/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
/*********************************************************************
 * RPC for the Windows NT Operating System
 * 1993 by Martin F. Gergeleit
 * Users may use, copy or modify Sun RPC for the Windows NT Operating 
 * System according to the Sun copyright below.
 *
 * RPC for the Windows NT Operating System COMES WITH ABSOLUTELY NO 
 * WARRANTY, NOR WILL I BE LIABLE FOR ANY DAMAGES INCURRED FROM THE 
 * USE OF. USE ENTIRELY AT YOUR OWN RISK!!!
 *********************************************************************/

/* @(#)svc.h	2.2 88/07/29 4.0 RPCSRC; from 1.20 88/02/08 SMI */
/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * svc.h, Server-side remote procedure call interface.
 *
 * Copyright (C) 1984, Sun Microsystems, Inc.
 */

#ifndef __SVC_HEADER__
#define __SVC_HEADER__

/*
 * This interface must manage two items concerning remote procedure calling:
 *
 * 1) An arbitrary number of transport connections upon which rpc requests
 * are received.  The two most notable transports are TCP and UDP;  they are
 * created and registered by routines in svc_tcp.c and svc_udp.c, respectively;
 * they in turn call xprt_register and xprt_unregister.
 *
 * 2) An arbitrary number of locally registered services.  Services are
 * described by the following four data: program number, version number,
 * "service dispatch" function, a transport handle, and a boolean that
 * indicates whether or not the exported program should be registered with a
 * local binder service;  if true the program's number and version and the
 * port number from the transport handle are registered with the binder.
 * These data are registered with the rpc svc system via svc_register.
 *
 * A service's dispatch function is called whenever an rpc request comes in
 * on a transport.  The request's program and version numbers must match
 * those of the registered service.  The dispatch function is passed two
 * parameters, struct svc_req * and SVCXPRT *, defined below.
 */

enum xprt_stat {
	XPRT_DIED,
	XPRT_MOREREQS,
	XPRT_IDLE,
	XPRT_INVALID
};

#ifndef WARLIB
/*
 * Server side transport handle
 */
struct xp_ops 
{
/* receive incomming requests */
	bool_t	(*xp_recv) __P (( struct SVCXPRT *, struct rpc_msg * ));
	/* get transport status */
	enum xprt_stat (*xp_stat) __P (( struct SVCXPRT * ));
	/* get arguments */
	bool_t (*xp_getargs)	__P ((struct SVCXPRT *, xdrproc_t, caddr_t ));
	/* send reply */
	bool_t (*xp_reply) __P (( struct SVCXPRT *, struct rpc_msg * ));
	/* free mem allocated for args */
	bool_t (*xp_freeargs)	__P (( struct SVCXPRT *, xdrproc_t, caddr_t ));
	/* destroy this struct */
	void (*xp_destroy)	__P (( struct SVCXPRT * ));
};


typedef struct SVCXPRT 
{
	int 				xp_sock;
	u_short 		xp_port;	 /* associated port number */
	struct xp_ops *xp_ops;
	int 							 xp_addrlen; /* length of remote address */
	struct sockaddr_in xp_raddr;	 /* remote address */
	struct opaque_auth xp_verf;  /* raw response verifier */
	caddr_t 				 xp_p1; 	 /* private */
	caddr_t 				 xp_p2; 	 /* private */
} SVCXPRT;




/*
 * Operations defined on an SVCXPRT handle
 *
 * SVCXPRT		*xprt;
 * struct rpc_msg	*msg;
 * xdrproc_t		 xargs;
 * LPSTR		 argsp;
 */
#if 0
#define SVC_RECV(xprt, msg)	xprt->svc_recv((msg))
#define SVC_STAT(xprt)	xprt->svc_stat()
#define SVC_GETARGS(xprt, xargs, argsp)	xprt->svc_getargs((xargs), (argsp))
#define SVC_REPLY(xprt, msg)	xprt->svc_reply((msg))
#define SVC_FREEARGS(xprt, xargs, argsp) xprt->svc_freeargs((xargs), (argsp))
#define SVC_DESTROY(xprt) xprt->xp_destroy()
#endif

#define SVC_RECV(xprt, msg)				\
	(*(xprt)->xp_ops->xp_recv)((xprt), (msg))
#define svc_recv(xprt, msg)				\
	(*(xprt)->xp_ops->xp_recv)((xprt), (msg))

#define SVC_STAT(xprt)					\
	(*(xprt)->xp_ops->xp_stat)(xprt)
#define svc_stat(xprt)					\
	(*(xprt)->xp_ops->xp_stat)(xprt)

#define SVC_GETARGS(xprt, xargs, argsp)			\
	(*(xprt)->xp_ops->xp_getargs)((xprt), (xargs), (argsp))
#define svc_getargs(xprt, xargs, argsp)			\
	(*(xprt)->xp_ops->xp_getargs)((xprt), (xargs), (argsp))

#define SVC_REPLY(xprt, msg)				\
	(*(xprt)->xp_ops->xp_reply) ((xprt), (msg))
#define svc_reply(xprt, msg)				\
	(*(xprt)->xp_ops->xp_reply) ((xprt), (msg))

#define SVC_FREEARGS(xprt, xargs, argsp)		\
	(*(xprt)->xp_ops->xp_freeargs)((xprt), (xargs), (argsp))
#define svc_freeargs(xprt, xargs, argsp)		\
	(*(xprt)->xp_ops->xp_freeargs)((xprt), (xargs), (argsp))

#define SVC_DESTROY(xprt)				\
	(*(xprt)->xp_ops->xp_destroy)(xprt)
#define svc_destroy(xprt)				\
	(*(xprt)->xp_ops->xp_destroy)(xprt)


#endif WARLIB

#ifdef WARLIB
typedef WarSVCSocket * PSVCXPRT;
#else
typedef struct SVCXPRT * PSVCXPRT;
#endif

/*
 *  Approved way of getting address of caller
 */
#define svc_getcaller(x) (&(x)->xp_raddr)


#define RQ_FLAG_LOOPBACK	 0x0001 /* The callsr is in the same thread */
/*
 * Service request
 */
struct svc_req {
	DWORD		rq_prog;	/* service program number */
	DWORD		rq_vers;	/* service protocol version */
	DWORD		rq_proc;	/* the desired procedure */
	struct opaque_auth rq_cred;	/* raw creds from the wire */
	LPSTR		rq_clntcred;	/* read only cooked cred */
#ifdef WARLIB
	WarSVCSocket	*rq_xprt;		/* associated transport */
	DWORD		rq_flags; /* special flags */
#else
	SVCXPRT	*rq_xprt;		/* associated transport */
#endif
};


/*
 * Service registration
 *
 * svc_register(xprt, prog, vers, dispatch, protocol)
 *	SVCXPRT *xprt;
 *	DWORD prog;
 *	DWORD vers;
 *	void (*dispatch)();
 *	int protocol;  /* like TCP or UDP, zero means do not register 
 */

struct svc_callout 
{
	struct svc_callout *sc_next;
	u_long		    sc_prog;
	u_long		    sc_vers;
#ifdef WARLIB
	void		    (*sc_dispatch)( struct svc_req*, WarSVCSocket  * );
#else
	void		    (*sc_dispatch)( struct svc_req*, SVCXPRT  * );
#endif
};

#ifndef WARLIB
extern bool_t svc_register __P ((SVCXPRT *__xpr, u_long __prog,
					u_long __vers, void (*dispatch), u_long __protocol));


/*
 * Service un-registration
 *
 * svc_unregister(prog, vers)
 *	DWORD prog;
 *	DWORD vers;
 */
extern void svc_unregister __P ((u_long __prog, u_long __vers));


/*
 * Transport registration.
 *
 * xprt_register(xprt)
 *	SVCXPRT *xprt;
 */
extern void	xprt_register __P ((SVCXPRT *__xprt));

/*
 * Transport un-register
 *
 * xprt_unregister(xprt)
 *	SVCXPRT *xprt;
 */
extern void	xprt_unregister __P ((SVCXPRT *__xprt));




/*
 * When the service routine is called, it must first check to see if it
 * knows about the procedure;  if not, it should call svcerr_noproc
 * and return.  If so, it should deserialize its arguments via 
 * SVC_GETARGS (defined above).  If the deserialization does not work,
 * svcerr_decode should be called followed by a return.  Successful
 * decoding of the arguments should be followed the execution of the
 * procedure's code and a call to svc_sendreply.
 *
 * Also, if the service refuses to execute the procedure due to too-
 * weak authentication parameters, svcerr_weakauth should be called.
 * Note: do not confuse access-control failure with weak authentication!
 *
 * NB: In pure implementations of rpc, the caller always waits for a reply
 * msg.  This message is sent when svc_sendreply is called.  
 * Therefore pure service implementations should always call
 * svc_sendreply even if the function logically returns void;  use
 * xdr.h - xdr_void for the xdr routine.  HOWEVER, tcp based rpc allows
 * for the abuse of pure rpc via batched calling or pipelining.  In the
 * case of a batched call, svc_sendreply should NOT be called since
 * this would send a return message, which is what batching tries to avoid.
 * It is the service/protocol writer's responsibility to know which calls are
 * batched and which are not.  Warning: responding to batch calls may
 * deadlock the caller and server processes!
 */

extern bool_t  svc_sendreply    __P ((SVCXPRT *__xprt, xdrproc_t __xdr_results,
                                     caddr_t __xdr_location));
extern void    svcerr_decode    __P ((SVCXPRT *__xprt));
extern void    svcerr_weakauth  __P ((SVCXPRT *__xprt));
extern void    svcerr_noproc    __P ((SVCXPRT *__xprt));
extern void    svcerr_progvers  __P ((SVCXPRT *__xprt, u_long __low_vers,
                                     u_long __high_vers));
extern void    svcerr_auth      __P ((SVCXPRT *__xprt, enum auth_stat __why));
extern void    svcerr_noprog    __P ((SVCXPRT *__xprt));
extern void    svcerr_systemerr __P ((SVCXPRT *__xprt));
     
/*
 * Lowest level dispatching -OR- who owns this process anyway.
 * Somebody has to wait for incoming requests and then call the correct
 * service routine.  The routine svc_run does infinite waiting; i.e.,
 * svc_run never returns.
 * Since another (co-existant) package may wish to selectively wait for
 * incoming calls or other events outside of the rpc architecture, the
 * routine svc_getreq is provided.  It must be passed readfds, the
 * "in-place" results of a select system call (see select, section 2).
 */

/*
 * Global keeper of rpc service descriptors in use
 * dynamic; must be inspected before each call to select 
 */

EXT fd_set svc_fdset;

/*
 * a small program implemented by the svc_rpc implementation itself;
 * also see clnt.h for protocol numbers.
 */
extern void    rpctest_service  __P (( void ));

extern void    svc_getreq       __P ((int __rdfds));
/* takes fdset instead of int */
extern void    svc_getreqset    __P ((fd_set *__readfds));
extern void    svc_run          __P ((void)); 	 /* never returns */


/*
 * These are the existing service side transport implementations
 */

/*
 * Memory based rpc for testing and timing.
 */
extern SVCXPRT *svcraw_create __P ((void));

/*
 * Udp based rpc.
 */
extern SVCXPRT *svcudp_create __P ((int __sock));
extern SVCXPRT *svcudp_bufcreate __P((int __sock, u_int sendsz,
		u_int __recvsz));

/*
 * Tcp based rpc.
 */
extern SVCXPRT *svctcp_create __P ((int __sock, u_int __sendsize,
		u_int __recvsize));

#endif // WARLIB
/*
 * Portmapper
 */

extern bool_t pmap_set(u_long, int, u_short);
extern bool_t pmap_unset(u_long, u_long);

/*
 * Socket to use on svcxxx_create call to get default socket
 */
#define	RPC_ANYSOCK	-1


#ifdef WARLIB
#define gen_svcerr_noproc(a) a->svcerr_noproc()
#define gen_svcerr_decode(a) a->svcerr_decode()
#define gen_svcerr_systemerr(a) a->svcerr_systemerr()
#else
#define gen_svcerr_noproc(a) svcerr_noproc(a)
#define gen_svcerr_decode(a) svcerr_decode(a)
#define gen_svcerr_systemerr(a) svcerr_systemerr(a)
#endif

#endif /* __SVC_HEADER__ */

