/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

#define ChkVer(a) {ar >> Ver; if (Ver > a) WarArchiveException::Throw(WarArchiveException::INVALID_VERSION);}

class WarArchive
{
public:
	WarArchive();
	~WarArchive();
	BOOL Create(LPCSTR Path, BOOL DoSave);
	HANDLE m_hFile;
	void SeekToStart();
	void SeekToEnd();

	void operator << (WarString& Val);
	void operator << (char Val);
	void operator << (short Val);
	void operator << (unsigned short Val);
	void operator << (unsigned int Val);
	void operator << (int Val);
	void operator << (DWORD Val);
	void operator << (QWORD Val);
	void operator << (QSWORD Val);
	void operator << (WarTimer Val);
	void operator << (WarTime Val);
	void operator << (float Val);
	void operator << (double Val);
	void operator << (in_addr Val);
	void operator << (LPCSTR Val);

	void operator >> (WarString& Val);
	void operator >> (char& Val);
	void operator >> (short& Val);
	void operator >> (unsigned short& Val);
	void operator >> (unsigned int& Val);
	void operator >> (int& Val);
	void operator >> (DWORD& Val);
	void operator >> (QWORD& Val);
	void operator >> (QSWORD& Val);
	void operator >> (WarTimer& Val);
	void operator >> (WarTime& Val);
	void operator >> (float& Val);
	void operator >> (double& Val);
	void operator >> (in_addr& Val);
	void operator >> (LPSTR *Val);
	void operator >> (long& Val);

	BOOL m_bIsSaving;
	static DWORD BytesWritten; // tmp var for macro
};

class WarArchiveException
{
public:
	enum ExcTypes
	{
		INVALID_VERSION,
		INVALID_FILE,
	};
	static void WarArchiveException::Throw(ExcTypes t, LPCSTR Msg = NULL);
	

	ExcTypes m_Type;
	WarString m_Message;
};

