/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* !!Copyright end */

#define LOG_DEFAULT_MASK  786302
#define LOG_ALWAYS_MASK 524352

enum // Log message typpes
{
	LOGF_DEBUG,
	LOGF_ERROR,
	LOGF_FILEACC,
	LOGF_INOUT,
	LOGF_SECURITY,
	LOGF_WARNINGS,
	LOGF_SYSTEM,
	LOGF_WINSOCK,
	LOGF_SNDFILE,
	LOGF_RCVFILE,
	LOGF_CREDIR,
	LOGF_DELDIR,
	LOGF_DELFILE,
	LOGF_LOGIN,
	LOGF_LOGOUT,
	LOGF_CREACC,
	LOGF_DELACC,
	LOGF_CHGACC,
	LOGF_CPS,
	LOGF_INFO,
	LOGF_INVALID,
};

#define LOG_ISSET(Mask, Flag) ((Mask >> Flag) & 1)
#define LOG_SET(Mask, Flag, Value)\
	{\
		Mask &= ~(1 << Flag);\
		Mask |= ((Value & 1) << Flag);\
	}

struct WarLogHistory : public WarLogHdr
{
	QSWORD m_SessionID;
	int m_BufLen;
	QSWORD m_SeqCnt;
};

class DBFuncHandler
{
public:
	DBFuncHandler(LPCSTR Name);
	~DBFuncHandler();

	LPCSTR m_Name;
};

class WarLog : public WarString
{
public:
	WarLog();
	~WarLog();
	void operator = (char ch) {WarString::operator = (ch);}
	void operator += (char ch) {WarString::operator += (ch);}
	void operator = (int val) {WarString::operator = (val);}
	void operator += (int val) {WarString::operator += (val);}
	void operator = (DWORD val) {WarString::operator = (val);}
	void operator += (DWORD val) {WarString::operator += (val);}
	void operator = (QWORD val) {WarString::operator = (val);}
	void operator += (QWORD val) {WarString::operator += (val);}
	void operator = (LPCSTR val) {WarString::operator = (val);}
	void operator += (LPCSTR val) {WarString::operator += (val);}
	void operator = (WarBuffer& val) {WarString::operator = (val);}
	void operator += (WarBuffer& val) {WarString::operator += (val);}

	void operator << (char ch) {*this += (ch);}
	void operator << (int val) {*this +=  (val);}
	void operator << (DWORD val) {*this += (val);}
	void operator << (QWORD val) {*this += (val);}
	void operator << (LPCSTR val) {*this += (val);}
	void operator << (WarBuffer& val) {*this += (val);}
	char operator [] (int Index) {return WarBuffer::operator [] (Index);}

	operator LPCSTR () {return buffer ? buffer : "";}
	
	void LogMsg(
		DWORD Type, 
		QWORD UserNo, 
		WarSocket *pSock, 
		int SystemErrno,
		int ProgramErrno,
		LPCSTR pModule,
		LPCSTR Format, ...);

	void LogMsgV(
		DWORD Type, 
		QWORD UserNo, 
		WarSocket *pSock, 
		int SystemErrno,
		int ProgramErrno,
		LPCSTR pModule,
		LPCSTR Format, va_list ap);

	void Printf(DWORD Type, LPCSTR Format, ...);

	enum LogModes
	{
		// Modes
		LM_STDOUT = 0,
		LM_STDERR,
		LM_FILE, // Netx argument; Filename
		LM_LOGDAEMON, // Next argument; domain, NULL for localhost
		LM_LOGWIN, // (WIN32 only) Next argument, HWND (edit window)
		LM_DISABLE,

		// Special flags
		LF_RELAX = 0x0001, // Supress name and type
	} m_Mode;

	BOOL SetMode(int Mode, ...);
	void SetRelaxMode(BOOL Enable);
	void Flush();

	// Some useful functions
	void Sysmsg(LPCSTR fmt, ...);
	void Sockerr(WarSocket *pSock, LPCSTR pModule, LPCSTR fmt, ...);
	void Sockerr(int SckError, WarSocket *pSock, LPCSTR pModule, LPCSTR fmt, ...);
	void Dbmsg(LPCSTR pModule, LPCSTR fmt, ...);
	#define DBFunc(a) DBFuncHandler DbFuncHVal(#a)


	void (*m_ExternPrc)(DWORD Type, 
		QWORD UserNo, 
		WarSocket *pSock, 
		int SystemErrno,
		LPCSTR SystemErrorText, 
		int ProgramErrno,	
		LPCSTR pModule, 
		LPCSTR Text, 
		int FmtIndex, 
		LPARAM lParam);
	LPARAM m_Extern_lParam;

	WarString (*m_GetUserInfo)(user User);

	WarCriticalSection m_Lock;
	DWORD m_Mask;
	int m_LogEventsHistoryCnt;
	WarLinkedList m_LogEventHistoryList;
	QSWORD m_CurrLogEventSeq;
private:
	DWORD m_Flags;
	FILE *m_fp; // Current file
	WarString m_FileName;
	WarString m_CurrentFileName;
	static char TypeChr[LOGF_INVALID+1];
#ifdef _WINDOWS
	HWND m_hWnd; // Logwindow
	DWORD m_NumWinLines;
	DWORD m_MaxWinLines;
#endif

#ifndef _WFD1
	BOOL CreateRPCClient(LPCSTR Host);
	void DestroyRPCClient();
	CLIENT *m_RPCclnt;
#endif
};

 