/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// WarLoginHandle.h

// General class that handles a logged in user
// in server applications.
// Maps communication trough the required 
// protocols with user and fsys daemons.

class WarLoginHandle;

class WarLoginHandleFC : public WarFileCallback
{
public:
	WarLoginHandleFC(WarLoginHandle *pLH);
	~WarLoginHandleFC();

	virtual void OnOpen(BOOL Success);
	virtual void OnRead(BOOL Success, DWORD BytesRead);
	virtual void OnWrite(BOOL Success, DWORD BytesWritten);
	virtual void OnScan(BOOL Success);
	virtual void OnStat(BOOL Success, WarFStat &St);

	WarLoginHandle *m_pLoginHandle;
};

class WarLoginHandle
{
public:
	WarLoginHandle(WarUserHandle *pUserHandle);
	~WarLoginHandle();
	WarUserHandle *GetUserHandle() {return m_phUser;}
	int GetLastError() {return m_Errno;}

	static WarLoginHandle *Login(WarUserHandle *pUserHandle, 
		user ServerNode, LPCSTR Name, LPCSTR Pwd, int& Err, 
		WarSocket& Sck);
	void Logout();
	BOOL ListFiles(LPCSTR URL, WarFileList *pFileList, LPCSTR Pattern, WarFileCallback *pCallback = NULL);
	BOOL OpenPath(LPCSTR LogicalPath, DWORD Flags, WarFileCallback *pCallback = NULL);
	BOOL OpenURL(LPCSTR URL, DWORD Flags, WarFileCallback *pCallback);
	BOOL ChDir(LPCSTR Path, WarFileCallback *pCallback = NULL);
	LPCSTR GetCWD() {return m_CWD;}
	BOOL ParsePath(LPCSTR Path, WarString& NewPath, 
		DWORD *pFlags = NULL, WarString *pFsysPath = NULL);
	BOOL DoListFiles(LPCSTR Pattern, WarFileCallback *pCallback = NULL);

	enum ErrorCodes
	{
		OK,
		CALLBACK_PENDING = MED_WAR_LOGIN_HANDLE,
		ILLEGAL_CHAR_IN_PATH,
		INVALID_PATH,
		ACCESS_DENIED,
		WDQ_FSYS_PATHS_FAILED, // See error code in user database handle
		USER_QUERY_PATH_FAILED, // See error code in user database handle
		MUST_HAVE_PATH,
	};

	WarUserHandle *m_phUser;
	WarFileList *m_pListFiles;
	WarSocket *m_pSck;
	QWORD m_LoginHandle; // Login handle with session mgr
	user m_User;
	int m_Errno;
	unsigned int m_bFlexibleSlash : 1;
	WarString m_CWD;
	WarString m_LoginName;
	WarString m_DirMessage;
	WarString m_EffectivePath;
	WarLoginHandleFC *m_pFC;
	WarFile *m_pFileTemplate;
	WarFile *m_pCurrentFile; 
};

 