/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */


class WarProgram
{
public:
	~WarProgram();

	virtual int Main(int argc, const char **argv);
	virtual int Usage(LPCSTR Tag);
	virtual void UsageOptions();
	void Create(LPCSTR AppName, LPCSTR LongName, LPCSTR Version, LPCSTR Copyright);
	virtual void Initialize();
	BOOL PreProcessArgs(int argc, const char **argv);
	BOOL RegisterService(BOOL bAutoStart = FALSE, 
		LPCSTR User = NULL, LPCSTR Passwd = NULL, 
		BOOL bKeysOnly = FALSE);
	BOOL UnregisterService();

#ifdef _WINDOWS
	virtual BOOL OpenProgramWindow();
	static DWORD WINAPI Main_Thread_Start( LPVOID lParam);
	static DWORD m_mainThreadID;
	enum // Windows messages
	{
		WM_SVRDONE = WM_USER + 1,
		WM_QUITPENDING,
	};
#endif

	LPCSTR m_Version;
	LPCSTR m_AppName;
	LPCSTR m_LongName;
	LPCSTR m_Copyright;
	LPCSTR m_ServiceName;
	static const char *m_argv[32];
	static int m_argc;

protected:
	static WarProgram *m_Me;
	static char OsName[64];

public:
	static WarProgram *GetProgram() {return m_Me;}
	static LPCSTR GetOsName();
};

int main(int argc, const char **argv); 