
/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

// Set to 0 to disable ODBC support
#define USE_SQL 1

// Set to 0 to load odbc32.dll manually
#define USE_SQL_LOADODBC 1

#ifndef __WAR_SQLQUERY_H
#define __WAR_SQLQUERY_H

#if USE_SQL

#include "SQL.H"
#include "SQLExt.H"

class WarSQLCol
{
public:
	WarSQLCol();
	~WarSQLCol();

	enum Types
	{
		sql_bool,
		sql_char,
		sql_short,		
		sql_int,
		sql_dword,
		sql_qword,
		sql_datetime,
		sql_user, // 
		sql_text,
		sql_float,
		sql_double,
		sql_invalid
	} m_Type;

	union
	{
		char m_Char;
		short int m_Short;
		int m_Int;
		DWORD m_dw;
		QWORD m_qw; // Qword, WarTime, user
		float m_Float;
		double m_Double;
		LPSTR m_Text;
	};

	SQLINTEGER m_StringLen; // Used for m_Text;
	void (*ConvertHook)(WarSQLCol& Col);

	WarSQLCol& operator = (WarSQLCol& Val);
	int GetLen();
};

class WarSQLRow
{
public:
	WarSQLRow();
	~WarSQLRow();
	
	WarPtrArray m_Cols; // WarSQLCol
};

class WarSQLView
{
public:
	WarSQLView();
	~WarSQLView();

	WarLinkedList m_Rows;
	int m_Cols;
	WarPtrArray m_ColDefs; // WarSQLCol
	WarPtrArray m_ColData; // WarSQLCol
	int *m_pColWidth;
};

class WarSQLQuery
{
public:
	WarSQLQuery();
	~WarSQLQuery();

	BOOL IsOpen() {return m_hODBCdbc != NULL;}
	BOOL Create(LPCSTR QDBCName, LPCSTR Name, LPCSTR Passwd);
	BOOL Open(SQLHENV hDB);
	BOOL Open(WarSQLQuery& DB);
	BOOL SQLQuery(LPCSTR Query);
	BOOL SQLQuery(LPCSTR Query, WarString& Result, int MaxRows = 0, BOOL bReadOnly = TRUE);
	BOOL SQLQuery(LPCSTR Query, WarSQLView& View, int MaxRows = 0, BOOL bReadOnly = TRUE);
	void (*SQLGetUserHook)(WarSQLCol& Col);

	void SQLLogError(LPCSTR Module, LPCSTR Msg, SQLSMALLINT HandleType, SQLHANDLE Handle);
	
	WarString m_ODBCName;
	SQLHENV m_hODBCenv;
	SQLHENV m_hODBCdbc;
	int m_LoginTimeout;
	int m_LoginRetries;
	BOOL m_bInherited;
	WarString m_ErrText;
	SQLCHAR m_SQLState[16];
	
};


#if USE_SQL_LOADODBC
#define SQLExecute __SQLExecute
#define SQLPrepare __SQLPrepare
#define SQLFreeHandle __SQLFreeHandle
#define SQLFetch __SQLFetch
#define SQLBindCol __SQLBindCol
#define SQLExecDirect __SQLExecDirect
#define SQLAllocHandle __SQLAllocHandle
#define SQLDisconnect __SQLDisconnect
#define SQLGetDiagRec __SQLGetDiagRec
#define SQLConnect __SQLConnect
#define SQLSetConnectAttr __SQLSetConnectAttr
#define SQLSetEnvAttr __SQLSetEnvAttr
#define SQLDescribeCol __SQLDescribeCol
#define SQLNumResultCols __SQLNumResultCols
#define SQLSetStmtAttr __SQLSetStmtAttr

#ifdef __cplusplus
extern "C" { 			/* Assume C declarations for C++   */
#endif  /* __cplusplus */

EXT SQLRETURN (SQL_API *__SQLExecute)(SQLHSTMT StatementHandle);
EXT SQLRETURN (SQL_API *__SQLPrepare)(SQLHSTMT StatementHandle, SQLCHAR *StatementText, SQLINTEGER TextLength);
EXT SQLRETURN (SQL_API *__SQLFreeHandle)(SQLSMALLINT HandleType, SQLHANDLE Handle);
EXT SQLRETURN (SQL_API *__SQLFetch)(SQLHSTMT StatementHandle);
EXT SQLRETURN (SQL_API *__SQLBindCol)(SQLHSTMT StatementHandle, SQLUSMALLINT ColumnNumber, SQLSMALLINT TargetType, SQLPOINTER TargetValue, SQLINTEGER BufferLength, SQLINTEGER *StrLen_or_Ind);
EXT SQLRETURN (SQL_API *__SQLExecDirect)(SQLHSTMT StatementHandle, SQLCHAR *StatementText, SQLINTEGER TextLength);
EXT SQLRETURN (SQL_API *__SQLAllocHandle)(SQLSMALLINT HandleType, SQLHANDLE InputHandle, SQLHANDLE *OutputHandle);
EXT SQLRETURN (SQL_API *__SQLDisconnect)(SQLHDBC ConnectionHandle);
EXT SQLRETURN (SQL_API *__SQLGetDiagRec)(SQLSMALLINT HandleType, SQLHANDLE Handle,SQLSMALLINT RecNumber, SQLCHAR *Sqlstate,SQLINTEGER *NativeError, SQLCHAR *MessageText,SQLSMALLINT BufferLength, SQLSMALLINT *TextLength);
EXT SQLRETURN (SQL_API *__SQLConnect)(SQLHDBC ConnectionHandle,SQLCHAR *ServerName, SQLSMALLINT NameLength1,SQLCHAR *UserName, SQLSMALLINT NameLength2,SQLCHAR *Authentication, SQLSMALLINT NameLength3);
EXT SQLRETURN (SQL_API *__SQLSetConnectAttr)(SQLHDBC ConnectionHandle,SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER StringLength);
EXT SQLRETURN (SQL_API *__SQLSetEnvAttr)(SQLHENV EnvironmentHandle,SQLINTEGER Attribute, SQLPOINTER Value,SQLINTEGER StringLength);
EXT SQLRETURN (SQL_API *__SQLDescribeCol)(SQLHSTMT StatementHandle,SQLUSMALLINT ColumnNumber, SQLCHAR *ColumnName,SQLSMALLINT BufferLength, SQLSMALLINT *NameLength,SQLSMALLINT *DataType, SQLUINTEGER *ColumnSize,SQLSMALLINT *DecimalDigits, SQLSMALLINT *Nullable);
EXT SQLRETURN (SQL_API *__SQLNumResultCols)(SQLHSTMT StatementHandle,SQLSMALLINT *ColumnCount);
EXT SQLRETURN (SQL_API *__SQLSetStmtAttr)(SQLHSTMT StatementHandle,SQLINTEGER Attribute, SQLPOINTER Value,SQLINTEGER StringLength);
BOOL WarInitODBC32Dll();

#ifdef __cplusplus
}                                    /* End of extern "C" { */
#endif  /* __cplusplus */
#endif // USE_SQL_LOADODBC

#endif // USE_SQL
#endif // __WAR_SQLQUERY_H
