/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
//{{NO_DEPENDENCIES}}

#ifndef __WARH
#define __WARH

#pragma warning(disable:4786)

#if defined (__GNUG__) || defined(__GNUC__)
#define GNUCPP
#define COMPILER "GNU C++"
#define COMPILER_VER __VERSION__
#elif defined (_MSC_VER)
#define MSVC
#define COMPILER "Microsoft Visual C++"
#if (_MSC_VER == 1100)
#define COMPILER_VER "5.0"
#elif (_MSC_VER == 1200)
#define COMPILER_VER "6.0"
#endif
#else
#error "Unknown compiler"
#endif

// Set CPU type
#ifndef _CPUTYPE
#define _CPUTYPE i386
#ifndef i386
#define i386
#endif
#endif

#include <list>

#pragma warning(disable:4786)
#pragma warning(disable:4291)
#pragma warning(disable:4049)

#if defined(_WIN32)
#if defined(LINUX)
#error UNIX and windows is two quite different systems!
#endif
#ifndef WIN32
#define WIN32
#endif
#endif

#if defined(LINUX)
#ifdef WIN32
#error UNIX and windows is two quite different systems!
#endif
#ifndef UNIX
#define UNIX
#endif
#endif

#ifdef WIN32
#define FSYS_SLASH  '\\'
#else
#define FSYS_SLASH  '/'
#endif

#ifdef WIN32
// Windows header files
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <errno.h>
#include <assert.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#else
// Unix/Linux header files
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <memory.h>
#include <errno.h>
#include <assert.h>
#include <time.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/ftp.h>
#include <arpa/inet.h>
#include <arpa/telnet.h>
#include <signal.h>
#include <setjmp.h>

#ifdef LINUX
#define __need_timeval 1
#include <timebits.h>
#endif

#endif // WIN32

#ifndef bool_t
#define bool_t int
#endif

#ifndef enum_t
#define enum_t int
#endif

#define TESTCODE 1

// base error codes
enum MasterErrorDef
{
	MED_WAR_FILE = 1000,
	MED_WAR_LOGIN_HANDLE = 1100,
	MED_WAR_PORTMAP = 1200,
	MED_WAR_RPC = 1300,
	MED_INVALID
};

#if defined(MSVC)
#ifndef FD_SETSIZE
#define FD_SETSIZE 512
#ifdef errno
#undef errno
#endif
#define errno GetLastError()
#endif
#if !defined(MFC) && defined(WARLIB)
//#include <windows.h>
#include <winsock2.h> // Includes windows.h
#define WINSOCK
#elif defined(_RPCLIB)
#include <windows.h>
#endif

typedef unsigned __int64 QWORD;
typedef __int64 QSWORD;
#ifdef MFC
//typedef QSWORD hyper;
#endif

/* bsd */
typedef unsigned char		u_char;
typedef unsigned short	u_short;
typedef unsigned int		u_int;
typedef unsigned long		u_long;

/* sysv */
typedef unsigned char		unchar;
typedef unsigned short	ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;

typedef LPSTR						caddr_t;
typedef DWORD						u_int32;
typedef int							uid_t;
typedef int							gid_t;
typedef void *					__ptr_t;

typedef short int				int16_t;
typedef unsigned short	u_int16_t;
typedef unsigned int		u_int32_t;
typedef int							int32_t;

typedef char						GCHAR; // Generic char, must handle unsigned transforms

#define __const const

#define geteuid() 0
#define getegid() 0
#define getuid() 0
inline getgroups(int num, int gids[]){for(int iIi = 0; iIi < num; iIi++) gids[iIi] = 0 ; return 0;}
#define setreuid(a,b)
#define bcopy(a,b,c) memcpy(b,a,c);
#define bzero(a,b) memset(a,0,b);

#define WAR_PACKED

#elif defined(UNIX) || defined(GNUCPP)

#define WINAPI

typedef int SOCKET;
typedef unsigned long DWORD;
typedef unsigned long long QWORD;
typedef unsigned short WORD;
typedef long long QSWORD;
typedef const char * LPCSTR;
typedef const void * LPCVOID;
typedef char * LPSTR;
typedef const void * LPVOID;
typedef hostent * LPHOSTENT;
typedef bool BOOL;
typedef unsigned char	GCHAR; // Generic char, must handle unsigned transforms
typedef void * HANDLE;
typedef QSWORD hyper;
typedef long LPARAM;

typedef struct sockaddr_in SOCKADDR_IN;
#define GetLastSocketError() errno
#define SetLastSocketError(err) (errno = err)
//#define ioctlsocket(a,b,c) 
#define SOCKET_ERROR -1
#define INVALID_SOCKET -1
#define closesocket(a) close(a)
typedef unsigned int DEF_SOCK_LEN_TYPE;
#define WAR_PACKED __attribute__ ((packed))

#define max(a,b) (a > b ? a : b)
#define min(a,b) (a < b ? a : b)
#else
#error "not handled"
#endif

#define MAX(a,b)	max(a,b)
#define MIN(a,b)	min(a,b)

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef ASSERT 
#define ASSERT assert
#endif

#ifndef _DEBUG
#undef ASSERT
#define ASSERT(a)
#endif

#if defined(EXT)
#include "../Lib/DebugNew.cpp"
#endif


#if 0
#ifdef _DEBUG
#ifndef DEBUG_NEW
#undef DEBUG_NEW
#endif
#define DEBUG_NEW new(THIS_FILE, __LINE__)
void* operator new(size_t nSize, LPCSTR lpszFileName, int nLine);
#endif // _DEBUG
#if defined(_DEBUG) && !defined(MFC)
void __mem_tag(void* ptr, LPCSTR File, int Line);
#else
#define __mem_tag(a,b,c)
#endif

#endif // 0
#ifdef DEBUG_NEW
#undef DEBUG_NEW
#endif
#define DEBUG_NEW new
#define __mem_tag(a,b,c)

#ifndef EXT
#define EXT extern
#endif

//#if defined(WIN32) && defined(WARLIB)
//#include "WarWinsockSupport.h"
//#endif

#ifdef WIN32
#define GetLastSocketError() WSAGetLastError()
#define SetLastSocketError(err) WSASetLastError(err)
typedef int DEF_SOCK_LEN_TYPE;
BOOL WINAPI MyHandler(DWORD dwEventType);
#endif

typedef QWORD FLEN;

#ifndef __P
#define __P(a) a
#endif

// Some pre-declarations
class WarProgram;
class WarSVCSocket;
class WarUserNode;
class WarUserData;
class WarUserDB;

#ifdef WARLIB
#include "WarCrypt.h" // Password encryption
#include "RPC/war_rpc.h"		// RPC stuff
#endif

#include "WarString.h"
#include "WarTime.h"
#include "WarParser.h"

#ifdef WARLIB
#include "waruser_prot.h"
#endif

#include "WarArchive.h"
#include "LinkedList.h"
#include "WarArgs.h"

#ifdef WARLIB
#include "WarSocket.h"
#include "WarTree.h"
#include "WarRPCSocket.h"
#include "warlogd_prot.h"
#include "WarLog.h"
#include "WarAuth.h"
#include "WarUserHandle.h"
#include "WarUserSupport.h"
#include "../portmap/portmap_prot.h"
#include "../portmap/WarPmapSvc.h"
#include "WarFile.h"
#endif

#ifdef WARLIB
EXT WarPortmap *pPortMapper;
#endif

#ifdef WARSVR
#include "WarProcess.h"
#include "WarUser.h"
#include "WarLoginHandle.h"
#endif

#ifdef WARUSERSVR
#include "WarSessionMgr.h"
#endif

#ifdef WIN32
#include "Nt/ServiceMgr.h"
#endif

#if defined(WIN32) && defined(WARSVR)
#include "Nt/WarService.h"
EXT WarNTService *pNTService;
#endif

EXT int DebugFlag;
EXT int VerboseFlag;

//#define DebugLabel(a) ::MessageBox(NULL, a, "DebugLabel", MB_OK)
#define DebugLabel(a)

#ifdef WARLIB
EXT LPCSTR myname;
EXT FILE *LogFp;
EXT WarLog Log;
#endif

#if defined(_WINDOWS) || defined(WIN32)
EXT LPVOID hMainWnd; // Program's main window
#endif

#ifdef _WINDOWS
EXT LPVOID hInstance, hPrevInstance;
EXT LPVOID hLogWnd; // Program's log window (edit window for now)

#include <windowsx.h>

// Zero out a structure. If fInitSize is TRUE, initialize the first int to
// the size of the structure. Many structures like WNDCLASSEX and STARTUPINFO
// require that their first member be set to the size of the structure itself.
#define chINITSTRUCT(structure, fInitSize)                           \
   (ZeroMemory(&(structure), sizeof(structure)),                     \
   fInitSize ? (*(int*) &(structure) = sizeof(structure)) : 0)

// The call to SetClassLong is for Windows NT 3.51 or less.  The WM_SETICON
// messages are for Windows NT 4.0 and Windows 95.
#define chSETDLGICONS(hwnd, idiLarge, idiSmall)                               \
   {                                                                          \
      OSVERSIONINFO VerInfo;                                                  \
      chINITSTRUCT(VerInfo, TRUE);                                            \
      GetVersionEx(&VerInfo);                                                 \
      if ((VerInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) &&                  \
          (VerInfo.dwMajorVersion <= 3 && VerInfo.dwMinorVersion <= 51)) {    \
         SetClassLong(hwnd, GCL_HICON, (LONG)                                 \
            LoadIcon(GetWindowInstance(hwnd), MAKEINTRESOURCE(idiLarge)));    \
      } else {                                                                \
         SendMessage(hwnd, WM_SETICON, TRUE,  (LPARAM)                        \
            LoadIcon(GetWindowInstance(hwnd), MAKEINTRESOURCE(idiLarge)));    \
         SendMessage(hwnd, WM_SETICON, FALSE, (LPARAM)                        \
            LoadIcon(GetWindowInstance(hwnd), MAKEINTRESOURCE(idiSmall)));    \
      }                                                                       \
   }

#endif // _WINDOWS

#ifndef __STDC__
#define __STDC__ 1 // Needed by ported RPC funcs
#endif

struct PrioritiesDef
{
	int m_Priority;
	LPCSTR m_Description;
};

// Extern PrioritiesDef Priorities[]
#define MaxPriorityIndex 4

#endif // __WARH

 