/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// LoginPermsCntr.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "LoginPermsCntr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LoginPermsCntr dialog


LoginPermsCntr::LoginPermsCntr(CWnd* pParent,
															 UserMgrDlg *pUserMgrDlg,
															 wdq_mode ReqMode,
															 int MinValue, 
															 int MaxValue,
															 LPCSTR LabelText)
	: CDialog(LoginPermsCntr::IDD, pParent)
{
	//{{AFX_DATA_INIT(LoginPermsCntr)
	m_Value = 0;
	m_Mode = 0;
	//}}AFX_DATA_INIT

	m_MinValue = MinValue;
	m_MaxValue = MaxValue;
	m_bIsInitialized = FALSE;
	m_pUserMgrDlg = pUserMgrDlg;
	m_ReqMode = ReqMode;
	m_LabelText = LabelText;
}


void LoginPermsCntr::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	if (!pDX->m_bSaveAndValidate)
	{
		if (!m_bIsInitialized)
		{
			// Pre-initialize controls
			DDX_Control(pDX, IDC_EFFECTIVE, m_ctlLevelIndicator);
			DDX_Control(pDX, IDC_SLIDER, m_ctlSlider);
			DDX_Control(pDX, IDC_VALUE, m_ctlValue);
		}

		XmitStateM();
		user_login_perms_result *pr;
		pr = (user_login_perms_result *)m_pUserMgrDlg->GetUH()->Query(
			m_pUserMgrDlg->GetCurrentUser(),
			WDQM_EFFECTIVE, m_ReqMode);
		if (pr)
		{
			char buf[32];
			char *p = "";
			switch(pr->m_Data.m_Mode)
			{
				case ULP_USETHIS:
					sprintf(p = buf, "%d", pr->m_Data.m_Data);
					break;
				case ULP_NOLIMIT:
					p = "No limit";
					break;
				default:
					p = "error";
			}
			m_ctlLevelIndicator.Define(pr->m_Level, p);
			m_ctlLevelIndicator.ShowWindow(SW_SHOW);
		}
		else
			m_ctlLevelIndicator.ShowWindow(SW_HIDE);

		pr = (user_login_perms_result *)m_pUserMgrDlg->GetUH()->Query(
			m_pUserMgrDlg->GetCurrentUser(),
			WDQM_ABSOLUTE, m_ReqMode);
		if (pr)
		{
			m_Value = pr->m_Data.m_Data;
			m_Mode = pr->m_Data.m_Mode;
			m_ctlSlider.SetPos(pr->m_Data.m_Data);
		}
		m_ctlValue.SetModify(FALSE);
	}

	//{{AFX_DATA_MAP(LoginPermsCntr)
	DDX_Control(pDX, IDC_EFFECTIVE, m_ctlLevelIndicator);
	DDX_Control(pDX, IDC_SLIDER, m_ctlSlider);
	DDX_Control(pDX, IDC_VALUE, m_ctlValue);
	DDX_Text(pDX, IDC_VALUE, m_Value);
	DDX_CBIndex(pDX, IDC_MODE, m_Mode);
	//}}AFX_DATA_MAP

	// Set slider position
	m_ctlSlider.SetPos(m_Value);
	m_bIsInitialized = TRUE;
}


BEGIN_MESSAGE_MAP(LoginPermsCntr, CDialog)
	//{{AFX_MSG_MAP(LoginPermsCntr)
	ON_CBN_SELCHANGE(IDC_MODE, OnSelchangeMode)
	ON_EN_KILLFOCUS(IDC_VALUE, OnKillfocusValue)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LoginPermsCntr message handlers

BOOL LoginPermsCntr::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_ctlSlider.SetTicFreq((m_MaxValue - m_MinValue)/10);
	m_ctlSlider.SetRange(m_MinValue, m_MaxValue);
	GetDlgItem(IDC_LABEL)->SetWindowText(m_LabelText);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void LoginPermsCntr::OnSelchangeMode() 
{
	if (!m_bIsInitialized)
		return;

	UpdateData();
	XmitStateM();
	m_pUserMgrDlg->GetUH()->SetLoginPerm(m_pUserMgrDlg->GetCurrentUser(),
		m_ReqMode, (long)m_Value, (user_login_perms_mode)m_Mode);
	UpdateData(FALSE);
}

void LoginPermsCntr::OnKillfocusValue() 
{
	if (!m_bIsInitialized)
		return;

	if (!m_ctlValue.GetModify())
		return;

	UpdateData();
	XmitStateM();
	m_Mode = ULP_USETHIS;
	m_pUserMgrDlg->GetUH()->SetLoginPerm(m_pUserMgrDlg->GetCurrentUser(),
		m_ReqMode, (long)m_Value, (user_login_perms_mode)m_Mode);
	UpdateData(FALSE);
}

void LoginPermsCntr::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar == (CScrollBar *)&m_ctlSlider)
		UpdateFromSlider(nSBCode);
	else
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void LoginPermsCntr::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar == (CScrollBar *)&m_ctlSlider)
		UpdateFromSlider(nSBCode);
	else
		CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void LoginPermsCntr::UpdateFromSlider(UINT nSBCode)
{
	if (!m_bIsInitialized)
		return;

	m_Value = m_ctlSlider.GetPos();
	char buf[32];
	m_ctlValue.SetWindowText(itoa(m_Value, buf, 10));

	if (nSBCode == TB_ENDTRACK)
	{
		XmitStateM();
		m_Mode = ULP_USETHIS;
		m_pUserMgrDlg->GetUH()->SetLoginPerm(m_pUserMgrDlg->GetCurrentUser(),
			m_ReqMode, (long)m_Value, (user_login_perms_mode)m_Mode);
		UpdateData(FALSE);
	}
}



void LoginPermsCntr::OnCancel() 
{
}

void LoginPermsCntr::OnOK()
{
}
 
