/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// NTNetworkBrowser.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "NTNetworkBrowser.h"
#include "NTNetwork.h"
#include "WarNTNewNTGroupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NTNetworkBrowser dialog


NTNetworkBrowser::NTNetworkBrowser(WarUserHandle *pUsrH, CWnd* pParent /*=NULL*/)
	: CDialog(NTNetworkBrowser::IDD, pParent)
{
	//{{AFX_DATA_INIT(NTNetworkBrowser)
	m_Method = 1;
	//}}AFX_DATA_INIT

	m_pUsrH = pUsrH;
}


void NTNetworkBrowser::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NTNetworkBrowser)
	DDX_Control(pDX, IDC_TOPIC, m_ctlLabel);
	DDX_Control(pDX, IDC_METHOD, m_ctlMethod);
	DDX_Control(pDX, IDC_TAB, m_ctlTab);
	DDX_Control(pDX, IDC_LINKAGE, m_ctlList);
	DDX_Control(pDX, IDC_NT_TREE, m_ctlTree);
	DDX_CBIndex(pDX, IDC_METHOD, m_Method);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NTNetworkBrowser, CDialog)
	//{{AFX_MSG_MAP(NTNetworkBrowser)
	ON_NOTIFY(TVN_SELCHANGED, IDC_NT_TREE, OnSelchangedNtTree)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_NT_TREE, OnItemexpandingNtTree)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LINKAGE, OnItemchangedLinkage)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_NOTIFY(TVN_DELETEITEM, IDC_NT_TREE, OnDeleteitemNtTree)
	ON_NOTIFY(LVN_DELETEITEM, IDC_LINKAGE, OnDeleteitemLinkage)
	ON_NOTIFY(NM_RCLICK, IDC_LINKAGE, OnRclickLinkage)
	ON_COMMAND(ID_POPUP_NEWGLOBALNTGROUP, OnPopupNewglobalntgroup)
	ON_COMMAND(ID_POPUP_NEWLOCALNTGROUP, OnPopupNewlocalntgroup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NTNetworkBrowser message handlers

BOOL NTNetworkBrowser::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Initialize the tree
	m_ctlTree.SetImageList(CWarDaemonManagerApp::m_pSmallImageList, TVSIL_NORMAL);
	AddDomains(NULL);

	// Initialize the tab
	TC_ITEM TabItem;
	int TabItems = 0;
	m_ctlTab.SetImageList(CWarDaemonManagerApp::m_pSmallImageList);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE;
	TabItem.pszText = "Groups";
	TabItem.iImage = ICON_GROUP;
	TabItem.cchTextMax = strlen(TabItem.pszText);
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	// Initialize the list
	m_ctlList.SetImageList(CWarDaemonManagerApp::m_pSmallImageList, LVSIL_SMALL);
	m_ctlList.InsertColumn(0, "Name", LVCFMT_LEFT, 100, 0);
	m_ctlList.InsertColumn(1, "Descr", LVCFMT_LEFT, 200, 1);

	m_ctlLabel.SetWindowText("Select NT group");
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void NTNetworkBrowser::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void NTNetworkBrowser::OnSelchangedNtTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	WarNTServerInfo *pNode = (WarNTServerInfo *)m_ctlTree.GetItemData(pNMTreeView->itemNew.hItem);

	AddGroups(pNode->GetNetName());
	
	*pResult = 0;
}

void NTNetworkBrowser::OnItemexpandingNtTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	WarNTServerInfo *pNode 
		= (WarNTServerInfo *)m_ctlTree.GetItemData(pNMTreeView->itemNew.hItem);

	if (pNode)
	{
		AddServers(NULL, pNode->GetNetName(), pNMTreeView->itemNew.hItem);
	}


	*pResult = 0;
}

void NTNetworkBrowser::OnItemchangedLinkage(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	if (pNMListView->uNewState & LVIS_SELECTED)
	{
		GetDlgItem(IDOK)->EnableWindow(TRUE);
		WarNTServerInfo *pSvr = (WarNTServerInfo *)m_ctlTree.GetItemData(
			m_ctlTree.GetSelectedItem());
		WarNTGroupInfo *pGrp = (WarNTGroupInfo *)m_ctlList.GetItemData(
			pNMListView->iItem);

		if (!pSvr || !pGrp)
			goto fail;

		m_Domain = pSvr->GetNetName();
		m_Group = pGrp->GetName();
		m_bLocalGroup = pGrp->IsGlobal() == FALSE;
	}
	else
	{
fail:
		m_Domain = "";
		m_Group = "";
		GetDlgItem(IDOK)->EnableWindow(FALSE);
	}

	*pResult = 0;
}

void NTNetworkBrowser::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	*pResult = 0;
}

void NTNetworkBrowser::AddDomains(LPCSTR Machine)
{
	CWaitCursor Cursor;
	WarLinkedList *pList = m_pUsrH->WarNTGetDomains(Machine);
	if (!pList)
		return;

	WarNTServerInfo *p;
	while(p = (WarNTServerInfo *)pList->GetAndDeleteFirst())
	{
		TV_INSERTSTRUCT TreeItem;
		TreeItem.hParent = NULL;
		TreeItem.hInsertAfter = TVI_SORT;
		TreeItem.item.mask = TVIF_CHILDREN | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT | TVIF_PARAM;
		TreeItem.item.pszText = (LPSTR)p->GetDisplayName();
		TreeItem.item.cchTextMax = strlen(TreeItem.item.pszText);
		TreeItem.item.iImage = ICON_NETDOMAIN;
		TreeItem.item.iSelectedImage = TreeItem.item.iImage;
		TreeItem.item.cChildren = 1;
		TreeItem.item.lParam = (LPARAM)p;
		m_ctlTree.InsertItem(&TreeItem);
	}

	if (pList)
		delete pList;
}

void NTNetworkBrowser::AddServers(LPCSTR Machine, LPCSTR Domain, HTREEITEM Father)
{
	CWaitCursor Cursor;
	WarLinkedList *pList = m_pUsrH->WarNTGetServers(Machine ? Machine : m_pUsrH->WarNTGetDC(NULL, Domain), Domain);

	HTREEITEM h;
	while(h = m_ctlTree.GetChildItem(Father))
		m_ctlTree.DeleteItem(h);

	WarNTServerInfo *p;
	while(p = (WarNTServerInfo *)pList->GetAndDeleteFirst())
	{
		int Icon = ICON_WORKSTATION;

		if (p->GetType() & SV_TYPE_DOMAIN_CTRL)
			Icon = ICON_DOMAINCONTROLLER;
		else if (p->GetType() & SV_TYPE_SERVER_NT)
			Icon = ICON_SERVER;

		TV_INSERTSTRUCT TreeItem;
		TreeItem.hParent = Father;
		TreeItem.hInsertAfter = TVI_SORT;
		TreeItem.item.mask = TVIF_CHILDREN | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT | TVIF_PARAM;
		TreeItem.item.pszText = (LPSTR)p->GetDisplayName();
		TreeItem.item.cchTextMax = strlen(TreeItem.item.pszText);
		TreeItem.item.iImage = Icon;
		TreeItem.item.iSelectedImage = TreeItem.item.iImage;
		TreeItem.item.cChildren = 0;
		TreeItem.item.lParam = (LPARAM)p;
		m_ctlTree.InsertItem(&TreeItem);
	}

	if (pList)
		delete pList;
}

void NTNetworkBrowser::AddGroups(LPCSTR Host)
{
	m_ctlList.DeleteAllItems();
	GetDlgItem(IDOK)->EnableWindow(FALSE);

	CWaitCursor Cursor;
	WarLinkedList *pList = m_pUsrH->WarNTGetGroups(Host);
	if (!pList)
		return;

	WarNTGroupInfo *p;
	while(p = (WarNTGroupInfo *)pList->GetAndDeleteFirst())
	{
		LV_ITEM item;
		item.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
		item.iItem = 0;
		item.iSubItem = 0;
		item.pszText = (LPSTR)p->GetName();
		item.cchTextMax = strlen(item.pszText);
		item.iImage = p->IsGlobal() ? ICON_NT_GLOBALUSER : ICON_NT_LOCALUSER;
		item.lParam = (LPARAM)p;
		int Index = m_ctlList.InsertItem(&item);
		
		if (Index >= 0)
		{
			m_ctlList.SetItem(Index, 1, LVIF_TEXT, p->GetComment(), 0, 0, 0, NULL);
		}
	}

	if (pList)
		delete pList;
}

void NTNetworkBrowser::OnDeleteitemNtTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	delete (WarNTServerInfo *)pNMTreeView->itemOld.lParam;

	*pResult = 0;
}


void NTNetworkBrowser::OnDeleteitemLinkage(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	if (pNMListView->iSubItem == 0)
		delete (WarNTGroupInfo *)m_ctlList.GetItemData(pNMListView->iItem);
	
	*pResult = 0;
}

void NTNetworkBrowser::OnRclickLinkage(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CMenu MenuT, *Menu;
	MenuT.LoadMenu(IDR_NT_NETMENU1); 
	Menu = MenuT.GetSubMenu(0);
	CPoint Pos;
	GetCursorPos(&Pos);
	Menu->TrackPopupMenu(TPM_RIGHTBUTTON | TPM_LEFTALIGN, Pos.x, Pos.y, this);
	Menu->DestroyMenu();

	*pResult = 0;
}

void NTNetworkBrowser::OnPopupNewglobalntgroup() 
{
	OnCreateNewGroup(TRUE);
}

void NTNetworkBrowser::OnPopupNewlocalntgroup() 
{	
	OnCreateNewGroup(FALSE);
}

void NTNetworkBrowser::OnCreateNewGroup(BOOL bMakeGlobal)
{
	WarNTNewNTGroupDlg Dlg;
	Dlg.m_MakeGlobal = bMakeGlobal;
	Dlg.m_Server = GetCurrentServer();
	if (Dlg.DoModal() == IDOK)
	{
		if (!m_pUsrH->WarNTAddGroup(Dlg.m_Server, Dlg.m_Name, Dlg.m_Comment, Dlg.m_MakeGlobal))
		{
			CString cBuf;
			cBuf.Format("Failed to create new group.\r\n Reason: %s", 
				(LPCSTR)GetLastErrorText(GetLastError()));
			AfxMessageBox(cBuf);
		}
	}
	AddGroups(Dlg.m_Server);
}

CString NTNetworkBrowser::GetCurrentServer()
{
	WarNTServerInfo *pSvr = (WarNTServerInfo *)m_ctlTree.GetItemData(
		m_ctlTree.GetSelectedItem());
	CString cBuf = "";

	if (pSvr)
		cBuf = pSvr->GetNetName();
	
	return cBuf;
}
 