/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// ParhPropertiesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "ParhPropertiesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ParhPropertiesDlg dialog


ParhPropertiesDlg::ParhPropertiesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ParhPropertiesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ParhPropertiesDlg)
	m_Fsys = _T("file");
	m_Path = _T("");
	m_Alias = _T("/");
	m_bMap = FALSE;
	//}}AFX_DATA_INIT
}


void ParhPropertiesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ParhPropertiesDlg)
	DDX_Control(pDX, IDC_INFO, m_ctlInfo);
	DDX_CBString(pDX, IDC_FSYS, m_Fsys);
	DDX_Text(pDX, IDC_PATH, m_Path);
	DDX_Text(pDX, IDC_ALIAS, m_Alias);
	DDX_Check(pDX, IDC_FREEZE, m_bMap);
	//}}AFX_DATA_MAP

	GetDlgItem(IDC_ALIAS)->EnableWindow(m_bMap);
}


BEGIN_MESSAGE_MAP(ParhPropertiesDlg, CDialog)
	//{{AFX_MSG_MAP(ParhPropertiesDlg)
	ON_BN_CLICKED(IDC_FREEZE, OnFreeze)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ParhPropertiesDlg message handlers

void ParhPropertiesDlg::OnFreeze() 
{
	UpdateData();
}

void ParhPropertiesDlg::OnOK() 
{
	UpdateData();

	if (m_bMap
		&& (m_Alias.IsEmpty() || (m_Alias[0] != '/')))
	{
		AfxMessageBox("The mount point is invalid. Mount points start with a slash '/'");
		return;
	}
	
	CDialog::OnOK();
}

BOOL ParhPropertiesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	WarString wPath = "", wTmp = m_Path;
	LPCSTR pp =  wTmp;
	while(*pp)
	{
		if ((pp[0] == ':') && (pp[1] == '/') && (pp[2] == '/'))
		{
			pp += 3;
			break;
		}
		wPath << *pp++;
	}

	m_Fsys = (LPCSTR)wPath;
	m_Path = pp;

	m_ctlInfo.SetWindowText("Note:\r\nThe best way to add paths is to drag the directories directly from Windows Explorer.");

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
 
