/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// UserDAccountStatus.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "UserDAccountStatus.h"
#include "PasswdSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UserDAccountStatus dialog


UserDAccountStatus::UserDAccountStatus(CWnd* pParent /*=NULL*/)
	: CDialog(UserDAccountStatus::IDD, pParent)
{
	//{{AFX_DATA_INIT(UserDAccountStatus)
	m_UserType = -1;
	m_PasswdMode = -1;
	m_bValidateEmail = FALSE;
	//}}AFX_DATA_INIT

	m_bIsInitialized = FALSE;
}


void UserDAccountStatus::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	if (m_bIsInitialized && !pDX->m_bSaveAndValidate)
	{
		UserMgrDlg *p = (UserMgrDlg *)GetParent();
		user User = p->GetCurrentUser();
		if (User == USER_INVALID)
			return;

		XmitStateP();

		user_attrs *pAttr = p->GetUserAttributes();
		generic_level_int *pGI;
			
		m_ctlAccessList.SetCurLevel(pAttr->m_Type);
		m_ctlAccessList.DeleteAllItems();
		
		LPCSTR txt = "";
		LPCSTR yesno = "";
		int Level = UT_ROOT;
		
		pGI = (generic_level_int *)p->GetUH()->Query(
			User, WDQM_ABSOLUTE, WDO_FTP_LOGIN_ACCESS);
		if (pGI)
		{
			switch(pGI->m_Data)
			{
				case ULA_ALLOW: txt = "allow"; break;
				case ULA_DENY: txt = "deny"; break;
				default: txt = "default"; break;
			}

			pGI = (generic_level_int *)p->GetUH()->Query(
				User, WDQM_EFFECTIVE, WDO_FTP_LOGIN_ACCESS);
			if (pGI)
			{
				Level = (int)pGI->m_Level;
				yesno = (pGI->m_Data == ULA_ALLOW) ? "yes" : "no";

				int Index = m_ctlAccessList.AddItem(
					Level, (LPVOID)WDO_FTP_LOGIN_ACCESS, "FTP login access", txt, yesno, NULL);

				m_ctlAccessList.SetIconOnCol(Index, 2, 
					(pGI->m_Data == ULA_ALLOW) ? ICON_BULLET_GREEN : ICON_BULLET_RED);

				if (pGI->m_Data == ULA_DENY)
				{
					// Set deny mark on icon
					m_ctlAccessList.SetOverlayImage(Index, IOVL_DENY);
				}
			}
		}

		pGI = (generic_level_int *)p->GetUH()->Query(
			User, WDQM_ABSOLUTE, WDO_USERDB_ADMIN_ACCESS);
		if (pGI)
		{
			switch(pGI->m_Data)
			{
				case ULA_ALLOW: txt = "allow"; break;
				case ULA_DENY: txt = "deny"; break;
				default: txt = "default"; break;
			}

			pGI = (generic_level_int *)p->GetUH()->Query(
				User, WDQM_EFFECTIVE, WDO_USERDB_ADMIN_ACCESS);
			if (pGI)
			{
				Level = (int)pGI->m_Level;
				yesno = (pGI->m_Data == ULA_ALLOW) ? "yes" : "no";

				int Index = m_ctlAccessList.AddItem(
					Level, (LPVOID)WDO_USERDB_ADMIN_ACCESS, "Server admin access", txt, yesno, NULL);
				
				m_ctlAccessList.SetIconOnCol(Index, 2, 
					(pGI->m_Data == ULA_ALLOW) ? ICON_BULLET_GREEN : ICON_BULLET_RED);

				if (pGI->m_Data == ULA_DENY)
				{
					// Set deny mark on icon
					m_ctlAccessList.SetOverlayImage(Index, IOVL_DENY);
				}
			}
		}

		// User type
		pGI = (generic_level_int *)p->GetUH()->Query(
			User, WDQM_ABSOLUTE, WDO_USER_PTYPE);
		if (pGI)
			m_UserType = pGI->m_Data;

		pGI = (generic_level_int *)p->GetUH()->Query(
			User, WDQM_EFFECTIVE, WDO_USER_PTYPE);
		if (pGI)
		{
			LPCSTR p= "";
			switch(pAttr->m_UserType)
			{
				case USERPT_ANONYMOUS:
					p = "anonymous";
					break;

				case USERPT_USER:
					p = "user";
					break;

				case USERPT_ADMIN:
					p = "admin";
					break;
			}
			m_ctlUserTypeLevel.Define(pGI->m_Level, p);
		}

		// Password
		m_bValidateEmail = FALSE;
		switch(pAttr->m_Pwd.m_PwdType)
		{
			case PWDT_NONE:
				m_PasswdMode = 2;
				break;
			case PWDT_SECURE_EMAIL:
				m_bValidateEmail = TRUE;
				// Fall trough
			case PWDT_EMAIL:
				m_PasswdMode = 1;
				break;
			case PWDT_NORMAL:
				m_PasswdMode = 0;
				break;
		}
		
	}

	//{{AFX_DATA_MAP(UserDAccountStatus)
	DDX_Control(pDX, IDC_ACCESSLIST, m_ctlAccessList);
	DDX_Control(pDX, IDC_USER_TYPE_ICON, m_ctlUserTypeLevel);
	DDX_Control(pDX, IDC_CHANGEPWD, m_ctlChangePwdButton);
	DDX_Control(pDX, IDC_VALIDATEPWD, m_ctlValidateEmail);
	DDX_CBIndex(pDX, IDC_COMBO1, m_UserType);
	DDX_Radio(pDX, IDC_PASSWD, m_PasswdMode);
	DDX_Check(pDX, IDC_VALIDATEPWD, m_bValidateEmail);
	//}}AFX_DATA_MAP

	if (m_bIsInitialized)
		UpdateEnabled();
}


BEGIN_MESSAGE_MAP(UserDAccountStatus, CDialog)
	//{{AFX_MSG_MAP(UserDAccountStatus)
	ON_BN_CLICKED(IDC_CHANGEPWD, OnChangepwd)
	ON_BN_CLICKED(IDC_RADIO5, OnPwdChange)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnUserTypeChange)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab)
	ON_BN_CLICKED(IDC_PASSWD, OnPwdChange)
	ON_BN_CLICKED(IDC_RADIO6, OnPwdChange)
	ON_BN_CLICKED(IDC_VALIDATEPWD, OnPwdChange)
	ON_NOTIFY(NM_DBLCLK, IDC_ACCESSLIST, OnDblclkAccesslist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UserDAccountStatus message handlers

void UserDAccountStatus::OnChangepwd() 
{
	PasswdSetDlg Dlg;

	if (Dlg.DoModal() == IDOK)
	{
		UserMgrDlg *p = (UserMgrDlg *)GetParent();
		XmitStateP();
		if (!p->GetUH()->SetPwd(p->GetCurrentUser(), Dlg.m_Pwd1))
		{
			AfxMessageBox("Failed to set password.");
			return;
		}
	}

	UpdateData(FALSE);
}

void UserDAccountStatus::OnPwdChange() 
{
	BOOL bOld = m_PasswdMode;
	BOOL bValOld = m_bValidateEmail;
	UpdateData();

	if ((m_PasswdMode == bOld)
		&& (bValOld == m_bValidateEmail))
		return;

	user_pwd_type Mode;

	switch(m_PasswdMode)
	{
		case 0:
			Mode = PWDT_NORMAL;
			break;
		case 1:
			Mode = m_bValidateEmail ? PWDT_SECURE_EMAIL : PWDT_EMAIL;
			break;
		case 2:
			Mode = PWDT_NONE;
			break;
	}

	UserMgrDlg *p = (UserMgrDlg *)GetParent();
	XmitStateP();
	if (!p->GetUH()->SetPwdMode(p->GetCurrentUser(), Mode))
	{
		if (!m_PasswdMode && (p->GetUH()->GetLastError() == USRERR_INVAL))
		{
			// Must have a password
			OnChangepwd();
			return;
		}
		else
		{
			if (p->GetUH()->GetLastError() == USRERR_ACCES)
				AfxMessageBox("Access denied.");
			else
				AfxMessageBox("Failed to change value.");
		}
	}
	UpdateEnabled();
	p->RefreshUserStat();
	UpdateData(FALSE);
}


void UserDAccountStatus::UpdateEnabled()
{
	user_attrs *pAttr = NULL;
	UserMgrDlg *p = (UserMgrDlg *)GetParent();
	pAttr = p->GetUserAttributes();

	if (!pAttr || (pAttr->m_Type < UT_USER))
	{
		// Disable password section
		GetDlgItem(IDC_PASSWD)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO5)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO6)->EnableWindow(FALSE);

		m_ctlValidateEmail.EnableWindow(FALSE);
		m_ctlChangePwdButton.EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_PASSWD)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO5)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO6)->EnableWindow(TRUE);
		m_ctlValidateEmail.EnableWindow(m_PasswdMode == 1);
		m_ctlChangePwdButton.EnableWindow(m_PasswdMode == 0);
	}
}

void UserDAccountStatus::OnUserTypeChange() 
{
	int Old = m_UserType;
	UpdateData();
	if (Old == m_UserType)
		return; 

	UserMgrDlg *p = (UserMgrDlg *)GetParent();
	XmitStateP();

	if (!p->GetUH()->SetPrivMode(p->GetCurrentUser(), (user_priv_type)m_UserType))
		p->PrintRPCError();

	p->RefreshUserStat();
	UpdateData(FALSE);

}


BOOL UserDAccountStatus::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Initialzie the access list
	m_ctlAccessList.m_MyName = "Access list";
	m_ctlAccessList.AddHdr("Access", LVCFMT_LEFT, 200);
	m_ctlAccessList.AddHdr("Value", LVCFMT_LEFT, 65);
	m_ctlAccessList.AddHdr("Allow", LVCFMT_LEFT, 60);
	m_ctlAccessList.EnableIconsOnCol(2);

	m_ctlAccessList.SetCurLevel(UT_ROOT);
	
	m_bIsInitialized = TRUE;
	UpdateData(FALSE);

		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void UserDAccountStatus::OnOK()
{
}

void UserDAccountStatus::OnCancel()
{
}


void UserDAccountStatus::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(FALSE);
	*pResult = 0;
}

void UserDAccountStatus::OnDblclkAccesslist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int Index = m_ctlAccessList.GetNextItem(-1, LVNI_SELECTED);
	if (Index < 0)
		return;

	UserMgrDlg *p = (UserMgrDlg *)GetParent();
	user User = p->GetCurrentUser();
	if (User == USER_INVALID)
		return;

	wdq_mode Mode = (wdq_mode)(DWORD)m_ctlAccessList.GetData(Index);

	XmitStateP();

	user_attrs *pAttr = p->GetUserAttributes();
	generic_level_int *pGI;

	pGI = (generic_level_int *)p->GetUH()->Query(
			User, WDQM_ABSOLUTE, Mode);
	if (!pGI)
		return;

	int Value = pGI->m_Data;
	if (++Value > 2)
		Value = 0;

	user_access_type aMode = UAT_FTP;
	switch(Mode)
	{
		case WDO_FTP_LOGIN_ACCESS:
			aMode = UAT_FTP;
			break;
		case WDO_USERDB_ADMIN_ACCESS:
			aMode = UAT_USERDB_ADMIN;
			break;
		default:
			return;
	}

	p->GetUH()->SetAccess(User, aMode, (user_login_access)Value);
	UpdateData(FALSE);

	*pResult = 0;
}
 
