/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// UserDGreeting.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "UserDGreeting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UserDGreeting dialog

IMPLEMENT_DYNCREATE(UserDGreeting, CDialog)

UserDGreeting::UserDGreeting(CWnd* pParent /*=NULL*/)
	: CDialog(UserDGreeting::IDD, pParent)
{
	//{{AFX_DATA_INIT(UserDGreeting)
	m_Message = _T("");
	m_bDeleteWhenDisplayed = FALSE;
	m_bUseDate = FALSE;
	//}}AFX_DATA_INIT

	m_sMessage = _T("");
	m_bIsInitialized = FALSE;
	m_pCal = NULL;
}


void UserDGreeting::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	if (!pDX->m_bSaveAndValidate && m_bIsInitialized)
		LoadData();

	//{{AFX_DATA_MAP(UserDGreeting)
	DDX_Control(pDX, IDC_EDIT2, m_ctlEffectiveMessage);
	DDX_Control(pDX, IDC_USEDATE, m_ctlUseDate);
	DDX_Control(pDX, IDC_TAB, m_ctlTab);
	DDX_Control(pDX, IDC_CHECK1, m_ctlDelete);
	DDX_Control(pDX, IDC_EDIT1, m_ctlEdit);
	DDX_Text(pDX, IDC_EDIT1, m_Message);
	DDV_MaxChars(pDX, m_Message, 2048);
	DDX_Check(pDX, IDC_CHECK1, m_bDeleteWhenDisplayed);
	DDX_Check(pDX, IDC_USEDATE, m_bUseDate);
	//}}AFX_DATA_MAP

	OnTab();

	if (m_bIsInitialized)
		SaveData();
}


BEGIN_MESSAGE_MAP(UserDGreeting, CDialog)
	//{{AFX_MSG_MAP(UserDGreeting)
	ON_BN_CLICKED(IDC_CHECK1, OnDelete)
	ON_EN_KILLFOCUS(IDC_EDIT1, OnKillfocusEdit)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_BN_CLICKED(IDC_USEDATE, OnUsedate)
	ON_WM_CTLCOLOR()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UserDGreeting message handlers

BOOL UserDGreeting::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set up the calendar control
	m_pCal = new CalendarCntr();
	CRect DlgRect;
	GetDlgItem(IDC_LABEL)->GetWindowRect(&DlgRect);
	ScreenToClient(DlgRect);
	m_pCal->Create(IDD_CALENDAR, this);
	m_pCal->MoveWindow(&DlgRect, FALSE);
	m_pCal->ShowWindow(SW_HIDE);

	// Initialzie the selection tab
	TC_ITEM TabItem;
	int TabItems = 0;

	TabItem.mask = TCIF_TEXT;
	TabItem.pszText = "Message";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT;
	TabItem.pszText = "Expiry properties";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT;
	TabItem.pszText = "Show effecive message";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	m_ctlTab.SetCurSel(0);
	OnTab();
	
	m_bIsInitialized = TRUE;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void UserDGreeting::OnDelete() 
{
	if (m_bIsInitialized)
	{
		m_bDoSave = TRUE;
		UpdateData();
		UpdateData(FALSE);
	}
}

void UserDGreeting::OnKillfocusEdit() 
{
	if (m_bIsInitialized)
	{
		UpdateData();
		UpdateData(FALSE);
	}
}


void UserDGreeting::OnOK()
{
}

void UserDGreeting::OnCancel()
{
}

void UserDGreeting::SaveData()
{
	if (m_bDoSave || m_sMessage != m_Message)
	{
		UserMgrDlg *p = (UserMgrDlg *)GetParent();
		XmitStateP();
		p->GetUH()->SetUserGreeting(p->GetCurrentUser(),
			m_Message,
			m_bDeleteWhenDisplayed,
			m_bUseDate ? (time_t)m_pCal->m_Date: 0);
	}

	m_bDoSave = FALSE;
}

void UserDGreeting::LoadData()
{
	UserMgrDlg *p = (UserMgrDlg *)GetParent();
	XmitStateP();

	user_greeting *pUG = (user_greeting *)p->GetUH()->Query(
		p->GetCurrentUser(), WDQM_ABSOLUTE, WDQ_GREETING);

	if (pUG)
	{
		m_Message = pUG->m_Message;
		m_bDeleteWhenDisplayed = pUG->m_bDelete;
		m_bUseDate = pUG->m_Expire.m_Time != 0;
		m_pCal->m_Date = pUG->m_Expire;

		m_pCal->EnableWindow(m_bUseDate);
		m_pCal->UpdateData(FALSE);

		if (m_ctlTab.GetCurSel() == 2)
		{
			pUG = (user_greeting *)p->GetUH()->Query(
				p->GetCurrentUser(), WDQM_EFFECTIVE, WDQ_GREETING);
			m_ctlEffectiveMessage.SetWindowText(pUG->m_Message);
		}
	}
}

void UserDGreeting::OnDate()
{
	if (m_bIsInitialized)
	{
		m_bDoSave = TRUE;
		UpdateData();
		UpdateData(FALSE);
	}
}

void UserDGreeting::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnTab();

	*pResult = 0;
}

void UserDGreeting::OnTab()
{
	if (!m_bIsInitialized)
		return;

	int Mode = m_ctlTab.GetCurSel();
	
	m_ctlEdit.ShowWindow(!Mode ? SW_SHOW : SW_HIDE);
	m_ctlDelete.ShowWindow((Mode == 1) ? SW_SHOW : SW_HIDE);
	m_pCal->ShowWindow((Mode == 1) ? SW_SHOW : SW_HIDE);
	m_ctlUseDate.ShowWindow((Mode == 1) ? SW_SHOW : SW_HIDE);
	m_ctlEffectiveMessage.ShowWindow((Mode == 2) ? SW_SHOW : SW_HIDE);
	if (Mode == 2)
	{
		UserMgrDlg *p = (UserMgrDlg *)GetParent();
		XmitStateP();
		user_greeting *pUG = (user_greeting *)p->GetUH()->Query(
			p->GetCurrentUser(), WDQM_EFFECTIVE, WDQ_GREETING);
		if (pUG)
			m_ctlEffectiveMessage.SetWindowText(pUG->m_Message);
	}
}

void UserDGreeting::OnUsedate() 
{
	if (m_bIsInitialized)
	{
		m_bDoSave = TRUE;
		UpdateData();
		UpdateData(FALSE);
	}
}

HBRUSH UserDGreeting::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if (pWnd == &m_ctlEffectiveMessage)
	{
		pDC->SetBkMode(TRANSPARENT);
		static CBrush *pMyBr;
		if (!pMyBr)
			pMyBr = new CBrush(GetSysColor(COLOR_INFOBK ));
		return *pMyBr;
	}
	
	return hbr;
}

void UserDGreeting::OnFinalRelease() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::OnFinalRelease();
}


void UserDGreeting::OnDestroy() 
{
	if (0/*m_bIsInitialized*/)
	{
		UpdateData();
		m_bIsInitialized = FALSE;
	}
	CDialog::OnDestroy();	
}
 
