/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// UserDStatTotals.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "UserDStatTotals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UserDStatTotals dialog


UserDStatTotals::UserDStatTotals(CWnd* pParent /*=NULL*/)
	: CDialog(UserDStatTotals::IDD, pParent)
{
	//{{AFX_DATA_INIT(UserDStatTotals)
	m_LoginCnt = 0;
	m_lfTcnt = 0;
	m_lfScnt = 0;
	m_ulFcnt = 0;
	m_ulAcnt = 0;
	m_dlFcnt = 0;
	m_dlAcnt = 0;
	m_ulBcnt = _T("");
	m_dlBcnt = _T("");
	//}}AFX_DATA_INIT
}


void UserDStatTotals::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	if (!pDX->m_bSaveAndValidate)
		LoadValues();

	//{{AFX_DATA_MAP(UserDStatTotals)
	DDX_Text(pDX, IDC_EDIT1A, m_LoginCnt);
	DDX_Text(pDX, IDC_EDIT1B, m_lfTcnt);
	DDX_Text(pDX, IDC_EDIT1C, m_lfScnt);
	DDX_Text(pDX, IDC_EDIT2A, m_ulFcnt);
	DDX_Text(pDX, IDC_EDIT2B, m_ulAcnt);
	DDX_Text(pDX, IDC_EDIT3A, m_dlFcnt);
	DDX_Text(pDX, IDC_EDIT3B, m_dlAcnt);
	DDX_Text(pDX, IDC_EDIT2C, m_ulBcnt);
	DDX_Text(pDX, IDC_EDIT3C, m_dlBcnt);
	//}}AFX_DATA_MAP

	if (pDX->m_bSaveAndValidate)
		SaveValues();
}


BEGIN_MESSAGE_MAP(UserDStatTotals, CDialog)
	//{{AFX_MSG_MAP(UserDStatTotals)
	ON_EN_KILLFOCUS(IDC_EDIT1A, OnKillfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT1A, OnSetfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT1B, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT1C, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT2A, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT2B, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT2C, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT3A, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT3B, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT3C, OnKillfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT1B, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT1C, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT2A, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT2B, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT2C, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT3A, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT3B, OnSetfocusEdit)
	ON_EN_SETFOCUS(IDC_EDIT3C, OnSetfocusEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UserDStatTotals message handlers

BOOL UserDStatTotals::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void UserDStatTotals::OnKillfocusEdit() 
{
	UpdateData();
	SaveValues();
	UpdateData(FALSE);
}

void UserDStatTotals::OnSetfocusEdit() 
{
	UpdateData(FALSE);
}

void UserDStatTotals::LoadValues()
{
	UserMgrDlg *p = (UserMgrDlg *)GetParent();

	XmitStateP();

	user_stat *pStat = (user_stat *)p->GetUH()->Query(
			p->GetCurrentUser(), WDQM_ABSOLUTE, WDQ_FTP_STAT);

	WarString wBuf;

	if (pStat)
	{
		m_LoginCnt = (DWORD)pStat->m_LoginCnt;
		m_lfTcnt = (DWORD)pStat->m_lfTcnt;
		m_lfScnt = (DWORD)pStat->m_lfScnt;
		m_ulFcnt = (DWORD)pStat->m_ulFcnt;
		m_ulAcnt = (DWORD)pStat->m_ulAcnt;
		wBuf.Format("%qd", pStat->m_ulBcnt);
		m_ulBcnt = (LPCSTR)wBuf;
		m_dlFcnt = (DWORD)pStat->m_dlFcnt;
		m_dlAcnt = (DWORD)pStat->m_dlAcnt;
		wBuf.Format("%qd", pStat->m_dlBcnt);
		m_dlBcnt = (LPCSTR)wBuf;
	}
}

void UserDStatTotals::SaveValues()
{
	static user_stat Stat;
	static int idMap[] = 
	{ IDC_EDIT1A, IDC_EDIT1B, IDC_EDIT1C, 
	IDC_EDIT2A, IDC_EDIT2B, IDC_EDIT2C, 
	IDC_EDIT3A, IDC_EDIT3B, IDC_EDIT3C, 0};

	static hyper *valMap[] = 
	{ 
		&Stat.m_LoginCnt, &Stat.m_lfTcnt, &Stat.m_lfScnt, 
		&Stat.m_ulFcnt, &Stat.m_ulAcnt, &Stat.m_ulBcnt,
		&Stat.m_dlFcnt, &Stat.m_dlAcnt, &Stat.m_dlBcnt
	};

	BOOL bDoUpdate = FALSE;

	for(int i = 0; i < 9; i++)
	{
		CEdit *pEdit = (CEdit *)GetDlgItem(idMap[i]);
		if (!pEdit)
			return; // Not initialized...
		
		if (pEdit->GetModify())
		{
			pEdit->SetModify(FALSE);
			bDoUpdate = TRUE;
			CString cBuf;
			pEdit->GetWindowText(cBuf);
			*valMap[i] = atoq(cBuf);
		}
		else
			*valMap[i] = -1; // Tag as unchanged
	}

	if (bDoUpdate)
	{
		UserMgrDlg *p = (UserMgrDlg *)GetParent();
		XmitStateP();
		p->GetUH()->SetStat(p->GetCurrentUser(),
			WDQ_FTP_STAT, USU_REPLACE, Stat);	
	}
}


 
