/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// UsersOnlineView.cpp : implementation file
//

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "UsersOnlineView.h"
#include "WarDaemonManagerDoc.h"
#include "ChildFrm.h"
#include "InfoView.h"
#include "SpyInfo.h"
#include "KickDlg.h"
#include "FileInfoWnd.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UsersOnlineView

IMPLEMENT_DYNCREATE(UsersOnlineView, CFormView)

UsersOnlineView::UsersOnlineView()
	: CFormView(UsersOnlineView::IDD)
{
	//{{AFX_DATA_INIT(UsersOnlineView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_Filter1h = filter1h_all;
	m_Filter1f = m_Filter1f_all;
	m_CurrentMode = ModeSessionList;
	m_pFileView = NULL;
}

UsersOnlineView::~UsersOnlineView()
{
	if (m_pFileView)
	{
		m_pFileView->SaveHdrs();
		delete m_pFileView;
	}
}

void UsersOnlineView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(UsersOnlineView)
	DDX_Control(pDX, IDC_COMBO2, m_ctlFilter2);
	DDX_Control(pDX, IDC_COMBO1, m_ctlFilter1);
	DDX_Control(pDX, IDC_TAB1, m_ctlTab);
	DDX_Control(pDX, IDC_USERLIST, m_ctlUserList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(UsersOnlineView, CFormView)
	//{{AFX_MSG_MAP(UsersOnlineView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_DBLCLK, IDC_USERLIST, OnDblclkUserlist)
	ON_NOTIFY(NM_RCLICK, IDC_USERLIST, OnRclickUserlist)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_USERLIST, OnItemchangedUserlist)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeFilter1)
	ON_COMMAND(ID_KICK, OnKick)
	ON_UPDATE_COMMAND_UI(ID_KICK, OnUpdateKick)
	ON_COMMAND(ID_ABORT, OnAbort)
	ON_UPDATE_COMMAND_UI(ID_ABORT, OnUpdateAbort)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeFilter2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UsersOnlineView diagnostics

#ifdef _DEBUG
void UsersOnlineView::AssertValid() const
{
	CFormView::AssertValid();
}

void UsersOnlineView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// UsersOnlineView message handlers

void UsersOnlineView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	RecalcLayout();
}

void UsersOnlineView::OnSelchangeFilter1() 
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	int i;

	switch(m_CurrentMode)
	{
		case ModeHost:
			m_Filter1h = (Filter1Host)m_ctlFilter1.GetCurSel();
			RefreshHostsOnlineList(NULL);
			break;
		case ModeFiles:
			m_Filter1f = (FilterFiles)m_ctlFilter1.GetCurSel();
			if (m_pFileView)
			{
				m_ctlFilter2.ResetContent();
				switch(m_Filter1f)
				{
					case m_Filter1f_all:
						m_ctlFilter2.ShowWindow(SW_HIDE);
						break;
					case m_Filter1f_Server:
						// Fill with server list
						for(i = 0; i < pDoc->m_DomainListLen; i++)
							m_ctlFilter2.AddString(pDoc->m_pDomainList[i]->m_NodeName);
						m_ctlFilter2.SetCurSel(0);
						m_ctlFilter2.ShowWindow(SW_SHOW);
						break;
				}
				OnSelchangeFilter2();
			}
			break;
	}
}

void UsersOnlineView::OnSelchangeFilter2() 
{
	if (!m_pFileView)
		return;

	switch(m_CurrentMode)
	{
		case ModeFiles:
			if (!m_pFileView)
				return;
			
			DoFileListSelection();
			m_pFileView->Refresh();
			break;
	}
}

void UsersOnlineView::DoFileListSelection()
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	int i;

	if (!m_pFileView)
		return;

	switch(m_Filter1f)
	{
		case m_Filter1f_all:
			m_pFileView->m_Req.m_Mode = frm_all;
			m_pFileView->m_Req.m_Req = 0;
			m_pFileView->m_Req.m_SvrType = (war_svr_type)0;
			break;
		case m_Filter1f_Server:
			i = m_ctlFilter2.GetCurSel();
			if ((i < 0) || (i > pDoc->m_DomainListLen))
				return;
			m_pFileView->m_Req.m_Mode = frm_server;
			m_pFileView->m_Req.m_Req = pDoc->m_pDomainList[i]->m_User;
			m_pFileView->m_Req.m_SvrType = pDoc->m_pDomainList[i]->m_Type;
			break;
	}
}

void UsersOnlineView::RecalcLayout()
{
	// Don't start recalculating before all child windows are
	// created...
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();

	if (m_pFileView)
	{
		delete m_pFileView;
		m_pFileView = NULL;
	}

	if (IsWindow(m_ctlUserList.m_hWnd)
		&& IsWindow(m_ctlTab.m_hWnd)
		&& IsWindow(m_ctlFilter1.m_hWnd))
	{
		CRect ClientRect, TabRect, ListRect, Filter1Rect, Filter2Rect;
		BOOL bDoFilter1 = FALSE;
		BOOL bDoFilter2 = FALSE;
		switch(m_CurrentMode)
		{
			case ModeHost:
				bDoFilter1 = TRUE;
				m_ctlFilter1.ResetContent();
				m_ctlFilter1.AddString("All");
				m_ctlFilter1.AddString("Active");
				m_ctlFilter1.AddString("Local");
				m_ctlFilter1.SetCurSel((int)m_Filter1h);
				break;
			case ModeFiles:
				{
					CRect FileListRect(1,1,10,10);
					sesmgr_file_info_req Req;
					memset(&Req, 0, sizeof(Req));
					m_pFileView = new FileInfoWnd(pDoc,Req);
					m_pFileView->Create(
						WS_CHILD | LVS_SHAREIMAGELISTS | LVS_REPORT,
						FileListRect, &m_ctlTab, 0);
					m_pFileView->Initialize();
				}
				bDoFilter1 = TRUE;
				bDoFilter2 = TRUE;
				m_ctlFilter1.ResetContent();
				m_ctlFilter1.AddString("All");
				m_ctlFilter1.AddString("Server");
				m_ctlFilter1.SetCurSel((int)m_Filter1f);
				break;
		}

		GetClientRect(&ClientRect);
		m_ctlTab.MoveWindow(&ClientRect, TRUE);

		m_ctlTab.GetWindowRect(TabRect);
		ScreenToClient(&TabRect);
		m_ctlUserList.GetWindowRect(ListRect);
		ScreenToClient(&ListRect);

		ListRect.bottom = max(197, (TabRect.bottom - 3));
		ListRect.right = max(97, (TabRect.right - 3));
		ListRect.left = 3;

		if (bDoFilter1)
		{
			m_ctlFilter1.GetWindowRect(Filter1Rect);
			ScreenToClient(&Filter1Rect);
			int Height = Filter1Rect.Height();
			int Width = Filter1Rect.Width();
			Filter1Rect.bottom = ListRect.bottom;
			Filter1Rect.top = ListRect.bottom - Height;
			Filter1Rect.left = 3;
			Filter1Rect.right = Filter1Rect.left + Width;
			ListRect.bottom -= (Height + 3);
			CRect NewTabRect = ClientRect;
			NewTabRect.bottom -= (Height + 3);
			m_ctlFilter1.MoveWindow(&Filter1Rect, TRUE);
			m_ctlFilter1.ShowWindow(SW_SHOW);

			if (bDoFilter2)
			{
				m_ctlFilter2.GetWindowRect(Filter2Rect);
				ScreenToClient(&Filter2Rect);
				Width = Filter2Rect.Width();
				Filter2Rect.bottom = Filter1Rect.bottom;
				Filter2Rect.top = Filter1Rect.top;
				Filter2Rect.left = Filter1Rect.right + 5;
				Filter2Rect.right = Filter2Rect.left + Width;
				m_ctlFilter2.MoveWindow(&Filter2Rect, TRUE);
				m_ctlFilter2.ShowWindow(SW_SHOW);
			}
		}
		else
			m_ctlFilter1.ShowWindow(SW_HIDE);

		// Always hide filter2.
		m_ctlFilter2.ShowWindow(SW_HIDE);

		if (m_pFileView)
		{
			m_pFileView->MoveWindow(&ListRect, TRUE);
			m_ctlUserList.ShowWindow(SW_HIDE);
			m_pFileView->ShowWindow(SW_SHOW);
		}
		else
		{
			m_ctlUserList.MoveWindow(&ListRect, TRUE);
			m_ctlUserList.ShowWindow(SW_SHOW);
		}
	}
}


void UsersOnlineView::OnDblclkUserlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void UsersOnlineView::OnRclickUserlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void UsersOnlineView::OnItemchangedUserlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	if ((m_CurrentMode == ModeSessionList)
		|| (m_CurrentMode == ModeSelectedSessions))
	{
		UserInfo *pInfo = (UserInfo *)m_ctlUserList.GetData(pNMListView->iItem);
		if (pInfo && 
			m_ctlUserList.GetItemState(pNMListView->iItem, LVIS_SELECTED) & LVIS_SELECTED)
		{
			GetInfoWnd()->AddSpyWin(pInfo, pDoc);
			pDoc->UpdateAllViews(this, UH_RECALC_SPYS, NULL);
		}
		else if (pInfo)
		{
			GetInfoWnd()->DeleteSpyWin(pInfo);
			pDoc->UpdateAllViews(this, UH_RECALC_SPYS, NULL);
		}
	}
	
	*pResult = 0;
}


void UsersOnlineView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	m_ctlUserList.m_MyName = "UsersOnlineList";

	TC_ITEM TabItem;
	int TabItems = 0;
	m_ctlTab.SetImageList(CWarDaemonManagerApp::m_pSmallImageList);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Sessions";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_FTPUSER;
	TabItem.lParam = ModeSessionList;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Servers";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_DOMAIN;
	TabItem.lParam = ModeServerList;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Users";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_USER;
	TabItem.lParam = ModeUserList;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Hosts";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_COMPUTE;
	TabItem.lParam = ModeHost;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Select";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_SEARCH;
	TabItem.lParam = ModeSelectedSessions;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Files";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_CLASS;
	TabItem.lParam = ModeSelectedSessions;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	TabItem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM;
	TabItem.pszText = "Log";
	TabItem.cchTextMax = strlen(TabItem.pszText);
	TabItem.iImage = ICON_NETDOMAIN;
	TabItem.lParam = ModeSelectedSessions;
	m_ctlTab.InsertItem(TabItems++, &TabItem);

	m_ctlTab.SetCurSel(0);
	OnTab();

	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	
	if (pDoc)
		pDoc->RefreshUserList();
}


BOOL UsersOnlineView::RefreshUser(UserUpdateHint *pHint)
{
	//CWaitCursor Cursor;
	// Get list of users from the server

	if ((m_CurrentMode != ModeSessionList)
		&& (m_CurrentMode != ModeSelectedSessions))
		return FALSE; // Call not relevant in this mode
	
	if (pHint)
	{
		BOOL bExist = FALSE;
		const UserInfo *p = pHint->m_pUserInfo;

		// See if the info already exist
		int Index = LookupUserIndex(p);
		if (Index >= 0)
			bExist = TRUE;

		const sesmgr_query_session_reply *pp = pHint->m_pRawInfo;
		ASSERT(pp != NULL);
		
		// Update screen content

#define C(a) (!bExist || (p->a != pp->a))

		if (!bExist)
		{
			// Not in list - create it.
			WarString wBuf;
			wBuf.Printf("%05qd", pp->m_SessionID);
			WarTime lt;
			lt = pp->m_TimeLoggedOn;
			Index = m_ctlUserList.AddItem(-1, 
				(LPVOID)p, 
				(LPCSTR)wBuf, 
				(LPCSTR)lt.FormatLT("%H:%M"),
				pp->m_Nickname,
				pp->m_DomainName,
				"Unknown",
				NULL);
		}

		ASSERT(p != NULL);

		if (C(m_State))
		{
			LPCSTR Msg = "unknown";
			switch(pp->m_State)
			{
				case PRELOGIN: Msg = "prelogin"; break;
				case GOTNAME: Msg = "login"; break;
				case PROCESS: Msg = "idle"; break;
				case HOLD: Msg = "hold"; break;
				case GETFILE: Msg = "upload"; break;
				case PUTFILE: Msg = "download"; break;
				case QUITTING: Msg = "quitting"; break;
			}
			m_ctlUserList.SetItemText(Index, 4, Msg);
		}

		// CPS
		if (C(m_CPS))
		{
			char buf[32];
			sprintf(buf, "%.2f", (float)((float)pp->m_CPS / (float)1024));
			m_ctlUserList.SetItemText(Index, 5, buf);
		}

		if (C(m_StateInfo) || C(m_State))
		{
			LPCSTR Msg = "";
			switch(pp->m_State)
			{
				case PRELOGIN: Msg = "login"; break;
				case GOTNAME: Msg = "login"; break;
				case PROCESS: Msg = pp->m_StateInfo; break;
				case HOLD: 
				case GETFILE: 
				case PUTFILE:
					Msg = strrchr(pp->m_CurrentFilePath, '/');
					if (!Msg || !*(++Msg))
						Msg = pp->m_CurrentFilePath;
					break;
					
				case QUITTING: Msg = "quitting"; break;
			}
			m_ctlUserList.SetItemText(Index, 6, Msg);
		}

		if (C(m_ProgressMeter))
		{
			m_ctlUserList.SetProgress(Index, 6, pp->m_ProgressMeter, 
				MyColor(COLOR_GreenProgressText), MyColor(COLOR_GreenProgress));
		}

		if (C(m_CopyProgressMeter))
		{
			m_ctlUserList.SetProgress(Index, 4, pp->m_CopyProgressMeter, 
				MyColor(COLOR_YellowProgressText), MyColor(COLOR_YellowProgress));
		}

		// Update idle time
		int Percent = (int)(float)((float)((float)pp->m_IdleTime 
			/	(float)(pp->m_IdleTimeLimit ? pp->m_IdleTimeLimit : 1 )) *100.0);

		if (!pp->m_CopyProgressMeter || (Percent >= 20))
		{
			m_ctlUserList.SetProgress(Index, 4, Percent, 
				MyColor(COLOR_RedProgressText), MyColor(COLOR_RedProgress));
		}
		
#undef C
	}

	return TRUE;
}

static LPCSTR TypeNames[] =
{
	"Debug",
	"ERROR",
	"File",
	"In/out",
	"Security",
	"WARNING",
	"System",
	"Net",
	"Send",
	"Recv",
	"Cre.dir",
	"Del.dir",
	"Del.File",
	"Login",
	"Logout",
	"New account",
	"Del.account",
	"Cng.account",
	"CPS",
	"Info",
	NULL
};

void UsersOnlineView::RefreshLogList(WarLinkedListItem *pItem)
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	//BOOL bDoSort = FALSE;
	
	if (pItem == (WarLinkedListItem *)0xffffffff)
	{
		if (m_ctlUserList.GetItemCount())
			return; // Nothing to do...
		pItem = NULL;
	}

	if (!pDoc
		|| (m_CurrentMode != ModeLog))
		return; // Call not relevant

	if (!pItem || !m_ctlUserList.GetItemCount())
	{
		m_ctlUserList.DeleteAllItems();
		pItem = pDoc->m_LogList.First();
	}
	
	for(; pItem; pItem = pDoc->m_LogList.Next(pItem))
	{
		sesmgr_log_event *p = (sesmgr_log_event *)pDoc->m_LogList.Ptr(pItem);

		LPCSTR TypeName = SafeStringIndex(TypeNames, p->m_Type, LOGF_INVALID);
		WarTime Time;
		Time = p->m_Time;
		WarString Cnt;
		Cnt << (QWORD)p->m_SessionID;

		m_ctlUserList.AddItem(-1, NULL, TypeName,
			p->m_SessionID ? (LPCSTR)Cnt : "", 
			p->m_SckName, 
			(LPCSTR)Time.FormatLT("%H:%M:%S"), 
			 p->m_ProgramName ? p->m_ProgramName : "", 
			 p->m_Text, NULL);
	}
}

void UsersOnlineView::RefreshHostsOnlineList(UserUpdateHint *pHint)
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	BOOL bDoSort = FALSE;

	if (!pDoc
		|| (m_CurrentMode != ModeHost))
		return; // Call not relevant

	// Go trough the users online list.
	// We have no help from the pHint - so we have to determnine the changes
	// and update only what we need to update to avoid too much flickering.


	WarLinkedListItem *pItem;
	for(pItem = pDoc->m_HostsOnlineList.First()
		; pItem
		; pItem = pDoc->m_HostsOnlineList.Next(pItem))
	{
		UserHostData *p = (UserHostData *)pDoc->m_HostsOnlineList.Ptr(pItem);

		// See if we have the data
		BOOL bHaveIt = FALSE;
		int Index = 0;
		for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
		{
			DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
			if(Ref == (DWORD)p->m_Addr.s_addr)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		// See if the data is filtered out
		BOOL bDontWant = FALSE;
		switch(m_Filter1h)
		{
			case filter1h_active:
				if (p->m_NumSessions == 0)
					bDontWant = TRUE;
				break;
			case filter1h_local:
				if (!p->m_bIsLocal)
					bDontWant = TRUE;
				break;
		}

		if (bDontWant)
		{
			if (bHaveIt)
			{
				m_ctlUserList.DeleteItem(Index);
			}
			continue;
		}

		// Prepere data
		WarString wCnt, wFlags, wIP, wOK;
		wCnt << p->m_NumSessions;

		wIP.Format("%I", p->m_Addr);

		if (p->m_Flags & SMF_IPHackerFlag)
			wFlags << "HACKER ";
		if (!p->m_NumSessions)
			wFlags << "[cached] ";
		if (p->m_Flags & SMF_LogoffPendingShutdown)
			wFlags << "Logoff ";
		if (p->m_bIsLocal)
			wFlags << "[local] ";

		if (!p->m_bReadyForLogin)
			wOK = "Pending DNS";
		else
		{
			if (p->m_Flags & SMF_IPHackerFlag)
				wOK = "deny";
			else
				wOK = "ok";
		}

		if (!bHaveIt)
		{
			m_ctlUserList.AddItem(-1, (LPVOID)(DWORD)p->m_Addr.s_addr,
				(LPCSTR)wIP, p->m_DomainName, (LPCSTR)wCnt, (LPCSTR)wOK, 
				(LPCSTR)wFlags, NULL);
			bDoSort = TRUE;
		}
		else
		{
			bDoSort |= m_ctlUserList.UpdateText(Index, 0, wIP);
			bDoSort |= m_ctlUserList.UpdateText(Index, 1, p->m_DomainName);
			bDoSort |= m_ctlUserList.UpdateText(Index, 2, wCnt);
			bDoSort |= m_ctlUserList.UpdateText(Index, 3, wOK);
			bDoSort |= m_ctlUserList.UpdateText(Index, 4, wFlags);
		}		
	}

	// Delete unreferenced items
	int Index = 0;
	for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
	{
		DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
		BOOL bHaveIt = FALSE;
		for(pItem = pDoc->m_HostsOnlineList.First()
			; pItem
			; pItem = pDoc->m_HostsOnlineList.Next(pItem))
		{
			UserHostData *p = (UserHostData *) pDoc->m_HostsOnlineList.Ptr(pItem);

			if(Ref == (DWORD)p->m_Addr.s_addr)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		if (!bHaveIt)
			m_ctlUserList.DeleteItem(Index);
	}

	if (bDoSort)
		m_ctlUserList.Sort();
}

void UsersOnlineView::RefreshUsersOnlineList(UserUpdateHint *pHint)
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();

	if (!pDoc
		|| (m_CurrentMode != ModeUserList))
		return; // Call not relevant

	// Go trough the users online list.
	// We have no help from the pHint - so we have to determnine the changes
	// and update only what we need to update to avoid too much flickering.


	WarLinkedListItem *pItem;
	for(pItem = pDoc->m_UserOnlineList.First()
		; pItem
		; pItem = pDoc->m_UserOnlineList.Next(pItem))
	{
		UserOnlineData *p = (UserOnlineData *)pDoc->m_UserOnlineList.Ptr(pItem);

		// See if we have the data
		BOOL bHaveIt = FALSE;
		int Index = 0;
		for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
		{
			DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
			if (Ref == p->m_CntID)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		// Prepere data
		WarString wCnt, wFlags;
		wCnt << p->m_Connections;

		if (!p->m_Connections)
			wFlags << "[cached] ";
		if (p->m_Flags & SMF_LogoffPendingShutdown)
			wFlags << "Logoff ";

		m_ctlUserList.SetCurLevel(UT_ROOT, FALSE);

		if (!bHaveIt)
		{
			m_ctlUserList.AddItem(p->m_DomainNodeType, (LPVOID)p->m_CntID,
				p->m_Domain, p->m_Name, p->m_FullName, p->m_SubclassInfo, 
				(LPCSTR)wCnt, (LPCSTR)wFlags, NULL);
		}
		else
		{
			m_ctlUserList.UpdateText(Index, 0, p->m_Domain);
			m_ctlUserList.UpdateText(Index, 1, p->m_Name);
			m_ctlUserList.UpdateText(Index, 2, p->m_FullName);
			m_ctlUserList.UpdateText(Index, 3, p->m_SubclassInfo);
			m_ctlUserList.UpdateText(Index, 4, wCnt);
			m_ctlUserList.UpdateText(Index, 5, wFlags);
		}		
	}

	// Delete unreferenced items
	int Index = 0;
	for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
	{
		DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
		BOOL bHaveIt = FALSE;
		for(pItem = pDoc->m_UserOnlineList.First()
			; pItem
			; pItem = pDoc->m_UserOnlineList.Next(pItem))
		{
			UserOnlineData *p = (UserOnlineData *) pDoc->m_UserOnlineList.Ptr(pItem);

			if (Ref == p->m_CntID)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		if (!bHaveIt)
			m_ctlUserList.DeleteItem(Index);
	}
}

void UsersOnlineView::RefreshServerList(UserUpdateHint *pHint)
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();

	if (!pDoc
		|| (m_CurrentMode != ModeServerList))
		return; // Call not relevant

	// Go trough the server list.
	// We have no help from the pHint - so we have to determnine the changes
	// and update only what we need to update to avoid too much flickering.

	// Index 0 is operators. We only want domains here..
	for(int i = 0; i < pDoc->m_DomainListLen; i++)
	{
		DomainData *p = pDoc->m_pDomainList[i];

		// Check if we have it..
		BOOL bHaveIt = FALSE;
		int Index = 0;
		for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
		{
			int DIndex = (int)m_ctlUserList.GetData(Index);
			if (DIndex == p->m_Index)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		WarString wNum, wIP, wState, wFlags, wKPS;

		// Get number online now..
		if (p->m_CPSdata.m_SessionReadings.m_SessionReadings_val)
			wNum.Format("%u", p->m_CPSdata.m_SessionReadings.m_SessionReadings_val
				[p->m_CPSdata.m_CurrentIndex]);

		float CPS = 0;
		if (p->m_CPSdata.m_CPSreadings.m_CPSreadings_val)
			CPS = (float)p->m_CPSdata.m_CPSreadings.m_CPSreadings_val
				[p->m_CPSdata.m_CurrentIndex];

		CPS = (float)(double)(((double)CPS * p->m_CPSdata.m_Resolution) / 1024);
		wKPS.Format("%.3f", CPS);
		wIP.Format("%I", p->m_Addr);
		wState = "ok";

		if (p->m_Flags & SMF_LogoffPendingShutdown)
			wFlags << "Shutdown ";
		if (p->m_Flags & SMF_IPchangeNotify)
			wFlags << "IPchange ";

		m_ctlUserList.SetCurLevel(UT_ROOT, FALSE);

		if (!bHaveIt)
		{
			// Add new
			m_ctlUserList.AddItem(p->m_NodeType, (LPVOID)p->m_Index,
				p->m_NodeName, p->m_Name, (LPCSTR)wIP, p->m_DomainName,
				(LPCSTR)wState, (LPCSTR)wNum, (LPCSTR)wKPS, (LPCSTR)wFlags, NULL);
		}
		else
		{
			// Update
			m_ctlUserList.UpdateText(Index, 0, p->m_NodeName);
			m_ctlUserList.UpdateText(Index, 1, p->m_Name);
			m_ctlUserList.UpdateText(Index, 2, wIP);
			m_ctlUserList.UpdateText(Index, 3, p->m_DomainName);
			m_ctlUserList.UpdateText(Index, 4, wState);
			m_ctlUserList.UpdateText(Index, 5, wNum);
			m_ctlUserList.UpdateText(Index, 6, wKPS);
			m_ctlUserList.UpdateText(Index, 7, wFlags);
		}
	}

	// Delete unreferenced items
	int Index = 0;
	for(Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
	{
		int DIndex = (int)m_ctlUserList.GetData(Index);
		BOOL bHaveIt = FALSE;
		for(int i = 0; i < pDoc->m_DomainListLen; i++)
		{
			DomainData *p = pDoc->m_pDomainList[i];
			if (DIndex == p->m_Index)
			{
				bHaveIt = TRUE;
				break;
			}
		}

		if (!bHaveIt)
			m_ctlUserList.DeleteItem(Index);
	}
}

InfoView *UsersOnlineView::GetInfoWnd()
{
	CSplitterWnd *p = (CSplitterWnd *)GetParent();
	if (p)
		return (InfoView *)p->GetPane(0,1);
	
	return NULL;
}

int UsersOnlineView::OnGlobalTimer(LPVOID lParam)
{
	UsersOnlineView *p = (UsersOnlineView *)lParam;
	p->OnMyTimer();
	return TRUE; // Don't delete the timer
}

void UsersOnlineView::OnMyTimer()
{
}


void UsersOnlineView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	ASSERT(IsWindow(m_hWnd));

	switch(lHint)
	{
		case UH_UPDATE_ALL:
			Invalidate();
			break;
		case UH_USER_REFRESHED:
		case UH_USER_ADDED:
			RefreshUser((UserUpdateHint *)pHint);
			break;
		case UH_USER_DELETED:
			if (pHint)
			{
				UserUpdateHint *p = (UserUpdateHint *)pHint;
				int Index = LookupUserIndex(p->m_pUserInfo);
				if (Index >= 0)
					m_ctlUserList.DeleteItem(Index);
			}
			break;
		case UH_DESTROY:
			// Clean up.
			if (m_pFileView)
			{
				m_pFileView->SaveHdrs();
				delete m_pFileView;
				m_pFileView = NULL;
			}
			m_ctlUserList.DeleteAllItems();
			break;
		case UH_DOMAINS_REFRESHED:
			RefreshServerList((UserUpdateHint *)pHint);
			break;
		case UH_USERSONLINE_REFRESHED:
			RefreshUsersOnlineList((UserUpdateHint *)pHint);
			break;
		case UH_HOSTSONLINE_REFRESHED:
			RefreshHostsOnlineList((UserUpdateHint *)pHint);
			break;
		case UH_LOG_UPDATED:
			RefreshLogList((WarLinkedListItem *)pHint);
			break;
		case UH_SYSSTAT_REFRESHED:
			if (m_pFileView)
			{
				DoFileListSelection();
				m_pFileView->Refresh();
			}
	}
}

int UsersOnlineView::LookupUserIndex(const UserInfo *pUser)
{
	if ((m_CurrentMode != ModeSessionList)
		&& (m_CurrentMode != ModeSelectedSessions))
		return -1; // Call not relevant in this mode

	for(int Index = 0; Index < m_ctlUserList.GetItemCount(); Index++)
	{
		UserInfo *p = (UserInfo *)m_ctlUserList.GetData(Index);
		if (p && (p->m_QID == pUser->m_QID))
			return Index;
	}

	return -1;
}


void UsersOnlineView::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	if (m_CurrentMode != (DisplayModeM)m_ctlTab.GetCurSel())
		OnTab();
	
	*pResult = 0;
}

void UsersOnlineView::OnTab()
{
	m_CurrentMode = (DisplayModeM)m_ctlTab.GetCurSel();
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	
	// Set up the user list
	m_ctlUserList.Reset();

	if (m_pFileView)
	{
		m_pFileView->SaveHdrs();
		delete m_pFileView;
		m_pFileView = NULL;
	}

	// Inform the info-view about the changes..
	InfoView *pInfo = GetInfoWnd(); 
	if (pInfo)
		pInfo->OnTabChange();

	switch(m_CurrentMode)
	{
		case ModeSelectedSessions:
		case ModeSessionList:
			m_ctlUserList.m_MyName = "UOL session list";
			m_ctlUserList.AddHdr("Cnt", LVCFMT_LEFT, 40, PathList::sort_num);
			m_ctlUserList.AddHdr("Login", LVCFMT_LEFT, 50);
			m_ctlUserList.AddHdr("ID", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Domain", LVCFMT_LEFT, 150);
			m_ctlUserList.AddHdr("State", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("Kb/sec", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("Info", LVCFMT_LEFT, 150);
	
			m_ctlUserList.EnableIconsOnCol(2);
			m_ctlUserList.EnableIconsOnCol(6);

			RecalcLayout();
			m_ctlUserList.m_CompareFunc = CompareFuncUsers;
			pDoc->RefreshUserList();
			break;
		case ModeServerList:
			m_ctlUserList.m_MyName = "UOL server list";
			m_ctlUserList.AddHdr("Shortname", LVCFMT_LEFT, 90);
			m_ctlUserList.AddHdr("Visual name", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("IP", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Domain name", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("State", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("Users", LVCFMT_RIGHT, 40, PathList::sort_num);
			m_ctlUserList.AddHdr("KPS", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("Info", LVCFMT_LEFT, 150);
			RecalcLayout();
			m_ctlUserList.m_CompareFunc = NULL;
			pDoc->RefreshDomainData();
			break;
		case ModeUserList:
			m_ctlUserList.m_MyName = "UOL user list";
			m_ctlUserList.AddHdr("Server", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Name", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Full name", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Subclass", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Connections", LVCFMT_RIGHT, 40, PathList::sort_num);
			m_ctlUserList.AddHdr("Info", LVCFMT_LEFT, 150);
			RecalcLayout();
			m_ctlUserList.m_CompareFunc = NULL;
			pDoc->RefreshUsersOnline();
			break;
		case ModeHost:
			m_ctlUserList.m_MyName = "UOL host list";
			m_ctlUserList.AddHdr("IP", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Domain", LVCFMT_LEFT, 150);
			m_ctlUserList.AddHdr("Connections", LVCFMT_RIGHT, 40, PathList::sort_num);
			m_ctlUserList.AddHdr("State", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("Info", LVCFMT_LEFT, 150);
			RecalcLayout();
			m_ctlUserList.m_CompareFunc = NULL;
			pDoc->RefreshHostsOnline();
			break;
		case ModeFiles:
			RecalcLayout();
			if (m_pFileView)
			{
				OnSelchangeFilter1();
				m_pFileView->Refresh();
			}
			break;
		case ModeLog:
			m_ctlUserList.m_MyName = "UOL loglines list";
			m_ctlUserList.AddHdr("Type", LVCFMT_LEFT, 40);
			m_ctlUserList.AddHdr("ID", LVCFMT_RIGHT, 40);
			m_ctlUserList.AddHdr("Connection", LVCFMT_LEFT, 40, PathList::sort_num);
			m_ctlUserList.AddHdr("Time", LVCFMT_LEFT, 50);
			m_ctlUserList.AddHdr("User", LVCFMT_LEFT, 100);
			m_ctlUserList.AddHdr("Message", LVCFMT_LEFT, 350);

			RecalcLayout();
			m_ctlUserList.m_CompareFunc = NULL;
			pDoc->RefreshLogList();
			break;
	}
}

int CALLBACK UsersOnlineView::CompareFuncUsers(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	ColData *p1 = (ColData *)lParam1;
	ColData *p2 = (ColData *)lParam2;
	PathList *p = (PathList *)lParamSort;
	
	UserInfo *pInfo1 = (UserInfo *)p1->m_Data;
	UserInfo *pInfo2 = (UserInfo *)p2->m_Data;

	int Rval = 0;

	switch(p->m_SortCol)
	{
		case 2: // User ID (name)
			Rval = stricmp(pInfo1->m_Nickname, pInfo2->m_Nickname);
			if (Rval != 0)
				break;
		case 1: // Login
			Rval = (int)((time_t)pInfo1->m_TimeLoggedOn - (time_t)pInfo2->m_TimeLoggedOn);
			if (Rval != 0)
				break;
		case 0: // Cnt
cntcmp:
			Rval = (int)(pInfo1->m_SessionID - pInfo2->m_SessionID);
			break;
		case 3: // Domain
			Rval = stricmp(pInfo1->m_DomainName, pInfo2->m_DomainName);
			if (Rval != 0)
				break;
			goto cntcmp;
		case 4: // State
			Rval = pInfo1->m_State - pInfo2->m_State;
			if (Rval != 0)
				break;
			goto cntcmp;
		case 5: // CPS
			Rval = (int)(pInfo1->m_CPS - pInfo2->m_CPS);
			if (Rval != 0)
				break;
			goto cntcmp;
		case 6: // Info
			Rval = stricmp(pInfo1->m_CWD, pInfo2->m_CWD);
			if (Rval != 0)
				break;
		default:
			goto cntcmp;
	}

	if (!p->m_SortAscending)
		Rval *= -1;

	return Rval;
}


void UsersOnlineView::OnKick() 
{
	DWORD Flags = SMF_LogoffPendingKick | SMF_ModeSetOnSessions; 
	LPCSTR pInfo = "";
	BOOL bDoIp = FALSE;
	BOOL bDoDisable = FALSE;
	BOOL bDoHacker = FALSE;

	switch(m_CurrentMode)
	{
		case ModeSelectedSessions:
		case ModeSessionList:
			if (m_ctlUserList.GetItemCount() > 1)
				pInfo = "This action will kick all the selected users off the system.";
			else
				pInfo = "This action will kick the user off the system.";
			bDoIp = bDoDisable = TRUE;
			break;
		case ModeServerList:
			pInfo = "This action will kick all user(s) on the selected server(s) off the system.";
			break;
		case ModeUserList:
			pInfo = "This action will kick all sessions from the selected user(s) off the system.";
			break;
		case ModeHost:
			pInfo = "This action will kick all user(s) from the selected host(s) off the system.";
			bDoIp = bDoHacker = TRUE;
			break;
		case ModeLog:
			return; // Not handled
	}

	KickDlg Dlg(bDoHacker, bDoIp, bDoDisable, pInfo, this);
	if (Dlg.DoModal() != IDOK)
		return;

	if (!Dlg.m_bDelay)
		Flags |= SMF_LogoffASAP;

	SetFlagOnSel(Flags, Dlg.m_bDisable, Dlg.m_IPoptions);
}

void UsersOnlineView::SetFlagOnSel(DWORD Flag, BOOL bDisable, int IPoptions)
{
	CWarDaemonManagerDoc *pDoc = (CWarDaemonManagerDoc *)GetDocument();
	if (!pDoc)
		return;

	try
	{
		int Index = -1;
		WarLinkedListItem *pItem;
		while((Index = m_ctlUserList.GetNextItem(Index, LVNI_SELECTED)) >= 0)
		{
			switch(m_CurrentMode)
			{
				case ModeSelectedSessions:
				case ModeSessionList:
					{
						WarString wIP;
						UserInfo *pInfo = (UserInfo *)m_ctlUserList.GetData(Index);						
						pDoc->m_pUserH->SesMgrSetFlag(
							Flag, Flag, SSFM_SESSION, pInfo->m_QID);
						if (bDisable)
						{
							// Disable the user account
							// We don't disable access to the user databasse here!
							pDoc->m_pUserH->SetAccess(pInfo->m_User, UAT_FTP, ULA_DENY);
							pDoc->m_pUserH->SetAccess(pInfo->m_User, UAT_FTP_ADMIN, ULA_DENY);
							pDoc->m_pUserH->SetAccess(pInfo->m_User, UAT_LOG_ADMIN, ULA_DENY);
							pDoc->m_pUserH->SetAccess(pInfo->m_User, UAT_VFSYS, ULA_DENY);
							pDoc->m_pUserH->SetAccess(pInfo->m_User, UAT_VFSYS_ADMIN, ULA_DENY);
						}
						switch(IPoptions)
						{
							case KickDlg::hacker:
								pDoc->m_pUserH->SesMgrSetFlag(
									SMF_IPHackerFlag, SMF_IPHackerFlag, SSFM_SESSION, pInfo->m_QID);
								break;
							case KickDlg::denyhost:
								wIP = pInfo->m_DomainName;
								goto do_denyip;
							case KickDlg::denyip:
								wIP.Format("%I", pInfo->m_UserHost);
do_denyip:
								if (pInfo->m_UserHost.s_addr == htonl(INADDR_LOOPBACK))
									break; // We don't disable localhost!

								// Get current list
								ip_access_list *pp = (ip_access_list *)
									pDoc->m_pUserH->Query(USER_SYSTEM, WDQM_ABSOLUTE, WDQ_IP_ACCESS_LIST);
								if (pp)
								{
									// See if the IP is present
									BOOL bHaveIt = FALSE;
									WarString wBuf = pp->m_Data.m_DenyList;
									if (!wBuf.IsEmpty())
										for(char *ppp = strtok(wBuf.GetBuffer(1), "\r\n"); ppp; ppp = strtok(NULL, "\r\n"))
									{
										if (wIP == ppp)
										{
											bHaveIt = TRUE;
											break;
										}
									}

									if (!bHaveIt)
									{
										// Add it
										wBuf = pp->m_Data.m_DenyList;
										if (!wBuf.IsEmpty())
											wBuf << "\r\n";
										wBuf << wIP;

										ip_restrictions_mode Mode = pp->m_Data.m_Mode;
										if (Mode == IR_DISABLE)
											Mode = IR_THIS;
										pDoc->m_pUserH->SetIPAccessList(USER_SYSTEM, 
											Mode, "", wBuf, TRUE, FALSE, TRUE, NULL);
									}
								}
								break;
								
						}
					}
					break;
				case ModeServerList:
					{
						int DIndex = (int)m_ctlUserList.GetData(Index);
						for(int i = 0; i < pDoc->m_DomainListLen; i++)
						{
							DomainData *p = pDoc->m_pDomainList[i];
							if (DIndex == p->m_Index)
							{
								pDoc->m_pUserH->SesMgrSetFlag(
									Flag, Flag, SSFM_SERVER, p->m_User);
								break;
							}
						}
					}
					break;
				case ModeUserList:
					{
						DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
						for(pItem = pDoc->m_UserOnlineList.First()
							; pItem
							; pItem = pDoc->m_UserOnlineList.Next(pItem))
						{
							UserOnlineData *p = (UserOnlineData *) pDoc->m_UserOnlineList.Ptr(pItem);

							if (Ref == p->m_CntID)
							{
								pDoc->m_pUserH->SesMgrSetFlag(
									Flag, Flag, SSFM_USER, p->m_User);
								break;
							}
						}						
					}
					break;
				case ModeHost:
					{
						DWORD Ref = (DWORD)m_ctlUserList.GetData(Index);
						for(pItem = pDoc->m_HostsOnlineList.First()
							; pItem
							; pItem = pDoc->m_HostsOnlineList.Next(pItem))
						{
							UserHostData *p = (UserHostData *) pDoc->m_HostsOnlineList.Ptr(pItem);

							if(Ref == (DWORD)p->m_Addr.s_addr)
							{
								pDoc->m_pUserH->SesMgrSetFlag(
									Flag, Flag, SSFM_ADDR, p->m_Addr);
								if (IPoptions == (int)KickDlg::hacker)
									pDoc->m_pUserH->SesMgrSetFlag(
										SMF_IPHackerFlag, SMF_IPHackerFlag, SSFM_ADDR, p->m_Addr);
								break;
							}
						}				
					}
					break;
				default:
					return; // Not handled
			}
		}
	}
	catch(CWarDaemonManagerDoc *e)
	{
		e->BrutalDisconnect();
		return;
	}
}

void UsersOnlineView::OnUpdateKick(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_ctlUserList.GetSelectedCount() > 0);
}

void UsersOnlineView::OnAbort() 
{
	LPCSTR pInfo = "";

	switch(m_CurrentMode)
	{
		case ModeSelectedSessions:
		case ModeSessionList:
			if (m_ctlUserList.GetSelectedCount() > 1)
				pInfo = "This action will abort all current transfers to/from the selected users.";
			else
				pInfo = "This action will abort the users current transfer.";
			break;
		case ModeServerList:
		case ModeUserList:
		case ModeHost:
			pInfo = "This action will abort all current transfers to/from the affected users.";
			break;
		default:
			return; // Not handled
	}	

	if (AfxMessageBox(pInfo, MB_OKCANCEL) == IDOK)
		SetFlagOnSel(SMF_AbortTransfer | SMF_ModeSetOnSessions, FALSE, 0);	
}

void UsersOnlineView::OnUpdateAbort(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_ctlUserList.GetSelectedCount() > 0);
}


 