/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
// WarDaemonManager.cpp : Defines the class behaviors for the application.
//

#define EXT

#include "stdafx.h"
#include "WarDaemonManager.h"
#include "WarWin32Support.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "WarDaemonManagerDoc.h"
#include "UsersOnlineView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CWarDaemonManagerApp

BEGIN_MESSAGE_MAP(CWarDaemonManagerApp, CWinApp)
	//{{AFX_MSG_MAP(CWarDaemonManagerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWarDaemonManagerApp construction

CImageList *CWarDaemonManagerApp::m_pSmallImageList;
CImageList *CWarDaemonManagerApp::m_pLargeImageList;
HCURSOR CWarDaemonManagerApp::m_hcNodrop;
HCURSOR CWarDaemonManagerApp::m_hcCopy;
HCURSOR CWarDaemonManagerApp::m_hcMove;
HCURSOR CWarDaemonManagerApp::m_hcMultiMove;


CWarDaemonManagerApp::CWarDaemonManagerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWarDaemonManagerApp object

CWarDaemonManagerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWarDaemonManagerApp initialization

BOOL CWarDaemonManagerApp::InitInstance()
{
	if (!WarInitWinsockDll())
	{
		AfxMessageBox("Failed to load winsock dll.");
		return FALSE;
	}
	
// We don't use MFC sockets...
//	if (!AfxSocketInit())
	if (!WarSocket::Initialize())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Jgaa"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Initialize colors and fonts
	ColorAndFontDlg::LoadColor();
	InitializeIcons();

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_DAEMONTYPE,
		RUNTIME_CLASS(CWarDaemonManagerDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(UsersOnlineView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Here we do our own command line processing.
	// To hell with the MFC shit command line parsing :-)
	{
		LPCSTR p = AfxGetApp()->m_lpCmdLine;
		if (strstr(p, "-install"))
		{
			// Register shell variables.
			UnregisterShellFileTypes();
			RegisterShellFileTypes(TRUE);
			return FALSE;
		}

		if (strstr(p, "-uninstall"))
		{
			UnregisterShellFileTypes();
			return FALSE;
		}
	}

	// Enable drag/drop open
	//m_pMainWnd->DragAcceptFiles();
	hMainWnd = m_pMainWnd->m_hWnd;

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_Info;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnHomepage();
	afx_msg void OnBugreports();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

	m_Info = "War FTP Daemon 1.70\r\nCopyright 1996 - 1998 by Jarle (jgaa) Aase";
	m_Info += "\r\nWar-FTPd.exe version: ";
	m_Info += QueryFileInfo("war-ftpd.exe");
	m_Info += "\r\nWDM.exe version: ";
	m_Info += QueryFileInfo("wdm.exe");
	m_Info += "\r\nWarTrayIcon.exe version: ";
	m_Info += QueryFileInfo("WarTrayIcon.exe");
	m_Info += "\r\nMsvcrt40.dll version: ";
	m_Info += QueryFileInfo("Msvcrt40.dll");
	m_Info += "\r\nCtl3d32.dll: ";
	m_Info += QueryFileInfo("Ctl3d32.dll");
	m_Info += "\r\nMsvcrt.dll: ";
	m_Info += QueryFileInfo("Msvcrt.dll");
	m_Info += "\r\nOlepro32.dll: ";
	m_Info += QueryFileInfo("Olepro32.dll");
	m_Info += "\r\nMsvcirt.dll: ";
	m_Info += QueryFileInfo("Msvcirt.dll");
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_EDIT1, m_Info);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_HOMEPAGE, OnHomepage)
	ON_BN_CLICKED(IDC_BUGREPORTS, OnBugreports)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CWarDaemonManagerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CAboutDlg::OnHomepage() 
{
	ShellExecute(NULL, "open", "http://www.jgaa.com/warftpd.htm", 
		NULL, NULL, SW_SHOWNORMAL);
}

void CAboutDlg::OnBugreports() 
{
	ShellExecute(NULL, "open", "http://war.jgaa.com:8080/support/", 
		NULL, NULL, SW_SHOWNORMAL);
}


/////////////////////////////////////////////////////////////////////////////
// CWarDaemonManagerApp commands


BOOL CWarDaemonManagerApp::InitializeIcons()
{
	m_pSmallImageList = new CImageList();
	CBitmap	bm;

	m_pSmallImageList->Create(15,13,TRUE,ICON_INVALID,ICON_INVALID);
	bm.LoadBitmap(IDB_DOMAIN_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_CLASS_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_GROUP_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_USER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_ALIAS_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_ADMIN_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_JGAACOM_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_ROOT_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_COMPUTE_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_FTP_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_FTP_USER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_REMADMIN_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_SEARCH);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_ALL_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_NETDOMAIN_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_WORKSTATION_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_SERVER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_DOMAINCONTROLLER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_NT_GLOBALUSER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_NT_LOCALUSER_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_BOUND_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_BULLET_RED_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_BULLET_GREEN_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();

	bm.LoadBitmap(IDB_CDUNIT_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();
	bm.LoadBitmap(IDB_CD_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();

	bm.LoadBitmap(IDB_DENY_S);	m_pSmallImageList->Add(&bm, RGB(128,128,0));	bm.DeleteObject();

	// Set default overlays
	m_pSmallImageList->SetOverlayImage(ICON_DENY, IOVL_DENY);

	// Load cursors
	m_hcNodrop = LoadCursor(IDC_NODROP);
	m_hcCopy = LoadCursor(IDC_POINTER_COPY);
	m_hcMove = LoadCursor(IDC_POINTER_MOVE);
	m_hcMultiMove = LoadCursor(IDC_POINTER_MULTIMOVE);

	return TRUE;
}
 
