/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */



//#include "stdafx.h"

#ifdef MFC
#undef MFC
#endif

#include "war.h"
#include "WarWin32Support.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Support functions for NT network
// These calls are not supported under UNIX
#ifdef WIN32
#include "NTNetwork.h"


//__declspec(thread) WarUserHandle *pWarNTNetH = NULL;

/* Since netapi32.dll is different between win95 and NT,
 * we have to load the library manually in order to avoid
 * problems when win95 users start the program.
 * I've never read how people use to do this, but my
 * code seems to work.
 * I'm getting tired of re-inventing the wheel....
 */

#ifdef WARSVR

#define NetApiBufferFree __NetApiBufferFree
#define NetGetDCName __NetGetDCName
#define NetServerEnum __NetServerEnum
#define NetLocalGroupEnum __NetLocalGroupEnum
#define NetGroupEnum __NetGroupEnum
#define NetLocalGroupAdd __NetLocalGroupAdd
#define NetGroupAdd __NetGroupAdd 
#define NetUserGetInfo __NetUserGetInfo
#define NetUserGetGroups __NetUserGetGroups
#define NetUserGetLocalGroups __NetUserGetLocalGroups
#define NetUserAdd __NetUserAdd
#define NetLocalGroupAddMembers __NetLocalGroupAddMembers
#define NetGroupAddUser __NetGroupAddUser
#define NetLocalGroupGetMembers __NetLocalGroupGetMembers
#define NetGroupGetUsers __NetGroupGetUsers

NET_API_STATUS (PASCAL *__NetGetDCName)(LPWSTR servername, LPWSTR domainname, LPBYTE *bufptr); 
NET_API_STATUS (PASCAL *__NetApiBufferFree)(LPVOID Buffer);
NET_API_STATUS (PASCAL *__NetServerEnum)(LPCWSTR servername, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries, DWORD servertype, LPCWSTR domain, LPDWORD resume_handle);
NET_API_STATUS (PASCAL *__NetLocalGroupEnum)(LPWSTR servername, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries, LPDWORD resumehandle);
NET_API_STATUS (PASCAL *__NetGroupEnum)(LPWSTR servername, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries, LPDWORD resume_handle); 
NET_API_STATUS (PASCAL *__NetLocalGroupAdd)(LPWSTR servername, DWORD level, LPBYTE buf, LPDWORD parm_err); 
NET_API_STATUS (PASCAL *__NetGroupAdd)(LPWSTR servername, DWORD level, LPBYTE buf, LPDWORD parm_err);
NET_API_STATUS (PASCAL *__NetUserGetInfo)(LPWSTR servername, LPWSTR username, DWORD level, LPBYTE *bufptr);
NET_API_STATUS (PASCAL *__NetUserGetGroups)(LPWSTR servername, LPWSTR username, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries);
NET_API_STATUS (PASCAL *__NetUserGetLocalGroups)(LPWSTR servername, LPWSTR username, DWORD level, DWORD flags, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries);
NET_API_STATUS (PASCAL *__NetUserAdd)(LPWSTR servername, DWORD level, LPBYTE buf, LPDWORD parm_err);
NET_API_STATUS (PASCAL *__NetLocalGroupAddMembers)(LPWSTR servername, LPWSTR LocalGroupName, DWORD level, LPBYTE buf, DWORD membercount);
NET_API_STATUS (PASCAL *__NetGroupAddUser)(LPWSTR servername, LPWSTR GroupName, LPWSTR username);
NET_API_STATUS (PASCAL *__NetLocalGroupGetMembers)(LPWSTR servername, LPWSTR localgroupname, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries, LPDWORD resumehandle);
NET_API_STATUS (PASCAL *__NetGroupGetUsers)(LPWSTR servername, LPWSTR groupname, DWORD level, LPBYTE *bufptr, DWORD prefmaxlen, LPDWORD entriesread, LPDWORD totalentries, LPDWORD resumeHandle);

// The lsa* api is only available for NT. Therefore we need to map that too...
#if USE_LSA
#ifdef __cplusplus
extern "C" {
#endif
#define LsaAddAccountRights __LsaAddAccountRights
#define LsaClose __LsaClose
#define LsaDeleteTrustedDomain __LsaDeleteTrustedDomain
#define LsaEnumerateAccountRights __LsaEnumerateAccountRights
#define LsaEnumerateAccountsWithUserRight __LsaEnumerateAccountsWithUserRight
#define LsaFreeMemory __LsaFreeMemory
#define LsaRegisterLogonProcess __LsaRegisterLogonProcess
#define LsaLookupAuthenticationPackage __LsaLookupAuthenticationPackage
#define LsaFreeReturnBuffer __LsaFreeReturnBuffer
#define LsaCallAuthenticationPackage __LsaCallAuthenticationPackage
#define LsaDeregisterLogonProcess __LsaDeregisterLogonProcess
#define LsaOpenPolicy __LsaOpenPolicy
#define LsaQueryInformationPolicy __LsaQueryInformationPolicy
#define LsaSetInformationPolicy __LsaSetInformationPolicy
#define LsaEnumerateTrustedDomains __LsaEnumerateTrustedDomains
#define LsaLookupNames __LsaLookupNames
#define LsaLookupSids __LsaLookupSids
#define LsaRemoveAccountRights __LsaRemoveAccountRights
#define LsaQueryTrustedDomainInfo __LsaQueryTrustedDomainInfo
#define LsaStorePrivateData __LsaStorePrivateData
#define LsaRetrievePrivateData __LsaRetrievePrivateData
#define LsaNtStatusToWinError __LsaNtStatusToWinError

NTSTATUS (NTAPI *__LsaAddAccountRights)(IN LSA_HANDLE PolicyHandle,IN PSID AccountSid,IN PLSA_UNICODE_STRING UserRights,IN ULONG CountOfRights);
NTSTATUS (NTAPI *__LsaClose)(IN LSA_HANDLE ObjectHandle);
NTSTATUS (NTAPI *__LsaDeleteTrustedDomain)(IN LSA_HANDLE PolicyHandle,IN PSID TrustedDomainSid);
NTSTATUS (NTAPI *__LsaEnumerateAccountRights)(IN LSA_HANDLE PolicyHandle,IN PSID AccountSid,OUT PLSA_UNICODE_STRING *UserRights,OUT PULONG CountOfRights);
NTSTATUS (NTAPI *__LsaEnumerateAccountsWithUserRight)(IN LSA_HANDLE PolicyHandle,IN OPTIONAL PLSA_UNICODE_STRING UserRights,OUT PVOID *EnumerationBuffer,OUT PULONG CountReturned);
NTSTATUS (NTAPI *__LsaFreeMemory)(IN PVOID Buffer);
NTSTATUS (NTAPI *__LsaRegisterLogonProcess)(IN PLSA_STRING LogonProcessName,OUT PHANDLE LsaHandle,OUT PLSA_OPERATIONAL_MODE SecurityMode);
NTSTATUS (NTAPI *__LsaLookupAuthenticationPackage)(IN HANDLE LsaHandle,IN PLSA_STRING PackageName,OUT PULONG AuthenticationPackage);
NTSTATUS (NTAPI *__LsaFreeReturnBuffer)(IN PVOID Buffer);
NTSTATUS (NTAPI *__LsaCallAuthenticationPackage)(IN HANDLE LsaHandle,IN ULONG AuthenticationPackage,IN PVOID ProtocolSubmitBuffer,IN ULONG SubmitBufferLength,OUT PVOID *ProtocolReturnBuffer,OUT PULONG ReturnBufferLength,OUT PNTSTATUS ProtocolStatus);
NTSTATUS (NTAPI *__LsaDeregisterLogonProcess)(IN HANDLE LsaHandle);
NTSTATUS (NTAPI *__LsaConnectUntrusted)(OUT PHANDLE LsaHandle);
NTSTATUS (NTAPI *__LsaOpenPolicy)(IN PLSA_UNICODE_STRING SystemName OPTIONAL,IN PLSA_OBJECT_ATTRIBUTES ObjectAttributes,IN ACCESS_MASK DesiredAccess,IN OUT PLSA_HANDLE PolicyHandle);
NTSTATUS (NTAPI *__LsaQueryInformationPolicy)(IN LSA_HANDLE PolicyHandle,IN POLICY_INFORMATION_CLASS InformationClass,OUT PVOID *Buffer);
NTSTATUS (NTAPI *__LsaSetInformationPolicy)(IN LSA_HANDLE PolicyHandle,IN POLICY_INFORMATION_CLASS InformationClass,IN PVOID Buffer);
NTSTATUS (NTAPI *__LsaEnumerateTrustedDomains)(IN LSA_HANDLE PolicyHandle,IN OUT PLSA_ENUMERATION_HANDLE EnumerationContext,OUT PVOID *Buffer,IN ULONG PreferedMaximumLength,OUT PULONG CountReturned);
NTSTATUS (NTAPI *__LsaLookupNames)(IN LSA_HANDLE PolicyHandle,IN ULONG Count,IN PLSA_UNICODE_STRING Names,OUT PLSA_REFERENCED_DOMAIN_LIST *ReferencedDomains,OUT PLSA_TRANSLATED_SID *Sids);
NTSTATUS (NTAPI *__LsaLookupSids)(IN LSA_HANDLE PolicyHandle,IN ULONG Count,IN PSID *Sids,OUT PLSA_REFERENCED_DOMAIN_LIST *ReferencedDomains,OUT PLSA_TRANSLATED_NAME *Names);
NTSTATUS (NTAPI *__LsaRemoveAccountRights)(IN LSA_HANDLE PolicyHandle,IN PSID AccountSid,IN BOOLEAN AllRights,IN PLSA_UNICODE_STRING UserRights,IN ULONG CountOfRights);
NTSTATUS (NTAPI *__LsaQueryTrustedDomainInfo)(IN LSA_HANDLE PolicyHandle,IN PSID TrustedDomainSid,IN TRUSTED_INFORMATION_CLASS InformationClass,OUT PVOID *Buffer);
NTSTATUS (NTAPI *__LsaStorePrivateData)(IN LSA_HANDLE PolicyHandle,IN PLSA_UNICODE_STRING KeyName,IN PLSA_UNICODE_STRING PrivateData);
NTSTATUS (NTAPI *__LsaRetrievePrivateData)(IN LSA_HANDLE PolicyHandle,IN PLSA_UNICODE_STRING KeyName,OUT PLSA_UNICODE_STRING * PrivateData);
ULONG (NTAPI *__LsaNtStatusToWinError)(NTSTATUS Status);
#ifdef __cplusplus
}
#endif
#endif // USE_LSA

#define NetServerEnum __NetServerEnum


BOOL WarNTInitialize()
{

	if (__NetGetDCName)
		return TRUE;

	HINSTANCE h = LoadLibrary("netapi32.dll");
	if (!h)
		return FALSE;

	ASSIGN(h, __NetGetDCName, "NetGetDCName");
	ASSIGN(h, __NetApiBufferFree, "NetApiBufferFree");
	ASSIGN(h, __NetServerEnum, "NetServerEnum");
	ASSIGN(h, __NetLocalGroupEnum, "NetLocalGroupEnum");
	ASSIGN(h, __NetGroupEnum, "NetGroupEnum");
	ASSIGN(h, __NetLocalGroupAdd, "NetLocalGroupAdd");
	ASSIGN(h, __NetGroupAdd, "NetGroupAdd");
	ASSIGN(h, __NetUserGetInfo, "NetUserGetInfo");
	ASSIGN(h, __NetUserGetGroups, "NetUserGetGroups");
	ASSIGN(h, __NetUserGetLocalGroups, "NetUserGetLocalGroups");
	ASSIGN(h, __NetUserAdd, "NetUserAdd");
	ASSIGN(h, __NetLocalGroupAddMembers, "NetLocalGroupAddMembers");
	ASSIGN(h, __NetGroupAddUser, "NetGroupAddUser");
	ASSIGN(h, __NetLocalGroupGetMembers, "NetLocalGroupGetMembers");
	ASSIGN(h, __NetGroupGetUsers, "NetGroupGetUsers");

	Log.LogMsg(LOGF_SYSTEM,0,NULL,0,0,"WarNTInitialize()", "Loaded NT Network api (netapi32.dll).");

#if USE_LSA
	if (!LoadLsaApi())
	{
		Log.LogMsg(LOGF_ERROR,0,NULL,0,0,
			"WarNTInitialize()", "Failed to load LSA api.");
	}
#endif // USE_LSA

	return TRUE;
}

#if USE_LSA
BOOL LoadLsaApi()
{
	if (__LsaAddAccountRights)
		return TRUE;

	HINSTANCE h = LoadLibrary("advapi32.dll");
	if (!h)
		return FALSE;

	ASSIGN(h, __LsaAddAccountRights, "LsaAddAccountRights");
	ASSIGN(h, __LsaClose, "LsaClose");
	ASSIGN(h, __LsaDeleteTrustedDomain, "LsaDeleteTrustedDomain");
	ASSIGN(h, __LsaEnumerateAccountsWithUserRight, "LsaEnumerateAccountsWithUserRight");
	ASSIGN(h, __LsaFreeMemory, "LsaFreeMemory");
	ASSIGNEX(h, __LsaRegisterLogonProcess, "LsaRegisterLogonProcess");
	ASSIGNEX(h, __LsaLookupAuthenticationPackage, "LsaLookupAuthenticationPackage");
	ASSIGNEX(h, __LsaCallAuthenticationPackage, "LsaCallAuthenticationPackage");
	ASSIGNEX(h, __LsaDeregisterLogonProcess, "LsaDeregisterLogonProcess");
	ASSIGN(h, __LsaOpenPolicy, "LsaOpenPolicy");
	ASSIGN(h, __LsaEnumerateAccountRights, "LsaEnumerateAccountRights");
	ASSIGN(h, __LsaQueryInformationPolicy, "LsaQueryInformationPolicy");
	ASSIGN(h, __LsaSetInformationPolicy, "LsaSetInformationPolicy");
	ASSIGN(h, __LsaEnumerateTrustedDomains, "LsaEnumerateTrustedDomains");
	ASSIGN(h, __LsaLookupNames, "LsaLookupNames");
	ASSIGN(h, __LsaLookupSids, "LsaLookupSids");
	ASSIGN(h, __LsaRemoveAccountRights, "LsaRemoveAccountRights");
	ASSIGN(h, __LsaQueryTrustedDomainInfo, "LsaQueryTrustedDomainInfo");
	ASSIGN(h, __LsaStorePrivateData, "LsaStorePrivateData");
	ASSIGN(h, __LsaRetrievePrivateData, "LsaRetrievePrivateData");
	ASSIGN(h, __LsaNtStatusToWinError, "LsaNtStatusToWinError");
	ASSIGNEX(h, __LsaFreeReturnBuffer, "LsaFreeReturnBuffer");

	Log.LogMsg(LOGF_SYSTEM,0,NULL,0,0,"LoadLsaApi()", "Loaded NT Local Security Authority Protected Subsystem (LSA) (advapi32.dll).");

	return TRUE;
}
#endif // USE_LSA

WarString WarNTGetDC(LPCSTR Machine, LPCSTR Domain)
{
	WarString wBuf;
	LPWSTR lpwMachine = WarNTConvertStr(Machine);
	LPWSTR lpwDomain = WarNTConvertStr(Domain);
	LPBYTE pBuf = NULL;

	NET_API_STATUS Result = ::NetGetDCName(lpwMachine, lpwDomain, &pBuf);
	if(Result == NERR_Success)
		wBuf = WarNTConvertStr((LPWSTR) pBuf);

	if (lpwMachine)
		delete lpwMachine;

	if (lpwDomain)
		delete lpwDomain;

	if (pBuf)
		::NetApiBufferFree(pBuf);

	return wBuf;
}

// Return a line seperated list of domans
WarLinkedList *WarNTGetDomains(LPCSTR RunOnMachine)
{
	LPBYTE pBuf = NULL;
	DWORD NumEntriesRead = 0;
	DWORD Total = 0;
	LPWSTR lpwMachine = WarNTConvertStr(RunOnMachine);
	WarLinkedList *pList = new WarLinkedList;

	NET_API_STATUS Result = ::NetServerEnum(lpwMachine, 101, &pBuf, 1024 * 16, 
		&NumEntriesRead, &Total, SV_TYPE_DOMAIN_ENUM, NULL, 0);

	if(Result == NERR_Success)
	{
		SERVER_INFO_101 *pSvr = (SERVER_INFO_101 *)pBuf;
		for(DWORD i = 0; i < NumEntriesRead; i++)
		{
			pList->AddLast((LPVOID)new WarNTServerInfo(pSvr[i]));
		}
	}

	if (pBuf)
		::NetApiBufferFree(pBuf);

	if (lpwMachine)
		delete lpwMachine;
	
	return pList;
}

// Return a line seperated list of NT servers/workstations
WarLinkedList *WarNTGetServers(LPCSTR RunOnMachine, LPCSTR Domain)
{
	ASSERT(Domain != NULL);
	LPBYTE pBuf = NULL;
	DWORD NumEntriesRead = 0;
	DWORD Total = 0;
	LPWSTR lpwMachine = WarNTConvertStr(RunOnMachine);
	LPWSTR lpwDomain = WarNTConvertStr(Domain);
	BOOL GoOn = FALSE;
	WarLinkedList *pList = new WarLinkedList;

	do
	{
		NET_API_STATUS Result = ::NetServerEnum(lpwMachine, 
			101, &pBuf, 1024 * 16, &NumEntriesRead, &Total, SV_TYPE_NT , 
			lpwDomain, 0);
		
		GoOn = FALSE;
		
		switch(Result)
		{
			case ERROR_MORE_DATA:
				GoOn = TRUE;
			case NERR_Success:
				{
					SERVER_INFO_101 *pSvr = (SERVER_INFO_101 *)pBuf;
					for(DWORD i = 0; i < NumEntriesRead; i++)
					{
						pList->AddLast((LPVOID)new WarNTServerInfo(pSvr[i]));
					}
				}
			break;
		}

		if (pBuf)
			::NetApiBufferFree(pBuf);
	} while (GoOn);

	if (lpwMachine)
		delete lpwMachine;

	if (lpwDomain)
		delete lpwDomain;
	
	return pList;
}

// Host can be a domain or a machine. Null for the current machine.
WarLinkedList *WarNTGetGroups(LPCSTR Host)
{
	LPBYTE pBuf = NULL;
	DWORD NumEntriesRead = 0;
	DWORD Total = 0;
	WarLinkedList *pList = new WarLinkedList;
	LPWSTR lpwMachine = WarNTConvertStr(Host 
		? (*Host == '\\') ? Host : WarNTGetDC(NULL, Host)
		: NULL);

	NET_API_STATUS Result = ::NetGroupEnum(lpwMachine, 1, &pBuf, 1024 * 16, 
		&NumEntriesRead, &Total, 0);

	// Get global groups
	if(Result == NERR_Success)
	{
		GROUP_INFO_1 *pSvr = (GROUP_INFO_1 *)pBuf;
		for(DWORD i = 0; i < NumEntriesRead; i++)
			pList->AddLast((LPVOID)new WarNTGroupInfo(pSvr[i]));
	}

	// Get local groups
	Result = ::NetLocalGroupEnum(lpwMachine, 1, &pBuf, 1024 * 16, 
		&NumEntriesRead, &Total, 0);

	if(Result == NERR_Success)
	{
		LOCALGROUP_INFO_1 *pSvr = (LOCALGROUP_INFO_1 *)pBuf;
		for(DWORD i = 0; i < NumEntriesRead; i++)
			pList->AddLast((LPVOID)new WarNTGroupInfo(pSvr[i]));
	}

	if (pBuf)
		::NetApiBufferFree(pBuf);

	if (lpwMachine)
		delete lpwMachine;
	
	return pList;
}

BOOL WarNTAddGroup(LPCSTR Host, LPCSTR Name, LPCSTR Comment, BOOL bMakeGlobal)
{
	LPWSTR lpwServer = WarNTConvertStr(Host 
		? (*Host == '\\') ? Host : WarNTGetDC(NULL, Host)
		: NULL);
	LPWSTR lpwName = WarNTConvertStr(Name);
	LPWSTR lpwComment = WarNTConvertStr(Comment);
	NET_API_STATUS Result;

	if (bMakeGlobal)
	{
		GROUP_INFO_1 Info;
		Info.grpi1_name = lpwName;
		Info.grpi1_comment = lpwComment;
		Result = ::NetGroupAdd(lpwServer, 1, (LPBYTE)&Info, NULL);
	}
	else
	{
		LOCALGROUP_INFO_1 Info;
		Info.lgrpi1_name = lpwName;
		Info.lgrpi1_comment = lpwComment;
		Result = ::NetLocalGroupAdd(lpwServer, 1, (LPBYTE)&Info, NULL);
	}

	SetLastError(Result);
	return Result == NERR_Success;
}


// Return TRUE, FALSE or -1 on error, -2 if the user exist, but not in the group
int WarNTDoesUserExist(LPCSTR Host, LPCSTR Group, BOOL bLocalGrp, LPCSTR UserName)
{
	int Retval = -1; // Error
	LPWSTR wHost = WarNTConvertStr(Host);
	LPWSTR wUser = WarNTConvertStr(UserName);
	NET_API_STATUS Result;
	LPBYTE pBuf = NULL;
	DWORD GotEntries = 0, TotalEntries = 0;

	Result = NetUserGetInfo(wHost, wUser, 0, &pBuf);
	if (Result == NERR_Success)
	{
		Retval = -2; // Exist
		switch(bLocalGrp)
		{
			case FALSE:
				// Check global groups
				if (pBuf)
					::NetApiBufferFree(pBuf);
				pBuf = NULL; // Prepere for next value
				Result = NetUserGetGroups(wHost, wUser, 0, &pBuf, 1024 * 16, &GotEntries, &TotalEntries);
				if (Result == NERR_Success)
				{
					for(DWORD i = 0; i < GotEntries; i++)
					{
						GROUP_USERS_INFO_0 *pInfo = (GROUP_USERS_INFO_0 *)pBuf;
						if (WarNTConvertStr(pInfo[i].grui0_name).Stricmp(Group))
						{
							Retval = TRUE;
							break;
						}
					}
				}
				break;

			case TRUE:
				// Check local groups
				if (pBuf)
					::NetApiBufferFree(pBuf);
				pBuf = NULL; // Prepere for next value
				Result = NetUserGetLocalGroups(wHost, wUser, 0, 
					LG_INCLUDE_INDIRECT, &pBuf, 1024 * 16, &GotEntries, &TotalEntries);
				if (Result == NERR_Success)
				{
					for(DWORD i = 0; i < GotEntries; i++)
					{
						LOCALGROUP_USERS_INFO_0 *pInfo = (LOCALGROUP_USERS_INFO_0 *)pBuf;
						if (WarNTConvertStr(pInfo[i].lgrui0_name).Stricmp(Group))
						{
							Retval = TRUE;
							goto done;
						}
					}
				}
				break;

			default:
				ASSERT(FALSE);
		}
	}
	else if (Result == NERR_UserNotFound)
	{
		Retval = FALSE;
	}

done:

	if (wHost)
		delete wHost;

	if (wUser)
		delete wUser;

	if (pBuf)
		::NetApiBufferFree(pBuf);

	return Retval;
}

// Add a user to the NT userdatabase
// // Return TRUE, FALSE or -1 on error.
int WarNTAddUser(LPCSTR Host, LPCSTR Group, BOOL bAddLocal, LPCSTR UserName, user_pwd& Pwd)
{
	int Status = WarNTDoesUserExist(Host, Group, bAddLocal, UserName);
	NET_API_STATUS CallStat;
	int Rval = -1; // Error

	if (Status == TRUE)
	{
		Log.LogMsg(LOGF_ERROR,0,NULL,0,0,"WarNTAddUser()", "(%s, %s, %s) - User alredy existed.",
			Host, Group, UserName);
		return TRUE; // User exist in group
	}

	if (Status == -1)
	{
		Log.LogMsg(LOGF_ERROR,0,NULL,0,0,"WarNTAddUser()", "(%s, %s, %s) - WarNTDoesUserExist() Failed.",
			Host, Group, UserName);
		return FALSE; // Error
	}

	LPWSTR wHost = WarNTConvertStr(Host);
	LPWSTR wGroup = WarNTConvertStr(Group);
	LPWSTR wUser = WarNTConvertStr(UserName);


	if (Status == FALSE)
	{
		Status = -2; // add user in group
		// Add the user
		LPCSTR Passwd;
		if ((Pwd.m_PwdEncoding != PWDE_NONE)
			|| (!Pwd.m_Passwd))
		{
			Passwd = "war";
			Log.LogMsg(LOGF_SYSTEM, 0, NULL, 0, 0, "WarNTAddUser()", "NT user '%s' on host %s must change password.",
				UserName, Host);
		}
		else
			Passwd = Pwd.m_Passwd;

		USER_INFO_1 UI;
		UI.usri1_name = WarNTConvertStr(UserName);
		UI.usri1_password = WarNTConvertStr(Passwd);
		UI.usri1_password_age = 0; // Ignored
		UI.usri1_priv = USER_PRIV_USER;
		UI.usri1_home_dir = NULL;
		UI.usri1_comment = WarNTConvertStr("Exported from War user database");
		UI.usri1_flags = UF_SCRIPT  | UF_DONT_EXPIRE_PASSWD | UF_NORMAL_ACCOUNT;
		UI.usri1_script_path = NULL;

		DWORD parm_err;

		CallStat = NetUserAdd(wHost, 1, (LPBYTE)&UI, &parm_err);

		delete UI.usri1_name;
		delete UI.usri1_password;
		delete UI.usri1_comment;

		if (CallStat != NERR_Success)
		{
			Log.LogMsg(LOGF_ERROR,0,NULL,CallStat,0,"WarNTAddUser()", "(%s, %s, %s) - NetUserAdd() Failed (parameter=%d).",
				Host, Group, UserName, parm_err);
			Status = -1; // Error
		}
		else
			Rval = TRUE;
	}

	if (Status == -2)
	{
		if (bAddLocal)
		{
			LOCALGROUP_MEMBERS_INFO_3 GM;
			GM.lgrmi3_domainandname = WarNTConvertStr(UserName);

			CallStat = NetLocalGroupAddMembers(wHost, wGroup, 3, (LPBYTE)&GM, 1);

			delete GM.lgrmi3_domainandname;

			if (CallStat != NERR_Success)
			{
				Rval = -1;
				Log.LogMsg(LOGF_ERROR,0,NULL,CallStat,0,"WarNTAddUser()", "(%s, %s, %s) - NetLocalGroupAddMembers() Failed.",
					Host, Group, UserName);
			}
			else
				Rval = TRUE;
		}
		else
		{
			CallStat = NetGroupAddUser(wHost, wGroup, wUser);

			if (CallStat != NERR_Success)
			{
				Rval = -1;
				Log.LogMsg(LOGF_ERROR,0,NULL,CallStat,0,"WarNTAddUser()", "(%s, %s, %s) - NetLocalGroupAddMembers() Failed.",
					Host, Group, UserName);
			}
			else
				Rval = TRUE;
		}
	}

	if (wHost)
		delete wHost;

	if (wGroup)
		delete wGroup;

	if (wUser)
		delete wUser;

	return Rval;
}

// Support function to add a user to a list. If the user already exist.
// Duplicates are not added.
// The information is stored in a WarNTUserInfo object
void WarNTAddUserInformation(LPWSTR wHost, LPWSTR wUser, WarLinkedList **ppList)
{
	USER_INFO_2 *pUI;
	NET_API_STATUS Status = NetUserGetInfo(wHost, wUser, 2, (LPBYTE *)&pUI);
	WarLinkedList *pList;

#ifdef _DEBUG
	WarString UserName = WarNTConvertStr(wUser);
#endif

	if (Status == NERR_Success)
	{
		if ((pUI->usri2_flags & UF_NORMAL_ACCOUNT))
		{
			// Add info
			if (!*ppList)
				*ppList = new WarLinkedList;
			pList = *ppList;
			WarLinkedListItem *pItem;
			WarString ID = WarNTConvertStr(pUI->usri2_name);
			WarNTUserInfo *p;
			for(pItem = pList->First(); pItem; pItem = pList->Next(pItem))
			{
				p = (WarNTUserInfo *)pList->Ptr(pItem);
				if (!p->m_Name.Stricmp(ID))
					break;
			}

			if (!pItem)
			{
				// Add entry
				p = new WarNTUserInfo(*pUI);
				pList->AddLast((LPVOID)p);
			}
		}
	}
	else
	{
		Log.LogMsg(LOGF_WARNINGS,0,NULL,Status,0,
			"WarNTAddUserInformation()", "(%s, %s) - NetUserGetInfo() failed.",
			(LPCSTR)WarNTConvertStr(wHost), (LPCSTR)WarNTConvertStr(wUser));
	}

	if (pUI)
		NetApiBufferFree(pUI);
}

WarLinkedList *WarNTGetUsers(LPCSTR Host, LPCSTR Group, BOOL bIsLocal)
{
	LPWSTR wHost = WarNTConvertStr((*Host == '\\') ? Host : WarNTGetDC(NULL, Host));
	LPWSTR wGroup = WarNTConvertStr(Group);
	WarLinkedList *pList = NULL;
	DWORD ReadEntries = 0, TotalEntries = 0, Resume = 0;

	// Lookup users
	if (bIsLocal)
	{
		// Global users
		LOCALGROUP_MEMBERS_INFO_1 *pGI = NULL;
		NET_API_STATUS Status = NetLocalGroupGetMembers(wHost, wGroup, 1, 
			(LPBYTE *)&pGI, 1024 * 32, &ReadEntries, &TotalEntries, &Resume);
		if (Status == NERR_Success)
		{
			for(DWORD i = 0; i < ReadEntries; i++)
			{
				if (pGI[i].lgrmi1_sidusage == SidTypeUser) //Don't work in NT 4.0 ??
					WarNTAddUserInformation(wHost, pGI[i].lgrmi1_name, &pList);
			}
		}

		if (pGI)
			NetApiBufferFree(pGI);
	}
	else
	{
		// Global users
		GROUP_USERS_INFO_0 *pGI = NULL;
		NET_API_STATUS Status = NetGroupGetUsers(wHost, wGroup, 0, 
			(LPBYTE *)&pGI, 1024 * 32, &ReadEntries, &TotalEntries, &Resume);
		if (Status == NERR_Success)
		{
			for(DWORD i = 0; i < ReadEntries; i++)
				WarNTAddUserInformation(wHost, pGI[i].grui0_name, &pList);
		}
		else
		{
			Log.LogMsg(LOGF_DEBUG,0,NULL,Status,0,"WarNTGetUsers()",
				"NetGroupGetUsers(%s,%s) failed", Host, Group);
		}

		if (pGI)
			NetApiBufferFree(pGI);
	}

	if (wHost)
		delete wHost;

	if (wGroup)
		delete wGroup;

	return pList;
}


LPWSTR WarNTConvertStr(LPCSTR Str)
{
	if (!Str)
		return NULL;

	int Len = strlen(Str);
	WORD *pNewBuf = new WORD[Len + 1];
	MultiByteToWideChar(CP_ACP, 0, Str, -1, 
		(LPWSTR)pNewBuf, Len + 1);

	WarString wBuf = WarNTConvertStr(pNewBuf);

	return pNewBuf;
}

WarString WarNTConvertStr(LPCWSTR wcStr)
{
	WarString wBuf;
	int Len = WideCharToMultiByte(CP_ACP, 0, wcStr, -1, NULL, 0, NULL, NULL);
	if (Len)
	{
		WideCharToMultiByte(CP_ACP, 0, wcStr, Len, wBuf.GetBuffer(Len), Len, NULL, NULL);
		wBuf.ReleaseBuffer();
	}
	return wBuf;
}

BOOL WarNTAccessPermitted(LPCSTR Domain, LPCSTR User, LPCSTR Passwd, DWORD LoginMode, BOOL bSetPrivileges)
{
	HANDLE lh;
	char buf[MAX_PATH];
	DWORD buflen = sizeof(buf);

	if (GetComputerName(buf, &buflen))
	{
		if ((Domain[0] == '\\') && (Domain[1] == '\\'))
		{
			if (!stricmp(&Domain[2], buf))
				Domain = ".";
		}
	}

	if (bSetPrivileges)
	{
#if USE_LSA
		// Give the user the rights to the requested login mode
		DWORD Error;
    LSA_HANDLE PolicyHandle = NULL;
    Error = OpenPolicy(NULL, POLICY_ALL_ACCESS,&PolicyHandle);
		if (Error)
		{
			Log.LogMsg(LOGF_ERROR,0,NULL,Error,0,"WarNTAccessPermitted()", "OpenPolicy() failed. Can not set user privileges.");
		}
		else
		{
			LPWSTR wUser = WarNTConvertStr(User);
			LPWSTR wRight = NULL;
			LPSTR Rights = NULL;
			BOOL bAlsoSystemRights = FALSE;
			switch(LoginMode)
			{
				case LOGON32_LOGON_SERVICE:
					Rights = "SeServiceLogonRight";
					bAlsoSystemRights = TRUE;
					break;
				case LOGON32_LOGON_BATCH:
					Rights = "SeBatchLogonRight";
					break;
				case LOGON32_LOGON_NETWORK:
					Rights = "SeNetworkLogonRight";
					break;
				case LOGON32_LOGON_INTERACTIVE:
					Rights = "SeInteractiveLogonRight";
					break;
				default:
					ASSERT(FALSE);
					;
					break;
			}
			wRight = WarNTConvertStr(Rights);
			Error = AddUserRightToAccount(PolicyHandle, wUser, wRight);
			if (Error == 0)
			{
				Log.LogMsg(LOGF_SYSTEM, 0, NULL, 0, 0, 
					"WarNTAccessPermitted()", "NT user %s is granthed %s.", 
					User, Rights);
			}
			else
			{
				Log.LogMsg(LOGF_SYSTEM, 0, NULL, Error, 0, 
					"WarNTAccessPermitted()", "Failed to granth NT user %s with %s.", 
					User, Rights);
			}

			if (bAlsoSystemRights && !Error)
			{
				delete wRight;
				wRight  = WarNTConvertStr("SeTcbPrivilege");
				Error = AddUserRightToAccount(PolicyHandle, wUser, wRight);
				if (Error == 0)
				{
					Log.LogMsg(LOGF_SYSTEM, 0, NULL, 0, 0, 
						"WarNTAccessPermitted()", "NT user %s is granthed %s.", 
						User, Rights);
				}
				else
				{
					Log.LogMsg(LOGF_SYSTEM, 0, NULL, Error, 0, 
						"WarNTAccessPermitted()", "Failed to granth NT user %s with %s.", 
						User, Rights);
				}
			}
			delete wUser;
			delete wRight;
		}
#endif // USE_LSA
	}

	if (LogonUser(
		(char *)User,
		(char *)Domain,
		(char *)Passwd,
		LoginMode,
		LOGON32_PROVIDER_DEFAULT,
		&lh))
	{
		// TODO: Store the logon handle for later use
		Log.LogMsg(LOGF_INOUT, 0, NULL, 0, 0, "WarNTAccessPermitted()", "User %s logged on with NT password (%s).", User, Domain);
		CloseHandle(lh); // We don't need this for now...
		return TRUE;
	}
		
	int err = GetLastError();
	if (err == ERROR_PRIVILEGE_NOT_HELD)
	{
#if USE_LSA
		static BOOL bHaveTriedToSetRights;
		if (!bHaveTriedToSetRights && RunningAsAdministrator())
		{
			// Try to set the right..
			char buffer[64];
			DWORD buflen = sizeof(buffer);
			if (GetUserName(buffer,&buflen))
			{
				bHaveTriedToSetRights = TRUE;
				LPWSTR wUser = WarNTConvertStr(buffer);
				LPWSTR wRight = NULL;
				LPSTR Rights = "SeTcbPrivilege";
				wRight = WarNTConvertStr(Rights);
				LSA_HANDLE PolicyHandle = NULL;
			
				// zero is success
				if (!OpenPolicy(NULL, POLICY_ALL_ACCESS,&PolicyHandle))
				{
					// zero is success
					if (!AddUserRightToAccount(PolicyHandle, wUser, wRight))
						Log.Sysmsg("*** YOU (%s) HAVE BEEN GRANTHED %s. PLEASE LOG OFF AND BACK ON IN ORDER TO MAKE THE RIGHTS EFFECTIVE.",
							buffer, Rights);
				}
			}
		}
#endif // USE_LSA
		char AccessName[128] = SE_TCB_NAME;
		DWORD dw1, dw2;
		LookupPrivilegeDisplayName(NULL, SE_TCB_NAME, AccessName, &dw1, &dw2);
		Log.LogMsg(LOGF_ERROR,0,NULL,0,err,"WarNTAccessPermitted()", "The user that run the FTP server must have '%s' access.",
		AccessName);
	}
			
	Log.LogMsg(LOGF_SECURITY,0,NULL,0,err,
		"WarNTAccessPermitted()", "(%s,%s) - NT logon failed.", User, Domain);

	return FALSE;
}

BOOL RunningAsAdministrator ( VOID)
{
    BOOL         fAdmin;
    HANDLE       hThread;
    TOKEN_GROUPS *ptg = NULL;
    DWORD        cbTokenGroups;
    DWORD        dwGroup;
    PSID         psidAdmin;

    SID_IDENTIFIER_AUTHORITY SystemSidAuthority= SECURITY_NT_AUTHORITY;

    // First we must open a handle to the access token for this thread.

    if ( !OpenThreadToken ( GetCurrentThread(), TOKEN_QUERY, FALSE, &hThread))
    {
        if ( GetLastError() == ERROR_NO_TOKEN)
        {
            // If the thread does not have an access token, we'll examine the
            // access token associated with the process.

            if (! OpenProcessToken ( GetCurrentProcess(), TOKEN_QUERY, 
                                                                    &hThread))
            return ( FALSE);
        }
        else 
            return ( FALSE);
    }

    // Then we must query the size of the group information associated with
    // the token. Note that we expect a FALSE result from GetTokenInformation
    // because we've given it a NULL buffer. On exit cbTokenGroups will tell
    // the size of the group information.

    if ( GetTokenInformation ( hThread, TokenGroups, NULL, 0, &cbTokenGroups))
        return ( FALSE);

    // Here we verify that GetTokenInformation failed for lack of a large
    // enough buffer.

    if ( GetLastError() != ERROR_INSUFFICIENT_BUFFER)
        return ( FALSE);

    ptg= new _TOKEN_GROUPS[cbTokenGroups];

    // Now we ask for the group information again.
    // This may fail if an administrator has added this account
    // to an additional group between our first call to
    // GetTokenInformation and this one.

    if ( !GetTokenInformation ( hThread, TokenGroups, ptg, cbTokenGroups,
                                       &cbTokenGroups) )
    {
				delete ptg;
        return ( FALSE);
		}

    // Now we must create a System Identifier for the Admin group.

    if ( ! AllocateAndInitializeSid ( &SystemSidAuthority, 2, 
                                               SECURITY_BUILTIN_DOMAIN_RID, 
                                               DOMAIN_ALIAS_RID_ADMINS,
                                               0, 0, 0, 0, 0, 0, &psidAdmin) )
    {
				delete ptg;
        return ( FALSE);
		}

    // Finally we'll iterate through the list of groups for this access
    // token looking for a match against the SID we created above.

    fAdmin= FALSE;

    for ( dwGroup= 0; dwGroup < ptg->GroupCount; dwGroup++)
    {
        if ( EqualSid ( ptg->Groups[dwGroup].Sid, psidAdmin))
        {
            fAdmin = TRUE;
            break;
        }
    }

    // Before we exit we must explicity deallocate the SID we created.

    FreeSid ( psidAdmin);
		delete ptg;

    return ( fAdmin);
}


#if USE_LSA

void InitLsaString(PLSA_UNICODE_STRING LsaString,LPWSTR String)
{
    DWORD StringLength;
    if (String == NULL)
    {
        LsaString->Buffer = NULL;
        LsaString->Length = 0;
        LsaString->MaximumLength = 0;
        return;
    }

    StringLength = wcslen(String);
    LsaString->Buffer = String;
    LsaString->Length = (USHORT) StringLength * sizeof(WCHAR);
    LsaString->MaximumLength = (USHORT) (StringLength + 1) * sizeof(WCHAR); 
}

DWORD OpenPolicy(LPWSTR ServerName,DWORD DesiredAccess,PLSA_HANDLE PolicyHandle)
{
    DWORD Error;
    LSA_OBJECT_ATTRIBUTES ObjectAttributes;
    LSA_UNICODE_STRING ServerString;
    PLSA_UNICODE_STRING Server = NULL;

    //
    // Always initialize the object attributse to all zeroes
    //

    ZeroMemory(
        &ObjectAttributes,
        sizeof(ObjectAttributes)
        );

    if (ServerName != NULL)
    {
        //
        // Make a LSA_UNICODE_STRING out of the LPWSTR passed in
        //
    
        InitLsaString(
            &ServerString,
            ServerName
            );
        Server = &ServerString;
    
    }
    //
    // Attempt to open the policy for all access
    //

    Error = LsaNtStatusToWinError(
                LsaOpenPolicy(
                    Server,
                    &ObjectAttributes,
                    DesiredAccess,
                    PolicyHandle
                    ) );
    if (Error != 0)
    {
       Log.LogMsg(LOGF_ERROR,0,NULL,Error,0,"OpenPolicy()", "Failed to open policy");
    }

    return Error;
}



PSID GetAccountSid(LSA_HANDLE PolicyHandle,LPWSTR AccountName)
{
    PLSA_TRANSLATED_SID TranslatedSid;
    PSID Sid;
    PSID DomainSid;
    PLSA_REFERENCED_DOMAIN_LIST Domains;
    DWORD Error;
    LSA_UNICODE_STRING AccountString;
    DWORD NewSidLength;
    DWORD SubAuthorityCount;

    //
    // Convert the string to a LSA_UNICODE_STRING
    //

    InitLsaString(
        &AccountString,
        AccountName
        );

    //
    // Call the LSA to lookup the name
    //

    Error = LsaNtStatusToWinError(
                LsaLookupNames(
                    PolicyHandle,
                    1,
                    &AccountString,
                    &Domains,
                    &TranslatedSid
                    ) );
    if (Error != 0)
    {
        Log.LogMsg(LOGF_ERROR,0,NULL,Error,0,"GetAccountSid()", "Could not map name");
        return(NULL);
    }

    //
    // Build a SID from the Domain SID and account RID
    //

    DomainSid = Domains->Domains[TranslatedSid->DomainIndex].Sid;
    //
    // Compute the length of the new SID.  This is the length required for the
    // number of subauthorities in the domain sid plus one for the user RID.
    //

    SubAuthorityCount = *GetSidSubAuthorityCount(DomainSid);
    NewSidLength = GetSidLengthRequired( (UCHAR) (SubAuthorityCount + 1) );

    Sid = LocalAlloc(0,NewSidLength);

    if (Sid == NULL)
    {
        LsaFreeMemory(Domains);
        LsaFreeMemory(TranslatedSid);
        return(NULL);
    }

    //
    // Build the SID by copying the domain SID and, increasing the sub-
    // authority count in the new sid by one, and setting the last
    // subauthority to be the relative id of the user.
    //

    CopySid(
        NewSidLength,
        Sid,
        DomainSid
        );


    *GetSidSubAuthorityCount(Sid) = (UCHAR) SubAuthorityCount + 1;
    *GetSidSubAuthority(Sid, SubAuthorityCount) = TranslatedSid->RelativeId;
    LsaFreeMemory(Domains);
    LsaFreeMemory(TranslatedSid);

    return(Sid);
            
}

DWORD AddUserRightToAccount(LSA_HANDLE PolicyHandle,LPWSTR AccountName,LPWSTR UserRightName)
{
    DWORD Error = 0;
    PSID AccountSid;
    LSA_UNICODE_STRING UserRightString;

    AccountSid = GetAccountSid(
            PolicyHandle,
            AccountName
            );
    if (AccountSid == NULL)
    {
        Log.LogMsg(LOGF_ERROR,0,NULL,Error,0,"AddUserRightToAccount()", "Failed to get account sid");
        return(0xc0000001);
    }

    //
    // Create a LSA_UNICODE_STRING for the right name
    //

    InitLsaString(&UserRightString,UserRightName);

    Error = LsaNtStatusToWinError(
                LsaAddAccountRights(
                    PolicyHandle,
                    AccountSid,
                    &UserRightString,
                    1
                    ) );
    if (Error != 0)
    {
         Log.LogMsg(LOGF_ERROR,0,NULL,Error,0,"AddUserRightToAccount()", "Failed to add user right");
    }

    LocalFree(AccountSid);
    return(Error);
}

#endif // USE_LSA
#endif // WARSVR

/////////////////////////////////////////////////////////////////////
// Data
/////////////////////////////////////////////////////////////////////

#ifdef WARSVR

WarNTUserInfo::WarNTUserInfo(USER_INFO_2& UI)
{
	m_Name = WarNTConvertStr(UI.usri2_name);
	m_FullName = WarNTConvertStr(UI.usri2_full_name);
	m_Comment = WarNTConvertStr(UI.usri2_usr_comment);
	m_HomeDir = WarNTConvertStr(UI.usri2_home_dir);
	if (UI.usri2_acct_expires != TIMEQ_FOREVER)
		m_Expire = (time_t)UI.usri2_acct_expires;
	else
		m_Expire.SetToNull();

	if (UI.usri2_flags & (UF_ACCOUNTDISABLE | UF_LOCKOUT))
		m_bIsDisabled = TRUE;
	else
		m_bIsDisabled = FALSE;
}

#endif

WarNTServerInfo::WarNTServerInfo(LPCSTR Name, LPCSTR Comment, int Type)
{
	m_Name = Name;
	m_Comment = Comment;
	m_Type = Type;
}

#ifdef WARSVR	
WarNTServerInfo::WarNTServerInfo(SERVER_INFO_101& Info)
{
	m_Name = (LPCSTR)WarNTConvertStr((LPCWSTR)Info.sv101_name);
	m_Comment = (LPCSTR)WarNTConvertStr((LPCWSTR)Info.sv101_comment);
	m_Type = Info.sv101_type;

	if (!(m_Type & SV_TYPE_DOMAIN_ENUM))
	{
		WarString wBuf = m_Name;
		m_Name = "\\\\";
		m_Name << wBuf;
	}
}
#endif

LPCSTR WarNTServerInfo::GetDisplayName()
{
	LPCSTR p = m_Name;
	while(*p == '\\')
		++p;

	return p;
}

WarNTGroupInfo::WarNTGroupInfo(LPCSTR Name, LPCSTR Comment, BOOL bIsGlobal)
{
	m_Name = Name;
	m_Comment = Comment;
	m_bIsGlobal = bIsGlobal; 
}

#ifdef WARSVR
WarNTGroupInfo::WarNTGroupInfo(LOCALGROUP_INFO_1& Info)
{
	m_Name = WarNTConvertStr((LPCWSTR)Info.lgrpi1_name);
	m_Comment = WarNTConvertStr((LPCWSTR)Info.lgrpi1_comment);
	m_bIsGlobal = FALSE; 
}

WarNTGroupInfo::WarNTGroupInfo(GROUP_INFO_1& Info)
{
	m_Name = WarNTConvertStr((LPCWSTR)Info.grpi1_name);
	m_Comment = WarNTConvertStr((LPCWSTR)Info.grpi1_comment);
	m_bIsGlobal = TRUE; 
}
#endif // WARSVR




#endif // WIN32


/*

Dump of file netapi32.dll

File Type: DLL

         Section contains the following exports for NETAPI32.dll

                   0 characteristics
            33397AFF time date stamp Wed Mar 26 18:37:35 1997
                0.00 version
                   1 ordinal base
                 273 number of functions
                 273 number of names

            ordinal hint RVA      name

                  1    0 0000F1BA I_BrowserDebugCall
                  2    1 0000F293 I_BrowserDebugTrace
                  3    2 0000F639 I_BrowserQueryEmulatedDomains
                  4    3 0000F0AE I_BrowserQueryOtherDomains
                  5    4 0000F369 I_BrowserQueryStatistics
                  6    5 000076B5 I_BrowserResetNetlogonState
                  7    6 0000F43F I_BrowserResetStatistics
                  8    7 0000EE74 I_BrowserServerEnum
                  9    8 0000F631 I_BrowserSetNetlogonState
                 10    9 0001145A I_NetAccountDeltas
                 11    A 000114E8 I_NetAccountSync
                 12    B 000112B6 I_NetDatabaseDeltas
                 13    C 000116E7 I_NetDatabaseRedo
                 15    D 00011341 I_NetDatabaseSync
                 14    E 000113CC I_NetDatabaseSync2
                 16    F 0000B060 I_NetDfsCreateExitPoint
                 17   10 0000ACE1 I_NetDfsCreateLocalPartition
                 18   11 0000B148 I_NetDfsDeleteExitPoint
                 19   12 0000ADCC I_NetDfsDeleteLocalPartition
                 20   13 0000B303 I_NetDfsFixLocalVolume
                 21   14 0000AC0B I_NetDfsGetVersion
                 22   15 00010062 I_NetDfsIsThisADomainName
                 23   16 0000B22A I_NetDfsModifyPrefix
                 24   17 0000AEA5 I_NetDfsSetLocalVolumeState
                 25   18 0000AF87 I_NetDfsSetServerInfo
                 26   19 0001176F I_NetGetDCList
                 27   1A 000086A2 I_NetListCanonicalize
                 28   1B 00008807 I_NetListTraverse
                 30   1C 00011576 I_NetLogonControl
                 29   1D 000115F9 I_NetLogonControl2
                 31   1E 00011B19 I_NetLogonSamLogoff
                 32   1F 00011A78 I_NetLogonSamLogon
                 33   20 00011A06 I_NetLogonUasLogoff
                 34   21 00011991 I_NetLogonUasLogon
                 35   22 00002467 I_NetNameCanonicalize
                 36   23 00002942 I_NetNameCompare
                 37   24 000025AC I_NetNameValidate
                 38   25 00001C50 I_NetPathCanonicalize
                 39   26 0000881B I_NetPathCompare
                 40   27 000022C4 I_NetPathType
                 42   28 000111AF I_NetServerAuthenticate
                 41   29 00002884 I_NetServerAuthenticate2
                 43   2A 00011231 I_NetServerPasswordSet
                 44   2B 00002825 I_NetServerReqChallenge
                 45   2C 000066C4 I_NetServerSetServiceBits
                 46   2D 0000CDC8 I_NetServerSetServiceBitsEx
                 47   2E 00006015 NetAlertRaise
                 48   2F 000060DD NetAlertRaiseEx
                 49   30 00001574 NetApiBufferAllocate
                 50   31 0000121B NetApiBufferFree
                 51   32 000085B9 NetApiBufferReallocate
                 52   33 00008602 NetApiBufferSize
                 53   34 00008634 NetAuditClear
                 54   35 0000865A NetAuditRead
                 55   36 0000869A NetAuditWrite
                 56   37 0000F512 NetBrowserStatisticsGet
                 57   38 00008906 NetConfigGet
                 58   39 0000897E NetConfigGetAll
                 59   3A 00008B76 NetConfigSet
                 60   3B 0000B3F4 NetConnectionEnum
                 61   3C 00010536 NetDfsAdd
                 62   3D 00010A4B NetDfsEnum
                 63   3E 000108D3 NetDfsGetInfo
                 64   3F 00010DCD NetDfsManagerGetConfigInfo
                 65   40 00010B35 NetDfsMove
                 66   41 00010673 NetDfsRemove
                 67   42 00010C81 NetDfsRename
                 68   43 00010781 NetDfsSetInfo
                 69   44 00007533 NetEnumerateTrustedDomains
                 70   45 00008C56 NetErrorLogClear
                 71   46 00008C7C NetErrorLogRead
                 72   47 00008CBC NetErrorLogWrite
                 73   48 0000B529 NetFileClose
                 74   49 0000B60C NetFileEnum
                 75   4A 0000B747 NetFileGetInfo
                 76   4B 00011C60 NetGetAnyDCName
                 77   4C 00008268 NetGetDCName
                 78   4D 0001CBD7 NetGetDisplayInformationIndex
                 79   4E 0001CC6F NetGroupAdd
                 80   4F 0001CE5A NetGroupAddUser
                 81   50 0001CE9A NetGroupDel
                 82   51 0001CEDA NetGroupDelUser
                 83   52 0001CF1A NetGroupEnum
                 84   53 0001D40E NetGroupGetInfo
                 85   54 0001D49C NetGroupGetUsers
                 86   55 0001D769 NetGroupSetInfo
                 87   56 0001D93B NetGroupSetUsers
                 88   57 0001D987 NetLocalGroupAdd
                 89   58 0001DA85 NetLocalGroupAddMember
                 90   59 0001E4C8 NetLocalGroupAddMembers
                 91   5A 0001DA9B NetLocalGroupDel
                 92   5B 0001DAE9 NetLocalGroupDelMember
                 93   5C 0001E4E5 NetLocalGroupDelMembers
                 94   5D 0001DAFF NetLocalGroupEnum
                 95   5E 0001DEB2 NetLocalGroupGetInfo
                 96   5F 0001DEF4 NetLocalGroupGetMembers
                 97   60 0001E3A9 NetLocalGroupSetInfo
                 98   61 0001E4AB NetLocalGroupSetMembers
                 99   62 000065C1 NetMessageBufferSend
                100   63 0000447E NetMessageNameAdd
                101   64 00005757 NetMessageNameDel
                102   65 0001ADE8 NetMessageNameEnum
                103   66 0001AF0F NetMessageNameGetInfo
                104   67 0001C7FE NetQueryDisplayInformation
                105   68 00001F78 NetRemoteComputerSupports
                106   69 0000CCE2 NetRemoteTOD
                107   6A 00011EE5 NetReplExportDirAdd
                108   6B 0001205B NetReplExportDirDel
                109   6C 00012181 NetReplExportDirEnum
                110   6D 000122C6 NetReplExportDirGetInfo
                111   6E 000123C8 NetReplExportDirLock
                112   6F 000124BB NetReplExportDirSetInfo
                113   70 000125C1 NetReplExportDirUnlock
                114   71 000126BA NetReplGetInfo
                115   72 00012B7B NetReplImportDirAdd
                116   73 00012CF9 NetReplImportDirDel
                117   74 00012E2F NetReplImportDirEnum
                118   75 00012F74 NetReplImportDirGetInfo
                119   76 00013076 NetReplImportDirLock
                120   77 00013169 NetReplImportDirUnlock
                121   78 00012869 NetReplSetInfo
                122   79 0001BE6B NetRplAdapterAdd
                123   7A 0001BEE9 NetRplAdapterDel
                124   7B 0001BF60 NetRplAdapterEnum
                125   7C 0001B656 NetRplBootAdd
                126   7D 0001B6D4 NetRplBootDel
                127   7E 0001B74E NetRplBootEnum
                128   7F 0001B4E8 NetRplClose
                129   80 0001B7FD NetRplConfigAdd
                130   81 0001B87B NetRplConfigDel
                131   82 0001B8F2 NetRplConfigEnum
                132   83 0001B55D NetRplGetInfo
                133   84 0001B46D NetRplOpen
                134   85 0001B9A4 NetRplProfileAdd
                135   86 0001BA22 NetRplProfileClone
                136   87 0001BA9F NetRplProfileDel
                137   88 0001BB16 NetRplProfileEnum
                138   89 0001BBC8 NetRplProfileGetInfo
                139   8A 0001BC46 NetRplProfileSetInfo
                140   8B 0001B5D8 NetRplSetInfo
                141   8C 0001C338 NetRplSetSecurity
                142   8D 0001BCC7 NetRplVendorAdd
                143   8E 0001BD45 NetRplVendorDel
                144   8F 0001BDBC NetRplVendorEnum
                145   90 0001C00F NetRplWkstaAdd
                146   91 0001C08D NetRplWkstaClone
                147   92 0001C110 NetRplWkstaDel
                148   93 0001C187 NetRplWkstaEnum
                149   94 0001C239 NetRplWkstaGetInfo
                150   95 0001C2B7 NetRplWkstaSetInfo
                151   96 0001B03B NetScheduleJobAdd
                152   97 0001B114 NetScheduleJobDel
                153   98 0001B1ED NetScheduleJobEnum
                154   99 0001B2F2 NetScheduleJobGetInfo
                155   9A 0000D58E NetServerComputerNameAdd
                156   9B 0000D75D NetServerComputerNameDel
                157   9C 0000C60D NetServerDiskEnum
                158   9D 0000E99A NetServerEnum
                159   9E 0000E9CC NetServerEnumEx
                160   9F 0000C73F NetServerGetInfo
                161   A0 0000C82B NetServerSetInfo
                162   A1 0000CA17 NetServerTransportAdd
                163   A2 0000D49F NetServerTransportAddEx
                164   A3 0000CAF0 NetServerTransportDel
                165   A4 0000CBC9 NetServerTransportEnum
                166   A5 0001A72E NetServiceControl
                167   A6 0001A7DD NetServiceEnum
                168   A7 00007A2E NetServiceGetInfo
                169   A8 0001A864 NetServiceInstall
                170   A9 0000B839 NetSessionDel
                171   AA 0000B922 NetSessionEnum
                172   AB 0000BA5D NetSessionGetInfo
                173   AC 0000BBAC NetShareAdd
                174   AD 0000BDEE NetShareCheck
                175   AE 0000BEFA NetShareDel
                176   AF 0000C029 NetShareDelSticky
                177   B0 00002D97 NetShareEnum
                178   B1 0000C125 NetShareEnumSticky
                179   B2 0000C265 NetShareGetInfo
                180   B3 0000C3BB NetShareSetInfo
                181   B4 00008CC4 NetStatisticsGet
                182   B5 0000267B NetUseAdd
                183   B6 0000E6C2 NetUseDel
                184   B7 000023BE NetUseEnum
                185   B8 00001BD2 NetUseGetInfo
                186   B9 0001E502 NetUserAdd
                187   BA 00020561 NetUserChangePassword
                188   BB 0001E6F2 NetUserDel
                189   BC 0001E8C3 NetUserEnum
                190   BD 0001EE3B NetUserGetGroups
                191   BE 0001EC34 NetUserGetInfo
                192   BF 0001F5B3 NetUserGetLocalGroups
                193   C0 0001FA70 NetUserModalsGet
                194   C1 0001FE47 NetUserModalsSet
                195   C2 0001F0F3 NetUserSetGroups
                196   C3 0001ED4D NetUserSetInfo
                197   C4 000013BD NetWkstaGetInfo
                198   C5 0000E221 NetWkstaSetInfo
                199   C6 0000E507 NetWkstaTransportAdd
                200   C7 0000E5E9 NetWkstaTransportDel
                201   C8 0000E3F6 NetWkstaTransportEnum
                202   C9 00005E4E NetWkstaUserEnum
                203   CA 000012FC NetWkstaUserGetInfo
                204   CB 0000E311 NetWkstaUserSetInfo
                205   CC 00004971 NetapipBufferAllocate
                206   CD 00005396 Netbios
                207   CE 00008D25 NetpAccessCheck
                208   CF 0000126B NetpAccessCheckAndAudit
                209   D0 00004D6B NetpAllocConfigName
                210   D1 00008DB7 NetpAllocStrFromStr
                211   D2 00004408 NetpAllocStrFromWStr
                212   D3 00008E0E NetpAllocTStrFromString
                213   D4 00008E60 NetpAllocWStrFromStr
                214   D5 00008ED8 NetpAllocWStrFromWStr
                215   D6 00008F26 NetpApiStatusToNtStatus
                216   D7 00008F52 NetpAssertFailed
                217   D8 000043E6 NetpCloseConfigData
                218   D9 0000143E NetpCopyStringToBuffer
                219   DA 0000479A NetpCreateSecurityObject
                220   DB 00009368 NetpDbgDisplayServerInfo
                221   DC 00008F55 NetpDbgPrint
                222   DD 000092E1 NetpDeleteSecurityObject
                223   DE 0000164B NetpGetComputerName
                224   DF 00005CF4 NetpGetConfigBool
                225   E0 00004649 NetpGetConfigDword
                226   E1 00006245 NetpGetConfigTStrArray
                227   E2 00004981 NetpGetConfigValue
                228   E3 0000622E NetpGetDomainName
                229   E4 0000D85A NetpGetFileSecurity
                230   E5 000051AA NetpGetPrivilege
                231   E6 00008F8B NetpHexDump
                232   E7 0000936B NetpInitOemString
                233   E8 0000169E NetpIsRemote
                234   E9 0000947E NetpIsUncComputerNameValid
                235   EA 000094BE NetpLocalTimeZoneOffset
                236   EB 00007C7E NetpLogonPutUnicodeString
                237   EC 000061DB NetpNetBiosAddName
                238   ED 00004CF8 NetpNetBiosCall
                239   EE 00009702 NetpNetBiosDelName
                240   EF 000043AB NetpNetBiosGetAdapterNumbers
                241   F0 00005FD4 NetpNetBiosHangup
                242   F1 00005F75 NetpNetBiosReceive
                243   F2 000096BE NetpNetBiosReset
                244   F3 00004ABC NetpNetBiosSend
                245   F4 0000651C NetpNetBiosStatusToApiStatus
                246   F5 00001000 NetpNtStatusToApiStatus
                247   F6 000064FE NetpOpenConfigData
                248   F7 0000903F NetpPackString
                249   F8 00005A17 NetpReleasePrivilege
                250   F9 00009749 NetpSetConfigBool
                251   FA 0000976E NetpSetConfigDword
                252   FB 0000978C NetpSetConfigTStrArray
                253   FC 0000D95C NetpSetFileSecurity
                254   FD 00004BAD NetpSmbCheck
                255   FE 000067F4 NetpStringToNetBiosName
                256   FF 00007788 NetpTStrArrayEntryCount
                257  100 00002141 NetpwNameCanonicalize
                258  101 00002BA0 NetpwNameCompare
                259  102 00001FDB NetpwNameValidate
                260  103 00001B00 NetpwPathCanonicalize
                261  104 00009888 NetpwPathCompare
                262  105 00001D71 NetpwPathType
                263  106 000029F9 NlBindingAddServerToCache
                264  107 0000276F NlBindingRemoveServerFromCache
                265  108 00013446 RxNetAccessAdd
                266  109 00013597 RxNetAccessDel
                267  10A 00013603 RxNetAccessEnum
                268  10B 0001370F RxNetAccessGetInfo
                269  10C 00013830 RxNetAccessGetUserPerms
                270  10D 000138B3 RxNetAccessSetInfo
                271  10E 00013FC1 RxNetServerEnum
                272  10F 00014BA4 RxNetUserPasswordSet
                273  110 00018D27 RxRemoteApi

  Summary

        2000 .data
        C000 .rdata
        2000 .reloc
        1000 .rsrc
       28000 .text

*/
 