/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

#include "war.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Prepere level 100 auth request
void PrpAuthData_100(war_rpclogin_req& Req, LPCSTR Name, LPCSTR Passwd,
										 user_node_type UserType, war_svr_type ServerLogonType)
{
	Req.m_AuthMode = WARAUTH_LEVEL_100;
	Req.m_AuthEncrLevel = WARAC_LEVEL_100;
	Req.m_UserType = UserType;
	Req.m_ServerLogonType = ServerLogonType;
	Req.m_ID = (char *)Name;

	memcpy(Req.m_Data, Passwd, strlen(Passwd) +1);
	ecb_crypt(WeakEncrKey, (char *)&Req.m_Data, WAR_AUTH_LOGIN_DATALEN, DES_ENCRYPT);
}


//  level 100 auth request
BOOL UnprpAuthData_100(war_rpclogin_req& Req)
{
	if (Req.m_AuthEncrLevel == WARAC_LEVEL_100)
	{
		ecb_crypt(WeakEncrKey, 
			(char *)&Req.m_Data, 
			WAR_AUTH_LOGIN_DATALEN, 
			DES_DECRYPT);
		return TRUE;
	}

	return FALSE;
}

// Hack to allow threads to log on, without
// storing a password on disk.
// We simply generate a unique 15 character long password
// each time the server start, and the theads can pass this
// one as a valid password for server accounts (not user logins)
LPCSTR GetSystemThreadPassword()
{
	static char Pwd[16];
	static WarCriticalSection Lock;

	Lock.Lock();

	if (!*Pwd)
	{

		// The password does not exist. Generate a unique one.
		srand(GetTickCount());
		int i, r;
		
		for(i = 0; i < 4; i++)
		{
			do
			{
				r = rand();
			}	while(!isalpha(r & 0xff));
			Pwd[i] = tolower((char)(r & 0xff));
		}
	
		for(i = 4; i < 7; i++)
		{
			do
			{
				r = rand();
			}	while(!isdigit(r & 0xff));
			Pwd[i] = tolower((char)(r & 0xff));
		}
	
		for(i = 7; i < 15; i++)
		{
			do
			{
				r = rand();
			}	while(!isalpha(r & 0xff));
			Pwd[i] = tolower((char)(r & 0xff));
		}
		Pwd[16] = 0;
	}

	Lock.Unlock();
	return Pwd;
}



void WarAuthConvertToGids(war_auth_def_100& ad, int gids[WAR_AUT_DEF_100_GLEN])
{
	gids[0] = ad.m_Mode;
	gids[1] = ad.m_EncrLevel;
	gids[2] = (int)((ad.m_User >> 32) & 0xffffffff);
	gids[3] = (int)(ad.m_User & 0xffffffff);
	gids[4] = (int)((ad.m_Handle >> 32) & 0xffffffff);
	gids[5] = (int)(ad.m_Handle & 0xffffffff);
	gids[6] = 0;
	gids[7] = 0;
}

void WarAuthConvertFromGids(war_auth_def_100& ad, int gids[WAR_AUT_DEF_100_GLEN])
{
	ad.m_Mode = (war_auth_mode)gids[0];
	ad.m_EncrLevel = (war_auth_crypt_mode)gids[1];
#ifdef GNUCPP
	ad.m_User = ((hyper)gids[2] << 32) & 0xffffffff00000000ULL;
#else
	ad.m_User = ((hyper)gids[2] << 32) & 0xffffffff00000000;
#endif
	ad.m_User |=  (gids[3] & 0xffffffff);
#ifdef GNUCPP
	ad.m_Handle = ((hyper)gids[4] << 32) & 0xffffffff00000000ULL;
#else
	ad.m_Handle = ((hyper)gids[4] << 32) & 0xffffffff00000000;
#endif
	ad.m_Handle |= (gids[5] & 0xffffffff);
	ad.m_Reserved = 0;
}

 