/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

/*
 * Misc support functions for the user structures
 */

#include "war.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define __SetNull(a) memset(&a,0,sizeof(a))

void Clear(user_subclass_data& Val)
{
	switch(Val.m_Subclass)
	{
		case UN_NTDOMAIN:
			ASSERT(Val.user_subclass_data_u.m_pNTDomain != NULL);
			Clear(*Val.user_subclass_data_u.m_pNTDomain);
			delete Val.user_subclass_data_u.m_pNTDomain;
			Val.user_subclass_data_u.m_pNTDomain = NULL;
			break;
	}
	Null(Val);
}

void Clear(user_node_type& Val)
{
	Null(Val);
}

void Clear(user_pwd& Val)
{
	if (Val.m_Passwd)
		delete Val.m_Passwd;

	Null(Val);
}

void Clear(user_info& Val)
{
	if (Val.m_RealName)
		delete Val.m_RealName;

	if (Val.m_Email)
		delete Val.m_Email;

	if (Val.m_Http)
		delete Val.m_Http;

	if (Val.m_Ftp)
		delete Val.m_Ftp;

	if (Val.m_ICQ)
		delete Val.m_RealName;

	if (Val.m_ICQ)
		delete Val.m_RealName;

	if (Val.m_IRCnick)
		delete Val.m_IRCnick;

	Null(Val);
}

void Clear(user_expiery& Val)
{
	Null(Val);
}

void Clear(ip_access& Val)
{
	if (Val.m_AllowList)
		delete Val.m_AllowList;

	if (Val.m_DenyList)
		delete Val.m_DenyList;

	Null(Val);
}

void Clear(user_fs_access_list **Val)
{
	user_fs_access_list *pList, *pNext;

	for(pList = *Val; pList; pList = pNext)
	{
		pNext = pList->m_pNext;
		Clear(pList->m_Data);
		delete pList;
	}

	*Val = NULL;
}

void Clear(user_perm_id& Val)
{
	Null(Val);
}

void Clear(war_daemon_info& Val)
{
	if (Val.m_HostName)
		delete Val.m_HostName;
	Null(Val);
}

void Clear(user_greeting& Val)
{
	if (Val.m_Message)
		delete Val.m_Message;
	Null(Val);
}

void Clear(user_stat& Val)
{
	Null(Val);
}

void Clear(ud_restrictions& Val)
{
	Null(Val);
}

void Clear(user_login_perms& Val)
{
	Null(Val);
	Clear(Val.m_LoginAccess);
	Clear(Val.m_LoginTimeMask);
}

void Clear(user_login_time_t& Val)
{
	Val.m_DayMask = 0xffffffff;
	Val.m_SaturdayMask = 0xffffffff;
	Val.m_SundayMask = 0xffffffff;
	Val.m_Mode = ULP_DEFAULT;
}

void Clear(user_login_access& Val)
{
	Val = ULA_DEFAULT;
}

void Clear(fs_dup& Val)
{
	Null(Val);
}

void Clear(user_fs_access& Val)
{
	if (Val.m_Path)
		delete Val.m_Path;

	if (Val.m_Alias)
		delete Val.m_Alias;

	Null(Val);
}

void Clear(ip_access_list **Val)
{
	ip_access_list *pList, *pNext;

	for(pList = *Val; pList; pList = pNext)
	{
		pNext = pList->m_pNext;
		Clear(pList->m_Data);
		delete pList;
	}

	*Val = NULL;	
}

void Clear(user_priv_type& Val)
{
	Val = USERPT_INHERIT;
}

void Clear(war_user_data& Val)
{
	Clear(Val.m_Subclass);
	Clear(Val.m_Type);
	Clear(Val.m_Pwd);
	Clear(Val.m_Info);
	Clear(Val.m_Expiery);
	Clear(Val.m_FTP);
	Clear(Val.m_IPAccess);
	Clear(&Val.m_FSAccessList);
	Clear(Val.m_Perm);
	if (Val.m_pDaemon)
	{
		Clear(*Val.m_pDaemon);
		delete Val.m_pDaemon;
		Val.m_pDaemon = NULL;
	}
	Clear(Val.m_Greeting);
	Clear(Val.m_UserType);
	Clear(Val.m_FTPAdminAccess);
	Clear(Val.m_UserDBAdminAccess);
	Clear(Val.m_LogAdminAccess);
	Clear(Val.m_VfSysAdminAccess);
}

void Clear(war_ftp_user_data& Val)
{
	Clear(Val.m_Stat);
	Clear(Val.m_UD);
	Clear(Val.m_BannedFiles);
	Clear(Val.m_LoginPerms);
	Clear(Val.m_DupMode);
}

void Clear(war_nt_domain& Val)
{
	if (Val.m_Domain)
		delete Val.m_Domain;
	if (Val.m_LinkToNTGroup)
		delete Val.m_LinkToNTGroup;

	__SetNull(Val);
}

void Clear(user_fsys_paths& Val)
{
	if (Val.m_Root)
		delete Val.m_Root;
	if (Val.m_Home)
		delete Val.m_Home;
	Null(Val);
}

void Null(user_subclass_data& Val)
{
	__SetNull(Val);
}

void Null(user_node_type& Val)
{
	__SetNull(Val);
}

void Null(user_pwd& Val)
{
	__SetNull(Val);
}

void Null(user_info& Val)
{
	__SetNull(Val);
}

void Null(user_expiery& Val)
{
	__SetNull(Val);
}

void Null(ip_access& Val)
{
	__SetNull(Val);
}

void Null(user_fs_access_list& Val)
{
	__SetNull(Val);
}

void Null(user_perm_id& Val)
{
	__SetNull(Val);
}

void Null(war_daemon_info& Val)
{
	__SetNull(Val);
}

void Null(user_greeting& Val)
{
	__SetNull(Val);
}

void Null(user_stat& Val)
{
	__SetNull(Val);
}

void Null(ud_restrictions& Val)
{
	__SetNull(Val);
}


void Null(user_login_perms& Val)
{
	__SetNull(Val);
}

void Null(fs_dup& Val)
{
	__SetNull(Val);
}

void Null(user_fs_access& Val)
{
	__SetNull(Val);
}

void Null(war_user_data& Val)
{
	__SetNull(Val);
}

void Null(user_priv_type& Val)
{
	Val = USERPT_INHERIT;
}

void Null(user_login_access& Val)
{
	__SetNull(Val);
}

void Null(user_login_time_t& Val)
{
	Clear(Val);
}

void Null(war_nt_domain& Val)
{
	__SetNull(Val);
}

void Null(user_fsys_paths& Val)
{
	__SetNull(Val);
}
 