/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
/*
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 */

#include "war.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void pmap_prog_2(struct svc_req *rqstp, register PSVCXPRT transp);

void * 
pmapproc_null_2_svc(void *argp, struct svc_req *rqstp)
{

	static char* result;

	return((void*) &result);
}

bool_t * 
pmapproc_set_2_svc(mapping *argp, struct svc_req *rqstp)
{

	static bool_t  result;
 
	result = pPortMapper->Register(*argp, rqstp->rq_xprt);

	return(&result);
}

bool_t * 
pmapproc_unset_2_svc(mapping *argp, struct svc_req *rqstp)
{

	static bool_t  result;

	result = pPortMapper->Unregister(*argp, rqstp->rq_xprt);
	
	return(&result);
}

u_int * 
pmapproc_getport_2_svc(mapping *argp, struct svc_req *rqstp)
{

	static u_int  result;

	pmap_pmaplist *pCurr = pPortMapper->Find(*argp);
	if (pCurr)
		result = pCurr->map.port;
	else
		result = 0;

	return(&result);
}

pmap_pmaplist * 
pmapproc_dump_2_svc(void *argp, struct svc_req *rqstp)
{
	return pPortMapper->m_pRootMap;
}

call_result * 
pmapproc_callit_2_svc(call_args *argp, struct svc_req *rqstp)
{

	/*
	static call_result  result;


	return(&result);
	*/

	return NULL; // Unsupported for now...
}


WarPortmap::WarPortmap()
{
	m_pRootMap = NULL;
	m_pUDP = NULL;
	m_Errno = PMAP_NO_ERROR;

	ASSERT(pPortMapper == NULL);
	pPortMapper = this;
	
	mapping Map;
	Map.prog = PMAP_PROG;
	Map.vers = PMAP_VERS;
	Map.prot = IPPROTO_UDP;
	Map.port = PMAP_PORT; 

	Register(Map); // Register ourself
}

WarPortmap::~WarPortmap()
{
	pmap_pmaplist *pCurr, *pNext = NULL;

	for(pCurr = m_pRootMap; pCurr; pCurr = pNext)
	{
		pNext = pCurr->next;
		delete pCurr;
	}

	if (m_pUDP)
		delete m_pUDP;

	pPortMapper = NULL;

}

BOOL WarPortmap::Register(mapping& Map, WarSocket *pSock)
{
	BOOL result = DoRegister(Map);

	Log.LogMsg(result ? LOGF_INFO : LOGF_WARNINGS, 
		0, pSock, 0, (int)pPortMapper->m_Errno, 
		"WarPortmap::Register()", "%s prog=0x%08x (%s) vers=%u prot=%u port=%u", 
		result ? "Service registered" : "Service failed to register",
		Map.prog,
		WarPortmap::GetProgName(Map.prog),
		Map.vers,
		Map.prot,
		ntohs(Map.port));

	return result;
}
	
BOOL WarPortmap::DoRegister(mapping& Map)
{
	m_Errno = PMAP_NO_ERROR;

	if (Find(Map))
	{
		m_Errno = PMAP_EXIST;
		return FALSE;
	}

	// Link first
	pmap_pmaplist *pNew = new pmap_pmaplist;
	pNew->next = m_pRootMap;
	pNew->map = Map;
	m_pRootMap = pNew;

	return TRUE;
}

pmap_pmaplist *WarPortmap::Find(mapping& Map)
{
	pmap_pmaplist *pCurr;

	for(pCurr = m_pRootMap; pCurr; pCurr = pCurr->next)
	{
		if ((pCurr->map.prog == Map.prog)
			&& (pCurr->map.vers == Map.vers)
			&& (pCurr->map.prot == Map.prot))
		{	
			return pCurr;
		}
	}

	return NULL;
}

BOOL WarPortmap::Unregister(mapping& Map, WarSocket *pSock)
{

	BOOL result = DoUnregister(Map);
	
	Log.LogMsg(result ? LOGF_INFO : LOGF_DEBUG, 
		0, pSock, 0, (int)pPortMapper->m_Errno, 
		"WarPortmap::Unregister()", "%s prog=0x%08x (%s) vers=%u prot=%u port=%u", 
		result ? "Service unregistered" : "Service failed to unregister",
		Map.prog,
		WarPortmap::GetProgName(Map.prog),
		Map.vers,
		Map.prot,
		ntohs(Map.port));

	return result;
}

BOOL WarPortmap::DoUnregister(mapping& Map)
{
	m_Errno = PMAP_NO_ERROR;
	BOOL Result = FALSE;

	pmap_pmaplist *pCurr, *pPrev = NULL, *pNext = NULL;

	for(pCurr = m_pRootMap; pCurr; pCurr = pNext)
	{
		pNext = pCurr->next;

		if ((pCurr->map.prog == Map.prog)
			&& (pCurr->map.vers == Map.vers)
			&& ((pCurr->map.prot == Map.prot) || !Map.prot)) // Protocol 0 = unmap all
		{	
			if (pPrev)
			{
				ASSERT(m_pRootMap != pCurr);
				pPrev->next = pCurr->next;
			}
			else
			{
				ASSERT(m_pRootMap == pCurr);
				m_pRootMap = pCurr->next;
			}
			delete pCurr;
			Result = TRUE;
			continue;
		}

		pPrev = pCurr;
	}

	m_Errno = Result ? PMAP_NO_ERROR : PMAP_NOT_FOUND;
	return Result;
}

BOOL WarPortmap::Create()
{
	ASSERT(m_pUDP == NULL);
	m_pUDP = new WarSvrUdpSocket;
	m_Errno = PMAP_NO_ERROR;

	if (!m_pUDP->Create("Pmap", PMAP_PORT))
	{
		Log.Sysmsg("Portmapper not started. Relaying on default portmapper.");
		delete m_pUDP;
		m_pUDP = NULL;
		m_Errno = PMAP_FAILED_TO_START;
		return FALSE;
	}

	if (!m_pUDP->svc_register(PMAP_PROG, PMAP_VERS, pmap_prog_2, 0)) 
	{
		Log.Sysmsg("Portmapper failed to register!.");
		m_Errno = PMAP_FAILED_TO_REGISTER;
		return FALSE;
	}

	Log.Sysmsg("Portmapper service is started.");

	return TRUE;
}

LPCSTR WarPortmap::GetProgName(DWORD ProgNo)
{
	LPCSTR p = "Unknown";
	switch(ProgNo)
	{
		case 352250: p = "waruser"; break;
		case 352251: p = "warlogd"; break;
		case 352252: p = "warsvrmgr"; break;
		case 352253: p = "warvfsysd"; break;
		case 352254: p = "warftpd"; break;
		case 352255: p = "warnfsd"; break;
		case 100000: p = "portmap"; break;
		case 100003: p = "nfsd"; break;
		case 100005: p = "mountd"; break;
	}

	return p;
}
 